       SUBROUTINE CMSRTB(MSTP,T,SINTL,SINTR,TAUDL,TAUDR,HDEN,H2DEN,
     >                   COSRAY,CD,COLR,NR)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
       PARAMETER (PNORM=0.636619772d0, TINY=1.0D-33,N1=50,N2=50,
     >                    N3=100,N4=30,N5=500,NSP=30)
       DIMENSION CD(NR),COLR(NR)
       COMMON/CNUM/  KH,KH2,KPHOT,KCR,KCHEM
       COMMON/NCHEM/ NRH(N1,3),NRH2(N2,3),NPHOT(N3,3),NCR(N4,3),
     >               NCHM(N5,4)
       COMMON/EXOTHM/ NH2EX(N2)
       COMMON/CHEMR/RRH(N1,3),RRH2(N2,3),RPHOT(N3,3),RCR(N4),RCHM(N5,3)
       COMMON /CHMDEN/ DSPEC(NSP),DSPECP(NSP),DSPSCL(NSP),CSPEC(NSP)
       COMMON /CABS/ PTOTC,TAUCI
       COMMON /COINFO/ X1ACO(8),X2AH2(6),YACO(8,6),Y2ACO(8,6),H2CLMN
       COMMON /COIN13/ YCO13(8,6),Y2CO13(8,6)
       DIMENSION RFM(NSP,500),NFM(NSP),MFM(NSP,500)
       DIMENSION RDS(NSP,500),NDS(NSP),MDS(NSP,500)
       DIMENSION RTEMP(500),MTEMP(500),WKSP(500),IWKSP(500)
       CHARACTER*5 SS(0:NSP)
       DATA SS/'/','HE','HE+','H+','H2+','H3+','C','CH','CO','C+',
     >           'CH+','CH2+','CO+','HCO+','*C','*CH','*CO','*C+',
     >           '*CH+','*CH2+','*CO+','*HCO+','O','OH','H2O','O2',
     >           'O+','OH+','H2O+','H3O+','ELEC' /
C

CB	OPEN(80,file='chemie.dat',STATUS='OLD')
       WRITE(80,3) MSTP
3      FORMAT('   MSTP = ',I2)
       NF=0
       T3=T/300.d0
C       COSRAY=5.0E-17
       FRAD1 = SINTL*expc2(-TAUDL)
       FRAD2 = SINTR*expc2(-TAUDR)
       FRAD  = SINTL*expc2(-TAUDL)+SINTR*expc2(-TAUDR)
C
       DO 7, I=1,NSP
	  DO 6, K=1,100
	     RFM(I,K)=0.D0
             RDS(I,K)=0.D0
	     MFM(I,K)=0
	     MDS(I,K)=0
6         CONTINUE
	  NFM(I)=0
	  NDS(I)=0
7      CONTINUE
C
C      REACTION TYPE  A + H --> B + C + (H,H2)
       DO 50, I=1,KH
          NA=NRH(I,1)
          NB=NRH(I,2)
          NC=NRH(I,3)
          R=RRH(I,3)*EXPC2(-RRH(I,2)/T)*T3**RRH(I,1)
          R=R*HDEN*DSPEC(NA)
	  NFM(NB)=NFM(NB)+1
	  RFM(NB,NFM(NB))=R
	  MFM(NB,NFM(NB))=I
          IF(NC .NE. 0) THEN
	     NFM(NC)=NFM(NC)+1
	     RFM(NC,NFM(NC))=R
	     MFM(NC,NFM(NC))=I
          END IF
	  NDS(NA)=NDS(NA)+1
	  RDS(NA,NDS(NA))=R
	  MDS(NA,NDS(NA))=I
50     CONTINUE
C
C
C      REACTION TYPE  A + H2 --> B + C + (H,H2)
       DO 70, I=1,KH2
	  NA=NRH2(I,1)
	  NB=NRH2(I,2)
	  NC=NRH2(I,3)
          R=RRH2(I,3)*EXPC2(-RRH2(I,2)/T)*T3**RRH2(I,1)
          R=R*H2DEN*DSPEC(NA)
	  NFM(NB)=NFM(NB)+1
	  RFM(NB,NFM(NB))=R
	  MFM(NB,NFM(NB))=I+KH
          IF(NC .NE. 0) THEN
	     NFM(NC)=NFM(NC)+1
	     RFM(NC,NFM(NC))=R
	     MFM(NC,NFM(NC))=I+KH
          END IF
	  NDS(NA)=NDS(NA)+1
	  RDS(NA,NDS(NA))=R
	  MDS(NA,NDS(NA))=I+KH
70     CONTINUE
C
       KH2T=KH2
C
C      REACTION TYPE  A + HNU --> B + C
       DO 80, I=1,KPHOT
          NA=NPHOT(I,1)
          NB=NPHOT(I,2)
          NC=NPHOT(I,3)
          R=FRAD*RPHOT(I,1)*DSPEC(NA)
C          WRITE(77,111) FRAD,RPHOT(I,1),RPHOT(I,2),DSPEC(NA),R,SS(NA)
C111       FORMAT(5(2X,1PE10.3),2X,A4)
	  NFM(NB)=NFM(NB)+1
	  RFM(NB,NFM(NB))=R
	  MFM(NB,NFM(NB))=I+KH+KH2T
          IF(NC .NE. 0) THEN
	  NFM(NC)=NFM(NC)+1
	  RFM(NC,NFM(NC))=R
	  MFM(NC,NFM(NC))=I+KH+KH2T
          END IF
	  NDS(NA)=NDS(NA)+1
	  RDS(NA,NDS(NA))=R
	  MDS(NA,NDS(NA))=I+KH+KH2T
80     CONTINUE
C
C      REACTION TYPE A + CRPHOT --> B + C
       DO 85, I=1,KCR
          NA=NCR(I,1)
          NB=NCR(I,2)
          NC=NCR(I,3)
          R=COSRAY*RCR(I)*DSPEC(NA)
	  NFM(NB)=NFM(NB)+1
	  RFM(NB,NFM(NB))=R
	  MFM(NB,NFM(NB))=I+KH+KH2T+KPHOT
          IF(NC .NE. 0) THEN
	     NFM(NC)=NFM(NC)+1
	     RFM(NC,NFM(NC))=R
	     MFM(NC,NFM(NC))=I+KH+KH2T+KPHOT
          END IF
          NDS(NA)=NDS(NA)+1
          RDS(NA,NDS(NA))=R
          MDS(NA,NDS(NA))=I+KH+KH2T+KPHOT
85     CONTINUE
C
C
C      REACTION TYPE  A + B --> C + D
       DO 90, I=1,KCHEM
          NA=NCHM(I,1)
          NB=NCHM(I,2)
          NC=NCHM(I,3)
          ND=NCHM(I,4)
          R=RCHM(I,3)*EXPC2(-RCHM(I,2)/T)*T3**RCHM(I,1)
          R=R*DSPEC(NA)*DSPEC(NB)
          IF(NC .NE. 0) THEN
	     NFM(NC)=NFM(NC)+1
	     RFM(NC,NFM(NC))=R
	     MFM(NC,NFM(NC))=I+KH+KH2T+KPHOT+KCR
          END IF
          IF(ND .NE. 0) THEN
	     NFM(ND)=NFM(ND)+1
	     RFM(ND,NFM(ND))=R
	     MFM(ND,NFM(ND))=I+KH+KH2T+KPHOT+KCR
          END IF
          IF(NA .NE. 0) THEN
	     NDS(NA)=NDS(NA)+1
	     RDS(NA,NDS(NA))=R
	     MDS(NA,NDS(NA))=I+KH+KH2T+KPHOT+KCR
          END IF
          IF(NB .NE. 0) THEN
	     NDS(NB)=NDS(NB)+1
	     RDS(NB,NDS(NB))=R
	     MDS(NB,NDS(NB))=I+KH+KH2T+KPHOT+KCR
          END IF
90     CONTINUE
C
C      THE SPECIAL CASE OF CARBON IONIZATION.
       A1=1.6D-10*FRAD1
       A2=1.6D-10*FRAD2
       RCI1=A1*expc2(-1.6D-17*CD(19))
       RCI2=A2*expc2(-1.6D-17*COLR(19))
       RCI=RCI1+RCI2
       R=RCI*DSPEC(6)
       NFM(9)=NFM(9)+1
       RFM(9,NFM(9))=R
       MFM(9,NFM(9))=KH+KH2T+KPHOT+KCR+KCHEM+1
       NFM(30)=NFM(30)+1
       RFM(30,NFM(30))=R
       MFM(30,NFM(30))=KH+KH2T+KPHOT+KCR+KCHEM+1
       NDS(6)=NDS(6)+1
       RDS(6,NDS(6))=R
       MDS(6,NDS(6))=KH+KH2T+KPHOT+KCR+KCHEM+1
C
C****13C
       R=RCI*DSPEC(14)
       NFM(17)=NFM(17)+1
       RFM(17,NFM(17))=R
       MFM(17,NFM(17))=KH+KH2T+KPHOT+KCR+KCHEM+2
       NFM(30)=NFM(30)+1
       RFM(30,NFM(30))=R
       MFM(30,NFM(30))=KH+KH2T+KPHOT+KCR+KCHEM+2
       NDS(14)=NDS(14)+1
       RDS(14,NDS(14))=R
       MDS(14,NDS(14))=KH+KH2T+KPHOT+KCR+KCHEM+2
C
C      THE SPECIAL CASE OF CO PHOTODISSOCIATION
C      radiation from the left side
       DCOL=1.0D0
       IF((CD(41).GT. 0.D0) .AND. (CD(1).GT. 0.D0)) THEN
          COLOG=LOG10(CD(41))
          H2LOG=LOG10(CD(1))
          M1=8
          M2=6
          CALL SPLIN2(X1ACO,X2AH2,YACO,Y2ACO,M1,M2,COLOG,H2LOG,DCO)
          DCOL=MIN(1.0D0,DCO)
CB        DCOL = 1.0D0
       END IF
C      radiation from the right side
       IF((COLR(41).GT. 0.D0) .AND. (COLR(1).GT. 0.D0)) THEN
          COLOG=LOG10(COLR(41))
          H2LOG=LOG10(COLR(1))
          M1=8
          M2=6
          CALL SPLIN2(X1ACO,X2AH2,YACO,Y2ACO,M1,M2,COLOG,H2LOG,DCO)
          DCOR=MIN(1.0D0,DCO)
CB          DCOR=1.0D0
       END IF
       DCOL=2.039D-10*DCOL
       DCOR=2.039D-10*DCOR
       DCOL=FRAD1*expc2(-1.6D-17*CD(19))*DCOL
       DCOR=FRAD2*expc2(-1.6D-17*COLR(19))*DCOR
       DCO=DCOR+DCOL
       R=DCO*DSPEC(8)
       NFM(6)=NFM(6)+1
       RFM(6,NFM(6))=R
       MFM(6,NFM(6))=KH+KH2T+KPHOT+KCR+KCHEM+3
       NFM(22)=NFM(22)+1
       RFM(22,NFM(22))=R
       MFM(22,NFM(22))=KH+KH2T+KPHOT+KCR+KCHEM+3
       NDS(8)=NDS(8)+1
       RDS(8,NDS(8))=R
       MDS(8,NDS(8))=KH+KH2T+KPHOT+KCR+KCHEM+3
C
C***13C
C      radiation from the left side
       DCOL=1.0D0
       IF((CD(59).GT. 0.D0) .AND. (CD(1).GT. 0.D0)) THEN
          COLOG=LOG10(CD(59))
          H2LOG=LOG10(CD(1))
          M1=8
          M2=6
          CALL SPLIN2(X1ACO,X2AH2,YCO13,Y2CO13,M1,M2,COLOG,H2LOG,DCO)
          DCOL=MIN(1.0D0,DCO)
CB        DCOL = 1.0D0
       END IF
C      radiation from the right side
       IF((COLR(59).GT. 0.D0) .AND. (COLR(1).GT. 0.D0)) THEN
          COLOG=LOG10(COLR(59))
          H2LOG=LOG10(COLR(1))
          M1=8
          M2=6
          CALL SPLIN2(X1ACO,X2AH2,YCO13,Y2CO13,M1,M2,COLOG,H2LOG,DCO)
          DCOR=MIN(1.0D0,DCO)
CB          DCOR=1.0D0
       END IF
       DCOL=2.039D-10*DCOL
       DCOR=2.039D-10*DCOR
       DCOL=FRAD1*expc2(-1.6D-17*CD(19))*DCOL
       DCOR=FRAD2*expc2(-1.6D-17*COLR(19))*DCOR
       DCO=DCOR+DCOL
       R=DCO*DSPEC(16)
       NFM(14)=NFM(14)+1
       RFM(14,NFM(14))=R
       MFM(14,NFM(14))=KH+KH2T+KPHOT+KCR+KCHEM+4
       NFM(22)=NFM(22)+1
       RFM(22,NFM(22))=R
       MFM(22,NFM(22))=KH+KH2T+KPHOT+KCR+KCHEM+4
       NDS(16)=NDS(16)+1
       RDS(16,NDS(16))=R
       MDS(16,NDS(16))=KH+KH2T+KPHOT+KCR+KCHEM+4
C
C
C      LOAD COSMIC RAY FORMATION TERMS FOR H+, H2+, HE+.
       R=0.022d0*COSRAY*H2DEN
       NFM(3)=NFM(3)+1
       RFM(3,NFM(3))=R
       MFM(3,NFM(3))=KH+KH2T+KPHOT+KCR+KCHEM+5
       NFM(30)=NFM(30)+1
       RFM(30,NFM(30))=R
       MFM(30,NFM(30))=KH+KH2T+KPHOT+KCR+KCHEM+5
       R=0.93d0*COSRAY*H2DEN
       NFM(4)=NFM(4)+1
       RFM(4,NFM(4))=R
       MFM(4,NFM(4))=KH+KH2T+KPHOT+KCR+KCHEM+6
       NFM(30)=NFM(30)+1
       RFM(30,NFM(30))=R
       MFM(30,NFM(30))=KH+KH2T+KPHOT+KCR+KCHEM+6
       R=0.46d0*COSRAY*HDEN
       NFM(3)=NFM(3)+1
       RFM(3,NFM(3))=R
       MFM(3,NFM(3))=KH+KH2T+KPHOT+KCR+KCHEM+7
       NFM(30)=NFM(30)+1
       RFM(30,NFM(30))=R
       MFM(30,NFM(30))=KH+KH2T+KPHOT+KCR+KCHEM+7
       R=0.5d0*COSRAY*DSPEC(1)
       NFM(2)=NFM(2)+1
       RFM(2,NFM(2))=R
       MFM(2,NFM(2))=KH+KH2T+KPHOT+KCR+KCHEM+8
       NFM(30)=NFM(30)+1
       RFM(30,NFM(30))=R
       MFM(30,NFM(30))=KH+KH2T+KPHOT+KCR+KCHEM+8
       NDS(1)=NDS(1)+1
       RDS(1,NDS(1))=R
       MDS(1,NDS(1))=KH+KH2T+KPHOT+KCR+KCHEM+8
C
C      Do the sortingr.
       DO 95, I=1,NSP
	  NFTOT=NFM(I)
	  IF(NFTOT .GT. 1) THEN
	  DO 81, K=1,NFTOT
	     RTEMP(K)=RFM(I,K)
	     MTEMP(K)=MFM(I,K)
81        CONTINUE
	  CALL SORTER(NFTOT,RTEMP,MTEMP,WKSP,IWKSP)
	  DO 82, K=1,NFTOT
	     RFM(I,K)=RTEMP(K)
	     MFM(I,K)=MTEMP(K)
82        CONTINUE
	  END IF
	  NDTOT=NDS(I)
	  IF(NDTOT .GT. 1) THEN
	  DO 84, K=1,NDTOT
	     RTEMP(K)=RDS(I,K)
	     MTEMP(K)=MDS(I,K)
84        CONTINUE
	  CALL SORTER(NDTOT,RTEMP,MTEMP,WKSP,IWKSP)
	  DO 86, K=1,NDTOT
	     RDS(I,K)=RTEMP(K)
	     MDS(I,K)=MTEMP(K)
86        CONTINUE
	  END IF
95     CONTINUE
C
       NRTOT=KH+KH2T+KPHOT+KCR+KCHEM
       DO 200, N=1,NSP
	  WRITE(80,96) SS(N),DSPEC(N),T
96        FORMAT(5X,A5,' = ',1PE10.3,5X,'T = ',1PE10.3)
	  WRITE(80,97) NFM(N)
97        FORMAT(10X,I2,' FORMATION REACTIONS')
	  SF=0.D0
	  DO 120, K=1,NFM(N)
	     MX=MFM(N,K)
             IF(MX .LE. KH) THEN
                I=MX
                NA=NRH(I,1)
                NB=NRH(I,2)
                NC=NRH(I,3)
		SF=SF+RFM(N,K)
                WRITE(80,100) SS(NA),SS(NB),SS(NC),RFM(N,K)
100             FORMAT(12X,A5,'  H     --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2) THEN
                I=MX-KH
                NA=NRH2(I,1)
                NB=NRH2(I,2)
                NC=NRH2(I,3)
		SF=SF+RFM(N,K)
                WRITE(80,102) SS(NA),SS(NB),SS(NC),RFM(N,K)
102             FORMAT(12X,A5,'  H2    --> ',A5,2X,A5,6X,1PE10.3)
	     ELSE IF(MX .LE. KH+KH2T) THEN
		I=MX-KH-KH2
		NA=NRH2(I,1)
		NB=NRH2(I,2)
		NC=NRH2(I,3)
		SF=SF+RFM(N,K)
		WRITE(80,103) SS(NA),SS(NB),SS(NC),RFM(N,K)
103	        FORMAT(12X,A5,'  H2*   --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2T+KPHOT) THEN
                I=MX-KH-KH2T
                NA=NPHOT(I,1)
                NB=NPHOT(I,2)
                NC=NPHOT(I,3)
		SF=SF+RFM(N,K)
                WRITE(80,104) SS(NA),SS(NB),SS(NC),RFM(N,K)
104             FORMAT(12X,A5,'  NU    --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2T+KPHOT+KCR) THEN
                I=MX-KH-KH2T-KPHOT
                NA=NCR(I,1)
                NB=NCR(I,2)
                NC=NCR(I,3)
		SF=SF+RFM(N,K)
                WRITE(80,106) SS(NA),SS(NB),SS(NC),RFM(N,K)
106             FORMAT(12X,A5,'  CRP   --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2T+KPHOT+KCR+KCHEM) THEN
                I=MX-KH-KH2T-KPHOT-KCR
                NA=NCHM(I,1)
                NB=NCHM(I,2)
                NC=NCHM(I,3)
                ND=NCHM(I,4)
		SF=SF+RFM(N,K)
                WRITE(80,107) SS(NA),SS(NB),SS(NC),SS(ND),RFM(N,K)
107             FORMAT(12X,A5,2X,A5,' --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+1) THEN
		SF=SF+RFM(N,K)
                WRITE(80,108) RFM(N,K)
108             FORMAT(12X,'C      NU    --> C+     ELEC ',6X,1PE10.3)
	write(32,*) rfm(n,k)
             ELSE IF(MX .EQ. NRTOT+2) THEN
                SF=SF+RFM(N,K)
                WRITE(80,109) RFM(N,K)
109             FORMAT(12X,'*C     NU    --> *C+    ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+3) THEN
		SF=SF+RFM(N,K)
                WRITE(80,110) RFM(N,K)
110             FORMAT(12X,'CO     NU    --> C      O    ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+4) THEN
                SF=SF+RFM(N,K)
                WRITE(80,111) RFM(N,K)
111             FORMAT(12X,'*CO    NU    --> *C     O    ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+5) THEN
		SF=SF+RFM(N,K)
                WRITE(80,112) RFM(N,K)
112             FORMAT(12X,'H2     CR    --> H+     ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+6) THEN
		SF=SF+RFM(N,K)
                WRITE(80,114) RFM(N,K)
114             FORMAT(12X,'H2     CR    --> H2+    ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+7) THEN
		SF=SF+RFM(N,K)
                WRITE(80,116) RFM(N,K)
116             FORMAT(12X,'H      CR    --> H+     ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+8) THEN
		SF=SF+RFM(N,K)
                WRITE(80,118) RFM(N,K)
118             FORMAT(12X,'HE     CR    --> HE+    ELEC ',6X,1PE10.3)
             ELSE 
                WRITE(6,*) 'N GREATER THAN NRTOT+8, ERROR'
                STOP
             END IF
120       CONTINUE
	  WRITE(80,121) SF
121       FORMAT(15X,'TOTAL FORMATION RATE = ',9X,1PE10.3)
	  WRITE(80,122) NDS(N)
122       FORMAT(10X,I2,' DESTRUCTION REACTIONS')
	  SD=0.D0
	  DO 160, K=1,NDS(N)
	     MX=MDS(N,K)
	     IF(MX .LE. KH) THEN
                I=MX
                NA=NRH(I,1)
                NB=NRH(I,2)
                NC=NRH(I,3)
		SD=SD+RDS(N,K)
                WRITE(80,130) SS(NA),SS(NB),SS(NC),RDS(N,K)
130             FORMAT(12X,A5,'  H     --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2) THEN
                I=MX-KH
                NA=NRH2(I,1)
                NB=NRH2(I,2)
                NC=NRH2(I,3)
		SD=SD+RDS(N,K)
                WRITE(80,132) SS(NA),SS(NB),SS(NC),RDS(N,K)
132             FORMAT(12X,A5,'  H2    --> ',A5,2X,A5,6X,1PE10.3)
	     ELSE IF(MX .LE. KH+KH2T) THEN
		I=MX-KH-KH2
		NA=NRH2(I,1)
		NB=NRH2(I,2)
		NC=NRH2(I,3)
		SD=SD+RDS(N,K)
		WRITE(80,133) SS(NA),SS(NB),SS(NC),RDS(N,K)
133		FORMAT(12X,A5,'  H2*   --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2T+KPHOT) THEN
                I=MX-KH-KH2T
                NA=NPHOT(I,1)
                NB=NPHOT(I,2)
                NC=NPHOT(I,3)
		SD=SD+RDS(N,K)
                WRITE(80,134) SS(NA),SS(NB),SS(NC),RDS(N,K)
134             FORMAT(12X,A5,'  NU    --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2T+KPHOT+KCR) THEN
                I=MX-KH-KH2T-KPHOT
                NA=NCR(I,1)
                NB=NCR(I,2)
                NC=NCR(I,3)
		SD=SD+RDS(N,K)
                WRITE(80,136) SS(NA),SS(NB),SS(NC),RDS(N,K)
136             FORMAT(12X,A5,'  CRP   --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .LE. KH+KH2T+KPHOT+KCR+KCHEM) THEN
                I=MX-KH-KH2T-KPHOT-KCR
                NA=NCHM(I,1)
                NB=NCHM(I,2)
                NC=NCHM(I,3)
                ND=NCHM(I,4)
		SD=SD+RDS(N,K)
                WRITE(80,137) SS(NA),SS(NB),SS(NC),SS(ND),RDS(N,K)
137             FORMAT(12X,A5,2X,A5,' --> ',A5,2X,A5,6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+1) THEN
		SD=SD+RDS(N,K)
                WRITE(80,138) RDS(N,K)
138             FORMAT(12X,'C      NU    --> C+     ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+2) THEN
                SD=SD+RDS(N,K)
                WRITE(80,139) RDS(N,K)
139             FORMAT(12X,'*C     NU    --> *C+    ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+3) THEN
		SD=SD+RDS(N,K)
                WRITE(80,140) RDS(N,K)
140             FORMAT(12X,'CO     NU    --> C      O    ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+4) THEN
                SD=SD+RDS(N,K)
                WRITE(80,141) RDS(N,K)
141             FORMAT(12X,'*CO     NU    --> *C      O    ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+5) THEN
		SD=SD+RDS(N,K)
                WRITE(80,142) RDS(N,K)
142             FORMAT(12X,'H2     CR    --> H+     ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+6) THEN
		SD=SD+RDS(N,K)
                WRITE(80,144) RDS(N,K)
144             FORMAT(12X,'H2     CR    --> H2+    ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+7) THEN
		SD=SD+RDS(N,K)
                WRITE(80,146) RDS(N,K)
146             FORMAT(12X,'H      CR    --> H+     ELEC ',6X,1PE10.3)
             ELSE IF(MX .EQ. NRTOT+8) THEN
		SD=SD+RDS(N,K)
                WRITE(80,148) RDS(N,K)
148             FORMAT(12X,'HE     CR    --> HE+    ELEC ',6X,1PE10.3)
	     ELSE
                WRITE(6,*) 'N GREATER THAN NRTOT+8, ERROR'
                STOP
             END IF
160       CONTINUE
	  WRITE(80,162) SD
162       FORMAT(15X,'TOTAL DESTRUCTION RATE = ',7X,1PE10.3)
200    CONTINUE
C
C
C
C
       RETURN
       END
C
C
       SUBROUTINE SORTER(N,RTEMP,MTEMP,WKSP,IWKSP)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DIMENSION RTEMP(N),MTEMP(N),WKSP(N),IWKSP(N)
       DIMENSION MWKSP(500)
       CALL INDEXX(N,RTEMP,IWKSP)
       DO 11, J=1,N
          WKSP(J)=RTEMP(J)
11     CONTINUE
       DO 12, J=1,N
          RTEMP(J)=WKSP(IWKSP(J))
12     CONTINUE
       DO 15, J=1,N
          MWKSP(J)=MTEMP(J)
15     CONTINUE
       DO 16, J=1,N
          MTEMP(J)=MWKSP(IWKSP(J))
16     CONTINUE
       RETURN
       END
C
C
       SUBROUTINE INDEXX(N,ARRIN,INDX)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DIMENSION ARRIN(N),INDX(N)
       DO 11, J=1,N
          INDX(J)=J
11     CONTINUE
       L=N/2+1
       IR=N
10     CONTINUE
          IF(L.GT.1)THEN
             L=L-1
             INDXT=INDX(L)
             Q=ARRIN(INDXT)
          ELSE
             INDXT=INDX(IR)
             Q=ARRIN(INDXT)
             INDX(IR)=INDX(1)
             IR=IR-1
             IF(IR.EQ.1)THEN
                INDX(1)=INDXT
                RETURN
             END IF
          END IF
          I=L
          J=L+L
20        IF(J.LE.IR)THEN
             IF(J.LT.IR)THEN
                IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1
             END IF
             IF(Q.LT.ARRIN(INDX(J)))THEN
                INDX(I)=INDX(J)
                I=J
                J=J+J
             ELSE
                J=IR+1
             END IF
          GO TO 20
          END IF
          INDX(I)=INDXT
       GO TO 10
       END
