 
C
C
       SUBROUTINE CMREAD(HTOT,CFRAC,OFRAC,HEFRAC)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (N1=50,N2=50,N3=100,N4=30,N5=500,NSP=30)
C
C      READS THE CHEMICAL REACTION DATA.
       COMMON/CNUM/  KH,KH2,KPHOT,KCR,KCHEM
       COMMON/NCHEM/ NRH(N1,3),NRH2(N2,3),NPHOT(N3,3),NCR(N4,3),
     >               NCHM(N5,4)
       COMMON/CHEMR/RRH(N1,3),RRH2(N2,3),RPHOT(N3,3),RCR(N4),
     >              RCHM(N5,3)
       COMMON /CHMDEN/ DSPEC(NSP),DSPECP(NSP),DSPSCL(NSP),CSPEC(NSP)
       CHARACTER*5 SS(0:NSP)
       DATA SS/'/','HE','HE+','H+','H2+','H3+','C','CH','CO','C+',
     >           'CH+','CH2+','CO+','HCO+','*C','*CH','*CO','*C+',
     >           '*CH+','*CH2+','*CO+','*HCO+','O','OH','H2O','O2',
     >           'O+','OH+','H2O+','H3O+','ELEC' /
C
Cold            'HE','C','O','H+','H2+','H3+','HE+','CH','CH2','CH3',
Cold >          'CH4','C+','CH+','CH2+','CH3+','CH4+','CH5+',
Cold >          'OH','H2O','O+','OH+','H2O+','H3O+','CO','CO+',
Cold >          'HCO+','ELEC','O2','O2+','O2H+',
Cold >          '*C','*CH','*CH2','*CH3','*CH4','*C+','*CH+','*CH2+',
Cold >          '*CH3+','*CH4+','*CH5+','*CO','*CO+','*HCO+',
Cold >          'Si','Si+','SiO','SiO+','SiH','SiH2+','HOSi+'/
C
C      READ CHEMICAL REACTION TABLES.
       READ(75,20) KH
       DO 2, I=1,KH
         READ(75,1)   (NRH(I,J), J=1,3),(RRH(I,K), K=1,3)
1        FORMAT(3I4,3(2X,1PE10.3))
         WRITE(82,11)  (SS(NRH(I,J)), J=1,3),(RRH(I,K), K=1,3)
11       FORMAT(3(A5,2X),3(2X,1PE10.3))
2      CONTINUE
       READ(75,20) KH2
       DO 3, I=1,KH2
         READ(75,1)   (NRH2(I,J), J=1,3),(RRH2(I,K), K=1,3)
         WRITE(82,11) (SS(NRH2(I,J)), J=1,3),(RRH2(I,K),K=1,3)
3      CONTINUE
       READ(75,20) KPHOT
       DO 4, I=1,KPHOT
         READ(75,1)    (NPHOT(I,J), J=1,3),(RPHOT(I,K), K=1,3)
         WRITE(82,11)  (SS(NPHOT(I,J)), J=1,3),(RPHOT(I,K),K=1,3)
4      CONTINUE
5      FORMAT(3I4,2X,1PE10.3)
15     FORMAT(3(A5,2X),1PE10.3)
       READ(75,20) KCR
       DO 6, I=1,KCR
          READ(75,5) (NCR(I,J), J=1,3),RCR(I)
          WRITE(82,15) (SS(NCR(I,J)), J=1,3),RCR(I)
6      CONTINUE
       READ(75,20) KCHEM
       DO 7, I=1,KCHEM
         READ(75,8)   (NCHM(I,J), J=1,4),(RCHM(I,K), K=1,3)
         WRITE(82,17)  (SS(NCHM(I,J)), J=1,4),(RCHM(I,K), K=1,3)
7      CONTINUE
8      FORMAT(4I4,3(2X,1PE10.3))
17     FORMAT(4(A5,2X),3(2X,1PE10.3))
20     FORMAT(15X,I3)

C      Startwerte um chemisches Netzwerk zu loesen 
       
       ENTRY CMREAD1(HTOT,CFRAC,OFRAC,HEFRAC)
       DO 12, K=1,NSP
          DSPSCL(K) = CFRAC*HTOT/1.0D+07
          DSPEC(K)  = 1.0D-05*CFRAC*HTOT
          DSPECP(K) = 0.D0
12     CONTINUE
       DSPEC(1)  = HEFRAC*HTOT
       DSPEC(22) = OFRAC*HTOT
       DSPEC(9)  = CFRAC*HTOT
       DSPEC(30) = DSPEC(9)
       DSPEC(17) = 1.5D-02*DSPEC(9)
       DSPECP(1) = DSPEC(1)
       DSPECP(3) = DSPEC(3)
       DSPECP(9) = DSPEC(9)
       DSPECP(30) = DSPEC(30)
       DSPECP(17) = DSPEC(17)
       RETURN
       END
C
 
C
       SUBROUTINE CHEM3(T,SINTL,SINTR,TAUDL,TAUDR,
     >                  HDEN,H2DEN,NF,COSRAY,
     >                  HEFRAC,OFRAC,CFRAC,SIFRAC,C13FRAC,XNSP,
     >                  CD,COLR,NR)
    
       

       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
       PARAMETER (PNORM=0.636619772D0, TINY=1.0D-33,N1=50,N2=50,N3=100,
     >                    N4=30,N5=500,NSP=30)

C NEW 
       Dimension CD(NR),COLR(NR)
     
       COMMON/CNUM/  KH,KH2,KPHOT,KCR,KCHEM
       COMMON/NCHEM/ NRH(N1,3),NRH2(N2,3),NPHOT(N3,3),NCR(N4,3),
     >               NCHM(N5,4)
       COMMON/CHEMR/RRH(N1,3),RRH2(N2,3),RPHOT(N3,3),RCR(N4),
     >              RCHM(N5,3)
       COMMON /CHMDEN/ DSPEC(NSP),DSPECP(NSP),DSPSCL(NSP),CSPEC(NSP)
       COMMON /COINFO/ X1ACO(8),X2AH2(6),YACO(8,6),Y2ACO(8,6),H2CLMN
       COMMON /COIN13/ YCO13(8,6),Y2CO13(8,6)
       DIMENSION Q(NSP,NSP),X(NSP),Y(NSP),INDX(NSP)
       DIMENSION Q2(NSP,NSP),Y2(NSP),F(NSP)
       DIMENSION XNSP(NSP) 
       Dimension IPIV(NSP),BTT(NSP,1),QT(NSP,NSP)
       CHARACTER*5 SS(0:NSP)
       DATA SS/'/','HE','HE+','H+','H2+','H3+','C','CH','CO','C+',
     >           'CH+','CH2+','CO+','HCO+','*C','*CH','*CO','*C+',
     >           '*CH+','*CH2+','*CO+','*HCO+','O','OH','H2O','O2',
     >           'O+','OH+','H2O+','H3O+','ELEC' /
C
       NF=0
       T3=T/300.D0
       HEDEN=HEFRAC*(HDEN+2.D0*H2DEN)
       CDEN=CFRAC*(HDEN+2.D0*H2DEN)
       ODEN=OFRAC*(HDEN+2.D0*H2DEN)
       C13DEN=C13FRAC*(HDEN+2.0D0*H2DEN)
       SILDEN=SIFRAC*(HDEN+2.0d0*H2DEN)
C      C13DEN=1.5D-02*CDEN
C      SILDEN=3.0D-05*(HDEN+2.D0*H2DEN)
       FRAD1 = SINTL*expc2(-TAUDL)
       FRAD2 = SINTR*expc2(-TAUDR)
       FRAD  = SINTL*expc2(-TAUDL)+SINTR*expc2(-TAUDR)
C
       DO 1000, MM=1,200
C      WRITE( 5,29) MM
29     FORMAT('ITERATION =',2X,I4)
       DO 40, I=1,NSP
          F(I)=0.D0
          DO 30, J=1,NSP
             Q(I,J)=0.D0
30        CONTINUE
40     CONTINUE
C
C      REACTION TYPE  A + H --> B + C + (H,H2)
       DO 50, I=1,KH
          NA=NRH(I,1)
          NB=NRH(I,2)
          NC=NRH(I,3)
          R=RRH(I,3)*expc2(-RRH(I,2)/T)*T3**RRH(I,1)
          Q(NA,NA)=Q(NA,NA)+HDEN*R
          Q(NB,NA)=Q(NB,NA)-HDEN*R
          IF(NC .NE. 0) Q(NC,NA)=Q(NC,NA)-HDEN*R
          H=DSPEC(NA)*HDEN*R
          F(NA)=F(NA)-H
          F(NB)=F(NB)+H
          IF(NC .NE. 0) F(NC)=F(NC)+H
50     CONTINUE
C
C      REACTION TYPE  A + H2 --> B + C + (H,H2)
       DO 70, I=1,KH2
          NA=NRH2(I,1)
          NB=NRH2(I,2)
          NC=NRH2(I,3)
          R=RRH2(I,3)*expc2(-RRH2(I,2)/T)*T3**RRH2(I,1)
          Q(NA,NA)=Q(NA,NA)+H2DEN*R
          Q(NB,NA)=Q(NB,NA)-H2DEN*R
          IF(NC .NE. 0) Q(NC,NA)=Q(NC,NA)-H2DEN*R
          H=DSPEC(NA)*H2DEN*R
          F(NA)=F(NA)-H
          F(NB)=F(NB)+H
          IF(NC .NE. 0) F(NC)=F(NC)+H
70     CONTINUE
C
C      REACTION TYPE  A + HNU --> B + C
       DO 80, I=1,KPHOT
          NA=NPHOT(I,1)
          NB=NPHOT(I,2)
          NC=NPHOT(I,3)
          Q(NA,NA)=Q(NA,NA)+FRAD*RPHOT(I,1)
          Q(NB,NA)=Q(NB,NA)-FRAD*RPHOT(I,1)
          IF(NC .NE. 0) Q(NC,NA)=Q(NC,NA)-FRAD*RPHOT(I,1)
          H=DSPEC(NA)*FRAD*RPHOT(I,1)
          F(NA)=F(NA)-H
          F(NB)=F(NB)+H
          IF(NC .NE. 0) F(NC)=F(NC)+H
80     CONTINUE
C
C
C      REACTION TYPE A + CRPHOT --> B + C
       DO 85, I=1,KCR
          NA=NCR(I,1)
          NB=NCR(I,2)
          NC=NCR(I,3)
          Q(NA,NA)=Q(NA,NA)+COSRAY*RCR(I)
          Q(NB,NA)=Q(NB,NA)-COSRAY*RCR(I)
          IF(NC .NE. 0.D0) Q(NC,NA)=Q(NC,NA)-COSRAY*RCR(I)
          H=DSPEC(NA)*COSRAY*RCR(I)
          F(NA)=F(NA)-H
          F(NB)=F(NB)+H
          IF(NC .NE. 0.D0) F(NC)=F(NC)+H
85     CONTINUE
C
C      NEW
C      goto 1111       

C
C      THE SPECIAL CASE OF CARBON IONIZATION.
       A1=2.181D-10*FRAD1
       A2=2.181D-10*FRAD2
CB       A1=1.6D-10*FRAD1
CB       A2=1.6D-10*FRAD2
       RCI1=A1*expc2(-1.6D-17*CD(19))
       RCI2=A2*expc2(-1.6D-17*COLR(19))
       RCI=RCI1+RCI2
       Q(9,6)=Q(9,6)-RCI
       F(9)=F(9)+DSPEC(6)*RCI
C ******* 13C
C      ??? not CD(48)
C      RCI=(A1+A2)*expc2(-1.6D-17*CDC)
       RCI=RCI1+RCI2
       Q(17,14)=Q(17,14)-RCI
       F(17)=F(17)+DSPEC(14)*RCI
C
C      THE SPECIAL CASE OF CO PHOTODISSOCIATION
C      radiation from the left side
       DCOL=1.0D0
       IF((CD(41).GT. 0.D0) .AND. (CD(1).GT. 0.D0)) THEN
	  COLOG=LOG10(CD(41))
	  H2LOG=LOG10(CD(1))
	  M1=8
	  M2=6
	  CALL SPLIN2(X1ACO,X2AH2,YACO,Y2ACO,M1,M2,COLOG,H2LOG,DCO)
	  DCOL=MIN(1.0D0,DCO)
CB	  DCOL = 1.0D0	
       END IF
C      radiation from the right side
       IF((COLR(41).GT. 0.D0) .AND. (COLR(1).GT. 0.D0)) THEN
	  COLOG=LOG10(COLR(41))
	  H2LOG=LOG10(COLR(1))
	  M1=8
	  M2=6
	  CALL SPLIN2(X1ACO,X2AH2,YACO,Y2ACO,M1,M2,COLOG,H2LOG,DCO)
   	  DCOR=MIN(1.0D0,DCO)
CB          DCOR=1.0D0
       END IF
       DCOL=1.039D-10*DCOL
       DCOR=1.039D-10*DCOR
CB       DCOL=2.039D-10*DCOL
CB       DCOR=2.039D-10*DCOR
       DCOL=FRAD1*expc2(-1.6D-17*CD(19))*DCOL
       DCOR=FRAD2*expc2(-1.6D-17*COLR(19))*DCOR
       DCO=DCOR+DCOL
       Q(8,8)  = Q(8,8)+DCO
       Q(6,8)  = Q(6,8)-DCO
       Q(22,8) = Q(22,8)-DCO
       F(8)    = F(8)-DSPEC(8)*DCO
C
C ******* 13CO
C      radiation from the left side
       DCOL=1.0D0
       IF((CD(59).GT. 0.D0) .AND. (CD(1).GT. 0.D0)) THEN
	  COLOG=LOG10(CD(59))
	  H2LOG=LOG10(CD(1))
	  M1=8
	  M2=6
CB	  CALL SPLIN2(X1ACO,X2AH2,YACO,Y2ACO,M1,M2,COLOG,H2LOG,DCO)
	  CALL SPLIN2(X1ACO,X2AH2,YCO13,Y2CO13,M1,M2,COLOG,H2LOG,DCO)
	  DCOL=MIN(1.0D0,DCO)
       END IF
CB	  write(*,*) 'dcol= ',dcol	 
C      radiation from the right side
       DCOR=1.0D0
       IF((COLR(59).GT. 0.D0) .AND. (COLR(1).GT. 0.D0)) THEN
	  COLOG=LOG10(COLR(59))
	  H2LOG=LOG10(COLR(1))
	  M1=8
	  M2=6
CB          CALL SPLIN2(X1ACO,X2AH2,YACO,Y2ACO,M1,M2,COLOG,H2LOG,DCO)
	  CALL SPLIN2(X1ACO,X2AH2,YCO13,Y2CO13,M1,M2,COLOG,H2LOG,DCO)
	  DCOR=MIN(1.0D0,DCO)
       END IF
CB	  write(*,*) 'dcor= ', dcor
       DCOL=1.039D-10*DCOL
       DCOR=1.039D-10*DCOR
CB       DCOL=2.039D-10*DCOL
CB       DCOR=2.039D-10*DCOR
       DCOL=FRAD1*expc2(-1.6D-17*CD(19))*DCOL
       DCOR=FRAD2*expc2(-1.6D-17*COLR(19))*DCOR
       DCO=DCOR+DCOL
       Q(16,16) = Q(16,16)+DCO
       Q(14,16) = Q(14,16)-DCO
       Q(22,16) = Q(22,16)-DCO
       F(16)    = F(16)-DSPEC(16)*DCO


1111   continue
C
C      REACTION TYPE  A + B --> C + D
       DO 90, I=1,KCHEM
          NA=NCHM(I,1)
          NB=NCHM(I,2)
          NC=NCHM(I,3)
          ND=NCHM(I,4)
          R=RCHM(I,3)*expc2(-RCHM(I,2)/T)*T3**RCHM(I,1)
          Q(NA,NA)=Q(NA,NA)+DSPEC(NB)*R
          Q(NB,NB)=Q(NB,NB)+DSPEC(NA)*R
          Q(NA,NB)=Q(NA,NB)+DSPEC(NA)*R
          Q(NB,NA)=Q(NB,NA)+DSPEC(NB)*R
          IF(NC .NE. 0) THEN
             Q(NC,NA)=Q(NC,NA)-DSPEC(NB)*R
             Q(NC,NB)=Q(NC,NB)-DSPEC(NA)*R
          END IF
          IF(ND .NE. 0) THEN
             Q(ND,NA)=Q(ND,NA)-DSPEC(NB)*R
             Q(ND,NB)=Q(ND,NB)-DSPEC(NA)*R
          END IF
          H=DSPEC(NA)*DSPEC(NB)*R
          F(NA)=F(NA)-H
          F(NB)=F(NB)-H
          IF(NC .NE. 0) F(NC)=F(NC)+H
          IF(ND .NE. 0) F(ND)=F(ND)+H
90     CONTINUE
C
C
C      THE FIRST THREE ROWS OF THE POPULATION MATRIX Q CONTAIN THE
C      COEFFICIENTS OF THE CONSERVATION EQUATIONS FOR HELIUM, OXYGEN,
C      AND OXYGEN.
C      HELIUM CONSERVATION.
       DO 100, I=1,NSP
          Q(1,I)=0.D0
100    CONTINUE
       Q(1,1)=1.D0
       Q(1,2)=1.D0
       F(1)=HEDEN-DSPEC(1)-DSPEC(2)
C
C
C      CARBON CONSERVATION.
       DO 120, I=1,NSP
          Q(6,I)=0.D0
120    CONTINUE
       Q(6,6)=1.D0
       F(6)=-DSPEC(6)
       DO 130, I=7,13
          Q(6,I) = 1.D0
          F(6) = F(6)-DSPEC(I)
130    CONTINUE
       F(6) = F(6)+CDEN
C
C      13C CONSERVATION
       DO 132, I=1,NSP
          Q(14,I)=0.
132    CONTINUE
       Q(14,14)=1.D0
       F(14)=-DSPEC(14)
       DO 134, I=15,21
          Q(14,I)=1.D0
          F(14)=F(14)-DSPEC(I)
134    CONTINUE
       F(14)=F(14)+C13DEN
C
C
C      OXYGEN CONSERVATION.
       DO 140, I=1,NSP
          Q(22,I)=0.D0
140    CONTINUE
       Q(22,22)=1.D0
       F(22)=-DSPEC(22)
       DO 150, I=23,24
          Q(22,I)= 1.D0
          F(22)  = F(22)-DSPEC(I)
150    CONTINUE
       DO 151, I=26,29
          Q(22,I)= 1.D0
          F(22)  = F(22)-DSPEC(I)
151    CONTINUE
       Q(22,8)  = 1.D0
       Q(22,12) = 1.D0
       Q(22,13) = 1.D0
       Q(22,25) = 2.D0
       F(22)    = F(22)-DSPEC(8)-DSPEC(12)-DSPEC(13)-2.D0*DSPEC(25)+ODEN
C ****** 13C
       Q(22,16)=1.D0
       Q(22,20)=1.D0
       Q(22,21)=1.D0
       F(22)=F(22)-DSPEC(16)-DSPEC(20)-DSPEC(21)
C
C
C
C      okay
C
C      ELECTRON EQUATION.
       DO 160, I=1,NSP
          Q(30,I)=0.D0
160    CONTINUE
       F(30)=-DSPEC(30)
       Q(30,30)=1.0D0
       DO 165, I=2,5
          Q(30,I)=-1.D0
          F(30)=F(30)+DSPEC(I)
165    CONTINUE
       DO 170, I=9,13
          Q(30,I)=-1.D0
          F(30)=F(30)+DSPEC(I)
170    CONTINUE
       DO 175, I=26,29
          Q(30,I)=-1.D0
          F(30)=F(30)+DSPEC(I)
175    CONTINUE
C ****** 13C
       DO 177, I=17,21
          Q(30,I)=-1.D0
          F(30)=F(30)+DSPEC(I)
177    CONTINUE
C
C
C
C      LOAD COSMIC RAY FORMATION TERMS FOR H+, H2+, HE+.
       F(3)=F(3)+(0.46D0*COSRAY*HDEN+0.022D0*COSRAY*H2DEN)
       F(4)=F(4)+0.93D0*COSRAY*H2DEN
       Q(2,1)=Q(2,1)-0.5D0*COSRAY
       F(2)=F(2)+0.5D0*COSRAY*DSPEC(1)
C
C      WRITE(6,178) (Y(IJ), IJ=1,NSP)
C178    FORMAT(5(2X,1PE10.3))
          DO 98, I=1,NSP
              Y2(I)=F(I)
              DO 97, J=1,NSP
                 Q2(I,J)=Q(I,J)
97            CONTINUE
98        CONTINUE
       ERRF=0.D0
       DO 101, I=1,NSP
          ERRF=ERRF+DABS(F(I))
101    CONTINUE
C      IF(ERRF .LT. 1.0D-15) THEN
C         PRINT*,'HIT ZERO AFTER',MM,'ITERATIONS'
C         RETURN
C      END IF
C      PRINT*, MM
C      WRITE(6,103) (SS(I),F(I), I=1,NSP)
103    FORMAT(4(A5,1X,1PE10.3,2X))
C      IF(1 .EQ. 0) THEN
       DO 302, I=1,NSP
	  BTT(i,1) = F(i)
          DO 301, J=1,NSP
C           IF(Q(I,J) .NE. 0.) WRITE(84,303) I,J,Q(I,J)
            QT(i,j) = Q(i,j)
301       CONTINUe
302    CONTINUE
303    FORMAT(2X,I2,2X,I2,2X,1PE10.3)
       WRITE(84,305)
305    FORMAT('************************')
C old  END IF
C      write(*,*)'ipiv',ipIV
C      write(*,*) BTT
C      write(*,*) 'okay'
C      write(*,*) Q
       Call DGESV(NSP,1,QT,nsp,ipiV,BTT,NSP,INFO)
C      write(*,*)'ipiv',ipIV
C      write(*,*) 'Info',Info
       DO 3022, I=1,NSP
         F(i)=Btt(i,1) 
C        write(*,*) i,Btt(i,1)
3022   CONTINUE

Cold       CALL LUDCMP(Q,NSP,NSP,INDX,D)
Cold       CALL LUBKSB(Q,NSP,NSP,INDX,F)
Cold       CALL MPROVE(Q2,Q,NSP,NSP,INDX,Y2,F)
C
C       WRITE(76,1105) (SS(I),DSPEC(I), I=1,NSP)
C      WRITE(6,103) (SS(I),F(I), I=1,NSP)
      ERRX=0.D0
      DO 201, I=1,NSP
      IF(DSPEC(I) .LT. TINY) DSPEC(I)=TINY
         IF(DSPEC(I) .NE. 0.D0) THEN
C          PRINT*,DSPEC(I),I
	    ACCM=5.0D-02
	    ONE=1.0D0
	    TEST1=DABS(F(I)/DSPEC(I))
	    TEST2=DABS(DSPEC(I)/DSPSCL(I))
	    IF((TEST1.GT.ACCM) .AND. (TEST2.GT.ONE)) ERRX=1.0D0
C	    IF((TEST1.GT.ACCM) .AND. (TEST2.GT.ONE))
C     >             WRITE(76,*) I,SS(I),TEST1,TEST2
C            IF((DABS(F(I)/DSPEC(I)) .GT. ACCM)  .AND.
C     >          (DABS(DSPEC(I)/DSPSCL(I)) .GT. ONE)) ERRX=1.0D0  
C             IF(ERRX .EQ. 1.0D0) WRITE(76,*) I,SS(I),TEST1,TEST2
         ELSE
          IF(F(I) .NE. 0.D0) ERRX=1.D0
         END IF
C        IF(DSPEC(I) .NE. 0.D0) THEN
         DSPEC(I)=DSPEC(I)*(1.D0+
     >            0.9D0*PNORM*DATAN(F(I)/((DSPEC(I)+TINY)*PNORM)))
C        ELSE
C           DSPEC(I)=DSPEC(I)*(1.D0+0.9D0*DATAN(F(I)/ODEN))
C        END IF
201   CONTINUE
      IF(ERRX.EQ.0.D0) THEN
         NSIGN=+1
         DO 205, I=1,NSP
            IF((DSPEC(I).LT.0.D0).AND.(DSPEC(I).GT.DSPSCL(I)))NSIGN=-1
205      CONTINUE
         IF(NSIGN .LT. 0) THEN
           PRINT*,'CONVERGED TO NEGATIVE SOLUTION AFTER',MM,'ITERATIONS'
           NF=1
           WRITE(6,1105) (SS(I),DSPEC(I), I=1,NSP)
         ELSE
C           PRINT*,'CONVERGED AFTER',MM,' ITERATIONS'
C           WRITE(6,1105) (SS(I),DSPEC(I), I=1,NSP)
         END IF
C        NEW 
         Do 501 i = 1,NSP
           XNSP(i) = DSPEC(i)
501      continue

         RETURN
      END IF
1000   CONTINUE
       NF=1
       WRITE(6,*) 'CHEMICAL VECTOR DID NOT CONVERGE'
       WRITE(6,1105) (SS(I),DSPEC(I), I=1,NSP)
       WRITE(6,*) DCO
1105   FORMAT(4(3X,A5,'=',1PE10.3))
       RETURN
       END
 
C
	SUBROUTINE COLOAD
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
	PARAMETER (NCO=50)
	COMMON /COINFO/ X1ACO(8),X2AH2(6),YACO(8,6),Y2ACO(8,6),H2CLMN
        COMMON /COIN13/ YCO13(8,6),Y2CO13(8,6)
	COMMON /COCLD/ COH2(NCO,NCO,6),TCOH2(6)
 	COMMON /COMAT/ COA(NCO-1),COC(NCO,NCO),COE(NCO)
C
	X1ACO(1)=0.D0
	DO 3, I=1,7
	   X1ACO(I+1)=12.D0+FLOAT(I)
3	CONTINUE
	X2AH2(1)=0.D0
	DO 4, I=1,5
	   X2AH2(I+1)=18.D0+FLOAT(I)
4	CONTINUE
	DO 30, I=1,6
	   READ(12,27) (YACO(M,I), M=1,8)
27	   FORMAT(8(1PE10.3))
C	   WRITE(6,27) (YACO(M,I), M=1,8)
30	CONTINUE
        DO 32, I=1,6
           READ(12,27) (YCO13(M,I), M=1,8)
C	   PRINT*,YCO13(1,I)
32      CONTINUE     
C
	M=8
	N=6
	CALL SPLIE2(X1ACO,X2AH2,YACO,M,N,Y2ACO)
        CALL SPLIE2(X1ACO,X2AH2,YCO13,M,N,Y2CO13)
C
C       Enter CO levels data...
	COE(1)=0.D0
	DO 40, I=1,NCO-1
	   READ(13,38) FREQ,AVAL
38         FORMAT(38X,F9.4,8X,1PE11.5)
	   COE(I+1)=COE(I)+FREQ/2.997925462D+01
	   COA(I)=AVAL
40      CONTINUE
C
C	Clear COH2 matrix
        DO 70, I=1,NCO
           DO 60, J=1,NCO
              DO 50, K=1,6
                 COH2(I,J,K)=0.D0
50	      CONTINUE
60         CONTINUE
70      CONTINUE
C
C
        READ(13,75) (TCOH2(K), K=1,6)
	DO 90, I=1,NCO-1
	   L=MIN(20,50-I)
	   DO 80, J=1,L
	      READ(13,75) (COH2(51-I-J,51-I,K), K=1,6)
75	      FORMAT(9X,6(E9.3,2X))
C              WRITE(7,76) 51-I,51-I-J,(COH2(51-I-J,51-I,K),K=1,6)
C76	      FORMAT(2X,I2,2X,I2,2X,6(E9.3,2X))
80	   CONTINUE
90	CONTINUE
C
	RETURN
	END

C
C

       SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)  
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DIMENSION XA(N),YA(N),Y2A(N)                                              
       KLO=1                                                                     
       KHI=N                                                                     
1      IF (KHI-KLO.GT.1) THEN                                                    
         K=(KHI+KLO)/2                                                           
         IF(XA(K).GT.X)THEN                                                      
           KHI=K                                                                 
         ELSE                                                                    
           KLO=K                                                                 
         ENDIF                                                                   
         GOTO 1                                                                    
       ENDIF                                                                     
       H=XA(KHI)-XA(KLO)                                                         
       IF (H.EQ.0.) PAUSE 'Bad XA input.'                                        
       A=(XA(KHI)-X)/H                                                           
       B=(X-XA(KLO))/H                                                           
       Y=A*YA(KLO)+B*YA(KHI)+                                                    
     *      ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.                     
       RETURN                                                                    
       END                                                                       

C
C

       SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)

       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (NMAX=100)                                                      
       DIMENSION X(N),Y(N),Y2(N),U(NMAX) 
       BIGG=.99E30
       IF (YP1.GT. BIGG) THEN                                                   
         Y2(1)=0.                                                                
         U(1)=0.                                                                 
       ELSE                                                                      
         Y2(1)=-0.5                                                              
         U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)                     
       ENDIF                                                                     
       DO 11 I=2,N-1                                                             
         SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))                                       
         P=SIG*Y2(I-1)+2.                                                        
         Y2(I)=(SIG-1.)/P                                                        
         U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))                     
     *        /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P                       
11     CONTINUE                                                                  
       IF (YPN.GT. BIGG) THEN                                                   
         QN=0.                                                                   
         UN=0.                                                                   
       ELSE                                                                      
         QN=0.5                                                                  
         UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))                 
       ENDIF                                                                     
       Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)                                      
       DO 12 K=N-1,1,-1                                                          
         Y2(K)=Y2(K)*Y2(K+1)+U(K)                                                
12     CONTINUE                                                                  
       RETURN                                                                    
       END                                                                       

C
C

       SUBROUTINE SPLIN2(X1A,X2A,YA,Y2A,M,N,X1,X2,Y)
  
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (NN=100)                                                        
       DIMENSION X1A(M),X2A(N),YA(M,N),Y2A(M,N),YTMP(NN),Y2TMP(NN),
     >           YYTMP(NN)                                                                       
       DO 12 J=1,M                                                               
         DO 11 K=1,N                                                             
           YTMP(K)=YA(J,K)                                                       
           Y2TMP(K)=Y2A(J,K)                                                     
11       CONTINUE                                                                
         CALL SPLINT(X2A,YTMP,Y2TMP,N,X2,YYTMP(J))                               
12     CONTINUE
       TTT=1.0E30
       CALL SPLINE(X1A,YYTMP,M,TTT,TTT,Y2TMP)                                
       CALL SPLINT(X1A,YYTMP,Y2TMP,M,X1,Y)                                       
       RETURN                                                                    
       END                                                                       

C
C 

       SUBROUTINE SPLIE2(X1A,X2A,YA,M,N,Y2A)
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (NN=100)
       DIMENSION YA(M,N),Y2A(M,N),YTMP(NN),Y2TMP(NN)
       DIMENSION X1A(M),X2A(N)
       DO 13 J=1,M      
         DO 11 K=1,N   
           YTMP(K)=YA(J,K) 
11       CONTINUE
	 TTT=1.E30
         CALL SPLINE(X2A,YTMP,N,TTT,TTT,Y2TMP)     
         DO 12 K=1,N        
           Y2A(J,K)=Y2TMP(K)
12       CONTINUE          
13     CONTINUE           
       RETURN            
       END              
 
