

         Subroutine COLEVS(CD,CDD,H2den,Hden,T,BETA,NR,COCOOL) 

	 PARAMETER(NCO=50)
         PARAMETER(NLHT=15)
         PARAMETER(NPAR=366)
         PARAMETER(NTRANS=426)
         
         IMPLICIT DOUBLE PRECISION (A-H,O-Z)

         DIMENSION COCLD(NCO),COLEV(NCO),
     >             COTAU(NCO-1),COCOOL(NCO-1), 
     >             CD(NR),CDD(NR)

         DO 100 i = 1,NCO-1
           COCLD(i)  = CD(68+i)
           COLEV(i)  = 0.0d0
           COTAU(i)  = 0.0d0
           COCOOL(i) = 0.0d0
100      continue  
         COCLD(NCO) = CD(68+NCO)
         COLEV(NCO) = 0.0d0  
         CODEN = CDD(41) 
         Do 260 i = 69,68+NCO
            CDD(i) = COLEV(i-68)
260      continue
         IF(CODEN.lt.1.0d-11) return  
      	 Call COPOPO(CODEN,COCLD,COLEV,COTAU,COCOOL,HDEN,H2DEN,T,
     >               BETA)
         Do 200 i = 69,68+NCO
            CDD(i) = COLEV(i-68)
200      continue
         Return
         End 

C
C

	SUBROUTINE COPOPO(CODEN,COCLD,COLEV,COTAU,COCOOL,HDEN,H2DEN,T,
     >                    BETA)
C
C	Computes local CO rotational population fractions
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
     
	PARAMETER (NCO=50)
	PARAMETER (NCO1=40)
        PARAMETER(NLHT=15)
        PARAMETER(NPAR=366)
        PARAMETER(NTRANS=426)
  
 	COMMON /COMAT/ COA(NCO-1),COC(NCO,NCO),COE(NCO) 
	COMMON /COMORE/ COTEX(NCO-1),COTB(NCO-1),CO13TB(NCO-1)
        COMMON /XTA1/ XTLTE(NCO-1),XTLTE13(NCO-1)
        DIMENSION COCLD(NCO),COLEV(NCO),
     >         	  COTAU(NCO-1),COCOOL(NCO-1),ESC(NCO-1)
	DIMENSION ZCO(NCO1,NCO1),B(NCO1),INDX(NCO1),ZCOP(NCO1,NCO1),
     >   BP(NCO1)
	DIMENSION COH(5)
	DATA COH /8.868D-11,2.048D-11,1.083D-11,5.815D-11,1.637D-11/
C
C 
C	Clear ZCO, COC and B
	DO 20, I=1,NCO1
	   B(I)=0.D0
	   DO 10,J=1,NCO1
	      ZCO(I,J)=0.D0
              COC(I,J)=0.D0
10	   CONTINUE
20      CONTINUE
C
C       LTE-TEST
        Do 300 I=1,NCO-1
          XTLTE(i) = (2*i+1)*expc2(-1.43883D0*
     >               (COE(i+1)-COE(1))/T)
300     continue
C	Load COC terms due to CO-H2 collisions.	
	DO 50, J=2,NCO1
	   K=MAX(1,J-20)
	   DO 40, I=K,J-1
	      COC(I,J)=-FCH2(I,J,T)*H2DEN
              COC(J,J)=COC(J,J)-COC(I,J)
  	      FAC=FLOAT(2*(J-1)+1)/FLOAT(2*(I-1)+1)
	      COC(J,I)=FAC*COC(I,J)*expc2(-1.43883D0*(COE(J)-COE(I))/T)
              COC(I,I)=COC(I,I)-COC(J,I)
40	   CONTINUE
50	CONTINUE
C
C	Load COC terms due to CO-H collisions.
	T2=(T/100.D0)**0.5D0
        DO 70, J=2,NCO1
	   K=MAX(1,J-5)
	   DO 60, I=K,J-1
	      JDEL=J-I
	      DOWN=T2*COH(JDEL)*HDEN
	      FAC=FLOAT(2*(J-1)+1)/FLOAT(2*(I-1)+1)
	      UP=FAC*DOWN*expc2(-1.43883D0*(COE(J)-COE(I))/T)
	      COC(I,J)=COC(I,J)-DOWN
	      COC(J,J)=COC(J,J)+DOWN
	      COC(J,I)=COC(J,I)-UP
	      COC(I,I)=COC(I,I)+UP
60         CONTINUE
70      CONTINUE
C
        DO 153, J=1,NCO1
        SUM=0.D0
        DO 152, I=1,NCO1
           SUM=SUM+COC(I,J)
152      CONTINUE
C        WRITE(6,149) SUM,COC(J,J)
149      FORMAT(2(2X,1PE10.3))
153      CONTINUE
C
C
C	Compute CO transition opacities.
        DO 156, I=1,NCO1-1
	   FAC=25.1327D0*BETA*(COE(I+1)-COE(I))**3.D0
	   WR=FLOAT(2*I+1)/FLOAT(2*(I-1)+1)
	   COTAU(I)=COA(I)*(COCLD(I)*WR-COCLD(I+1))/FAC
156	CONTINUE
CB           WRITE(10,334) (COTAU(I),i=1,4)
334	format(4(2x,1pe10.3))
C	Load ZCO
	DO 159, I=1,NCO1-1
           ESC(I)=BESC(COTAU(I))
           ZCO(I+1,I+1)=COA(I)*ESC(I)
           ZCO(I,I+1)=-ZCO(I+1,I+1)
159      CONTINUE
	DO 170, I=1,NCO1
	   DO 160, J=1,NCO1
             ZCO(I,J)=ZCO(I,J)+COC(I,J)
160	   CONTINUE
170      CONTINUE
	DO 180, J=1,NCO1
	   ZCO(NCO1,J)=1.D0
180	CONTINUE
        B(NCO1)=1.0D0
C
C
        DO 185, I=1,NCO1
           BP(I)=B(I)
           DO 184, J=1,NCO1
	      ZCOP(I,J)=ZCO(I,J)
184	   CONTINUE
185      CONTINUE
C        write(*,*) 'ANFANG'
C        write(*,*) (ZCO(NCO,J),J=1,50)
C        write(*,*) 'ENDE'
C
        NLEV=NCO1
	CALL LUDCMP(ZCO,NLEV,NLEV,INDX,D)
	CALL LUBKSB(ZCO,NLEV,NLEV,INDX,B)
        CALL MPROVE(ZCOP,ZCO,NLEV,NLEV,INDX,BP,B)
        CALL MPROVE(ZCOP,ZCO,NLEV,NLEV,INDX,BP,B)
C
C	   WRITE(6,190) (B(I), I=1,NCO1
C190	   FORMAT(5(2X,1PE10.3))
C
	SUM=0.D0
C	DO 200, I=1,NCO
C           SUM=SUM+B(I)
C200	CONTINUE
C	WRITE(6,*) SUM
C
	DO 210, I=1,NCO1
C alt           IF(B(I) .GT. 1.0D-11) THEN
           IF(B(I) .GT. 1.0D-9) THEN
              COLEV(I)=CODEN*B(I)
           ELSE
              COLEV(I)=0.D0
           END IF
210     CONTINUE
        Do 211 I=NCO1,NCO
          COLEV(i)=0.0d0
211     continue
C
C	Compute local cooling.
	DO 220, I=1,NCO-1
           COCOOL(I)=COLEV(I+1)*COA(I)*ESC(I)*(COE(I+1)-COE(I))
220     CONTINUE
C
	IF(1 .EQ. 0) THEN
	DO 230, I=1,NCO-1
	   IF(COLEV(I+1) .GT. 0.D0) THEN
	     FAC=FLOAT(2*(I-1)+1)/FLOAT(2*I+1)
	     R=LOG(FAC*COLEV(I+1)/COLEV(I))
	     COTEX(I)=-1.43883D0*(COE(I+1)-COE(I))/R
           END IF
230     CONTINUE
	END IF
C
	RETURN
	END
 
