

         Subroutine COLEVSN(CD,CDD,COLR,H2den,Hden,T,
     >                      BETA,NR,COCOOL) 

C        Calculates 12CO-level-populations and cooling functions
C        for a plane-parallel slab of finite extension


	 PARAMETER(nco=50)
         PARAMETER(NLHT=15)
         PARAMETER(NPAR=416)
         PARAMETER(NTRANS=476)
         IMPLICIT DOUBLE PRECISION (A-H,O-Z)

         DIMENSION COCLDL(NCO),COCLDR(NCO),COLEV(NCO),
     >             COTAUL(NCO-1),COTAUR(NCO-1),COCOOL(NCO-1), 
     >             CD(NR),CDD(NR),COLR(NR)

         DO 100 i = 1,NCO-1
           COCLDL(i)  = CD(68+i)
           COCLDR(i)  = COLR(68+i)
           COLEV(i)   = 0.0d0
           COTAUL(i)  = 0.0d0
           COTAUR(i)  = 0.0d0
           COCOOL(i)  = 0.0d0
100      continue  
         COCLDL(NCO) = CD(68+NCO)
         COCLDR(NCO) = COLR(68+NCO)
         COLEV(NCO) = 0.0d0  
         CODEN = CDD(41) 
         Do 260 i = 69,68+NCO
           CDD(i) = COLEV(i-68)
260      continue

             IF(CODEN.lt.1.0d-11) return  
CB           IF(CODEN.lt.1.275d-5) return  
      	 Call COPOP(CODEN,COCLDL,COCLDR,COLEV,COTAUL,COTAUR,
     >              COCOOL,HDEN,H2DEN,T,BETA)
C        write(*,*) 'CODEN =',Coden
C        write(*,*) COLEV
         Do 200 i = 69,68+NCO
            CDD(i) = COLEV(i-68)
200      continue
         Return
         End 

C
C

        FUNCTION BESC(TAU)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C 
C       CALCULATES ONE SIDED ESCAPE PROBABILTY AS A FUNCTION OF TAU.
C
        IF(TAU .EQ. 0.D0) THEN
           BESC=5.0D-01
        ELSE IF(TAU .LT. 7.D0) THEN
           BESC=(1.D0-expc2(-2.3D0*TAU))/(4.68D0*TAU)
        ELSE
           BESC=1.D0/(4.D0*TAU*(LOG(TAU/1.77245D0))**5.0D-01)
        END IF
        RETURN
        END

C  
C
 
        FUNCTION FCH2(I,J,T)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
	PARAMETER (nco=50)
	COMMON /COCLD/ COH2(NCO,NCO,6),TCOH2(6)
C
	TIN=T

CB	IF(T .LE. 50.D0) T=50.D0
        IF(T .GE. 2000.D0) T=2000.D0
CB ***************** Stossraten fuer T > 100K *********************
	IF (T.GE.100.0d0) THEN
	IF((T .GE. 50.D0) .AND. (T .LE. 300.D0)) THEN
	   K=1
	ELSE IF((T .GT. 300.D0) .AND. (T .LE. 600.D0)) THEN
	   K=2
	ELSE IF((T .GT. 600.D0) .AND. (T .LE. 1000.D0)) THEN
	   K=3
        ELSE IF((T .GT. 1000.D0) .AND. (T .LE. 1500.D0)) THEN
	   K=4
        ELSE
           K=5
	END IF

	FCH2=COH2(I,J,K) + ((COH2(I,J,K+1)-COH2(I,J,K))/
     > 	 	    (TCOH2(K+1)-TCOH2(K)))*(T-TCOH2(K))

	END IF

CB ************  NEUE STOSSRATENEXTRAPOLATION FUER T < 100K ***********
CB               SIEHE DIPLOMARBEIT VON INGO BOORS, S. 69
	
	IF (T .LT. 100.0D0) THEN 
			FCH2=COH2(I,J,1) *SQRT(T/ TCOH2(1))
	END IF

CB        IF ((i .le. 3) .and. (j .le. 3) .and. (k .le. 2)) then
CB	WRITE(10,*) 'T=',T,'  Tin=',TIN, '   FCH2(',I,J,K,') =',FCH2 
CB	END IF

	T=TIN

	RETURN
	END

C
C
      	SUBROUTINE COPOP(CODEN,COCLDL,COCLDR,COLEV,COTAUL,COTAUR,
     >                   COCOOL,HDEN,H2DEN,T,BETA)
 
C
C	Computes local CO rotational population fractions
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
 
	PARAMETER (nco=50)
	PARAMETER (nco1=40)
        PARAMETER(NLHT=15)
        PARAMETER(NPAR=416)
        PARAMETER(NTRANS=476)

 	COMMON /COMAT/ COA(NCO-1),COC(NCO,NCO),COE(NCO) 
	COMMON /COMORE/ COTEX(NCO-1),COTB(NCO-1),CO13TB(NCO-1)
        COMMON /XTA1/ XTLTE(NCO-1),XTLTE13(NCO-1),XTLTE18(NCO-1)
        DIMENSION COCLDL(NCO),COCLDR(NCO),COLEV(NCO),
     >         	  COTAUL(NCO-1),COTAUR(NCO-1),
     >            COCOOL(NCO-1),ESC(NCO-1)
	DIMENSION ZCO(NCO1,NCO1),B(NCO1),INDX(NCO1),ZCOP(NCO1,NCO1),
     >  BP(NCO1)
	DIMENSION COH(5)
	DATA COH /8.868D-11,2.048D-11,1.083D-11,5.815D-11,1.637D-11/
C
C 
C	Clear ZCO, COC and B
	DO 20, I=1,NCO1
	   B(I)=0.D0
	   DO 10,J=1,NCO1
	      ZCO(I,J)=0.D0
              COC(I,J)=0.D0
10	   CONTINUE
20      CONTINUE
C
C       LTE-TEST
        Do 300 I=1,NCO-1
          XTLTE(i) = (2*i+1)*expc2(-1.43883D0*
     >               (COE(i+1)-COE(1))/T)
300     continue
C	Load COC terms due to CO-H2 collisions.	
	DO 50, J=2,NCO1
	   K=MAX(1,J-20)
	   DO 40, I=K,J-1
	      COC(I,J)=-FCH2(I,J,T)*H2DEN
              COC(J,J)=COC(J,J)-COC(I,J)
  	      FAC=FLOAT(2*(J-1)+1)/FLOAT(2*(I-1)+1)
	      COC(J,I)=FAC*COC(I,J)*expc2(-1.43883D0*(COE(J)-COE(I))/T)
              COC(I,I)=COC(I,I)-COC(J,I)
40	   CONTINUE
50	CONTINUE
C
C	Load COC terms due to CO-H collisions.
	T2=(T/100.D0)**0.5D0
        DO 70, J=2,NCO1
	   K=MAX(1,J-5)
	   DO 60, I=K,J-1
	      JDEL=J-I
	      DOWN=T2*COH(JDEL)*HDEN
	      FAC=FLOAT(2*(J-1)+1)/FLOAT(2*(I-1)+1)
	      UP=FAC*DOWN*expc2(-1.43883D0*(COE(J)-COE(I))/T)
	      COC(I,J)=COC(I,J)-DOWN
	      COC(J,J)=COC(J,J)+DOWN
	      COC(J,I)=COC(J,I)-UP
	      COC(I,I)=COC(I,I)+UP
60         CONTINUE
70      CONTINUE
C
        DO 153, J=1,NCO1
        SUM=0.D0
        DO 152, I=1,NCO1
           SUM=SUM+COC(I,J)
152      CONTINUE
C        WRITE(6,149) SUM,COC(J,J)
149      FORMAT(2(2X,1PE10.3))
153      CONTINUE
C
C
C	Compute CO traisition opacities.
        DO 156, I=1,NCO1-1
	   FAC=25.1327D0*BETA*(COE(I+1)-COE(I))**3.D0
	   WR=FLOAT(2*I+1)/FLOAT(2*(I-1)+1)
	   COTAUL(I)=COA(I)*(COCLDL(I)*WR-COCLDL(I+1))/FAC
           COTAUR(I)=COA(I)*(COCLDR(I)*WR-COCLDR(I+1))/FAC
156	CONTINUE
CB	write(10,*) 'cotaul J= 1 - 4:'
CB          WRITE(10,333) (cotaul(i), i=1,4)
CB	write(10,*) 'cotaur J= 1 - 4:'
CB          WRITE(10,333) (cotaur(i), i=1,4)
333	format(4(2x,1pe10.3))
C        write(*,*) 'Cotau 2->1',Cotaul(1)
C        write(*,*) 'Cotau 3->2',Cotaul(2)
C	Load ZCO
	DO 159, I=1,NCO1-1
           ESC(I) = BESC(COTAUL(I))+BESC(COTAUR(I))
           ZCO(I+1,I+1) = COA(I)*ESC(I)
           ZCO(I,I+1)   = -ZCO(I+1,I+1)
159      CONTINUE
	DO 170, I=1,NCO1
	   DO 160, J=1,NCO1
             ZCO(I,J)=ZCO(I,J)+COC(I,J)
160	   CONTINUE
170      CONTINUE
	DO 180, J=1,NCO1
	   ZCO(NCO1,J)=1.D0
180	CONTINUE
        B(NCO1)=1.0D0
C
C
        DO 185, I=1,NCO1
           BP(I)=B(I)
           DO 184, J=1,NCO1
	      ZCOP(I,J)=ZCO(I,J)
184	   CONTINUE
185      CONTINUE
C        write(*,*) 'ANFANG'
C        write(*,*) (ZCO(NCO,J),J=1,50)
C        write(*,*) 'ENDE'
C
        NLEV=NCO1
	CALL LUDCMP(ZCO,NLEV,NLEV,INDX,D)
	CALL LUBKSB(ZCO,NLEV,NLEV,INDX,B)
        CALL MPROVE(ZCOP,ZCO,NLEV,NLEV,INDX,BP,B)
        CALL MPROVE(ZCOP,ZCO,NLEV,NLEV,INDX,BP,B)
C
C	   WRITE(6,190) (B(I), I=1,NCO)
C190	   FORMAT(5(2X,1PE10.3))
C
	SUM=0.D0
C	DO 200, I=1,NCO
C           SUM=SUM+B(I)
C200	CONTINUE
C	WRITE(6,*) SUM
C
	DO 210, I=1,NCO1
C alt           IF(B(I) .GT. 1.0D-11) THEN
           IF(B(I) .GT. 1.0D-9) THEN
              COLEV(I)=CODEN*B(I)
           ELSE
              COLEV(I)=0.D0
           END IF
210     CONTINUE
        Do 211 I=NCO1,NCO
          COLEV(i)=0.d0
211     continue
C
C	Compute local cooling.
	DO 220, I=1,NCO-1
           COCOOL(I)=COLEV(I+1)*COA(I)*ESC(I)*(COE(I+1)-COE(I))
220     CONTINUE
C
	IF(1 .EQ. 0) THEN
	DO 230, I=1,NCO-1
	   IF(COLEV(I+1) .GT. 0.D0) THEN
	     FAC=FLOAT(2*(I-1)+1)/FLOAT(2*I+1)
	     R=LOG(FAC*COLEV(I+1)/COLEV(I))
	     COTEX(I)=-1.43883D0*(COE(I+1)-COE(I))/R
           END IF
230     CONTINUE

	END IF
C
	RETURN
	END
 
