CB 14.09.1995 vermutlich biexp-fit fuer Av=10
       SUBROUTINE FABVIB(BETA)                                  
C  
C      Calculates oscillator-strenghts and branching-ratios for 
C      the mean interstellar field PHI(Lambda)
C
                                                                   
       IMPLICIT DOUBLE PRECISION(A-H,O-Z) 

       PARAMETER(NLHT=15)
                              
       COMMON /OSCB/ FXB(0:23),DXB(0:23),TXB(0:23)
       COMMON /OSCC/ FXC(0:9),DXC(0:9),TXC(0:9)
       COMMON /BRATB/ BBX(24,0:NLHT-1),ABTOT(24)
       COMMON /BRATC/ BCX(10,0:NLHT-1),ACTOT(10)
       COMMON /ENERGY/ EX(15),EB(24),EC(10)                         
       COMMON /BANDB/ FBANDB(0:14,0:23),AVBTOT(0:23),ABCONT(0:23),      
     >               DFVB(0:23)                                         
       COMMON /BANDC/ FBANDC(0:14,0:9),DFVC(0:9)                        
C                                                                       
C      ARRAY INITIALIZATION.                                            
       DO 10, K=0,23                                                 
          FXB(K)=0.                                               
10     CONTINUE                                                      
       DO 15, K=0,9                                                  
          FXC(K)=0.                                               
15     CONTINUE                                                      
       DO 30, I=1,24                                                   
          ABTOT(I)=0.                                                   
          DO 25, K=0,NLHT-1                                                 
             BBX(I,K)=0.                                               
25        CONTINUE                                                      
30     CONTINUE                                                         
       DO 38, I=1,10                                                   
          ACTOT(I)=0.                                                   
          DO 35, K=0,NLHT-1                                                 
             BCX(I,K)=0.                                               
35        CONTINUE                                                      
38     CONTINUE                                                         
C                                                                       
C      CALCULATE X-B OSCILLATOR STRENGTHS, INITIAL OPTICAL DEPTHS       
C      AND OPTICALLY THIN PUMPING RATES AND DOPPLER WIDTHS.             
C                                                                       
       U=1.49736D-02                                                    
       U2=2.654D-02                                                     
          DO 40, K=0,23                                                 
             FXB(K)=FBANDB(0,K)
             NB=K+1      
             X=1.0D+08/(EB(NB)-EX(1))                                   
             DXB(K)=BETA*(EB(NB)-EX(1))                              
             TXB(K)=U*FXB(K)/DXB(K)                            
             FXB(K)=PHI(X)*U2*FXB(K)                         
40        CONTINUE                                                      
C                                                                       
C      CALCULATE B-X TRANSITION PROBABILTIES                            
       DO 70, I=1,24                                                   
          DO 60, K=0,NLHT-1                                                 
             BBX(I,K)=0.66702*((EB(I)-EX(K+1))**2.)*FBANDB(K,I-1)      
60        CONTINUE
70     CONTINUE                                                         
C                                                                       
C      CALCULATE TOTAL B-X TRANSITION PROBABILITIES.                    
       DO 90, I=1,24
          ABTOT(I)=0.                                                   
          DO 80, K=0,NLHT-1                                                 
             ABTOT(I)=ABTOT(I)+BBX(I,K)                      
80        CONTINUE                                                      
             ABTOT(I)=ABTOT(I)/(1.-DFVB(I-1))
90     CONTINUE                                                         
C                                                                       
C      CALCULATE B-X BRANCHING RATIOS                                   
       DO 110, I=1,24                                                  
          DO 100, K=0,NLHT-1                                                
             BBX(I,K)=BBX(I,K)/ABTOT(I)                               
100       CONTINUE                                                      
110    CONTINUE                                                         
C
C
C
C                                                                       
C      CALCULATE X-C OSCILLATOR STRENGTHS                               
          DO 120, K=0,9                                                 
             FXC(K)=FBANDC(0,K)
             NC=K+1      
             X=1.0D+08/(EC(NC)-EX(1))                                   
             DXC(K)=BETA*(EC(NC)-EX(1))                              
             TXC(K)=U*FXC(K)/DXC(K)                            
             FXC(K)=PHI(X)*U2*FXC(K)                         
120       CONTINUE                                                      
C                                                                       
C      C-X TRANSITION PROBABILITIES.                                    
       DO 150, I=1,10                                                  
          DO 140, K=0,NLHT-1                                                
             BCX(I,K)=0.66702*((EC(I)-EX(K+1))**2.)*FBANDC(K,I-1)      
140       CONTINUE                                                      
150    CONTINUE                                                         
C                                                                       
C      TOTAL C TRANSITION PROBABILITIES                                 
       DO 160, I=1,10                                                  
          ACTOT(I)=0.
          DO 155, K=0,NLHT-1                                                
             ACTOT(I)=ACTOT(I)+BCX(I,K)                      
155       CONTINUE
             ACTOT(I)=ACTOT(I)/(1.-DFVC(I-1))
160    CONTINUE                                                         
C                                                                       
C      C-X BRANCHING RATIOS                                             
       DO 180, I=1,10                                                  
          DO 170, K=0,NLHT-1                                                
             BCX(I,K)=BCX(I,K)/ACTOT(I)                               
170       CONTINUE                                                      
180    CONTINUE                                                         
C                                                                       
C                                                                       
       RETURN                                                           
       END                                                              
                            
 
                                               
C                                                                       
C                                                                       
C       SUBROUTINE YIELD(DENV0,PTOT)                                
C       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
C                                                                       
C      CLACULATES THE CONTRIBUTION TO THE NUMBER OF PHOTONS IN THE      
C      6 TO 13.6 EV BAND THAT ARE ABSORBED BY H2 IN THE CURRENT STEP,   
C                                                                       
C       COMMON /PUMPB/ PXB(0:23),DISRB       
C       COMMON /PUMPC/ PXC(0:9),DISRC     
C                                                                       
C       PTOT=0.D0                                                          
C          DO 50, NVB=0,23                                               
C             PTOT=PTOT+DENV0*PXB(NVB)                    
C50        CONTINUE                                                      
C          DO 80, NVC=0,9                                                
C             PTOT=PTOT+DENV0*PXC(NVC)
C80        CONTINUE                                                      
C                                                                       
C       RETURN                                                           
C       END                                                              
C
C
       SUBROUTINE PMPVIB
C                                                                       
       IMPLICIT DOUBLE PRECISION (A-H,O-Z) 

       PARAMETER(NLHT=15)
                             
       COMMON /PUMPB/ PXB(0:23),DISRB       
       COMMON /PUMPC/ PXC(0:9),DISRC     
       COMMON /BRATB/ BBX(24,0:NLHT-1),ABTOT(24)            
       COMMON /BRATC/ BCX(10,0:NLHT-1),ACTOT(10)     
       COMMON /MATRIX/ POPA(NLHT,NLHT),POPP(NLHT),POPC(NLHT,NLHT) 
C                                                                       
C      INITIALIZE ARRAY POPP.                                           
       DO 10, II=1,NLHT                                                
          POPP(II)=0.                                             
10     CONTINUE                                                      
C                                                                       
C      DEPOPULATION                                                     
       DO 40, NVB=0,23                                               
          POPP(1)=POPP(1)+PXB(NVB)                                  
40     CONTINUE                                                      
       DO 45, NVC=0,9                                                
          POPP(1)=POPP(1)+PXC(NVC)                                  
45     CONTINUE                                                      
C                                                                       
C                                                                       
C      POPULATION VIA B                                                 
       DO 90, II=1,NLHT                                               
          DO 80, NVB=0,23                                            
              POPP(II)=POPP(II)-PXB(NVB)*BBX(NVB+1,II-1)
80        CONTINUE                                                   
90     CONTINUE                                                      
C                                                                       
C      POPULATION VIA C                                                 
       DO 120, II=1,NLHT                                                  
          DO 110, NVC=0,9                                               
             POPP(II)=POPP(II)-PXC(NVC)*BCX(NVC+1,II-1)
110       CONTINUE                                                      
120    CONTINUE                                                         
C
C
C
       RETURN                                                           
       END                                                              
        
C 
C
       SUBROUTINE PCLVIB(COLVOL,COLVOR,TAUDL,TAUDR)                          
C    
C      Calculates UV-Pumping rates from H2-ground-level to Lyman-Band 
C      (24-Levels) and Werner-Band (10-Levels)
C      COLVO = Column-density of H2 in ground-level
C                                                                   
       IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
 
       PARAMETER(NLHT=15)
CBB *********************************************************                             
       COMMON /PARAM/ XNTOT,SIGD,ZTOT,SINTL,SINTR,COSRAY,
     >                BETA,STEP1,STEP2,HTRY,RATDG,RFORM,THRES
       COMMON /OSCB/ FXB(0:23),DXB(0:23),TXB(0:23)                   
       COMMON /OSCC/ FXC(0:9),DXC(0:9),TXC(0:9)
       COMMON /BRATB/ BBX(24,0:NLHT-1),ABTOT(24)          
       COMMON /BRATC/ BCX(10,0:NLHT-1),ACTOT(10)     
       COMMON /PUMPB/ PXB(0:23),DISRB       
       COMMON /PUMPC/ PXC(0:9),DISRC
       COMMON /EDIS/  EDISRB,EDISRC,EBD(0:23),ECD(0:9)       
       COMMON /ENERGY/ EX(15),EB(24),EC(10)                         
       COMMON /BANDB/ FBANDB(0:14,0:23),AVBTOT(0:23),ABCONT(0:23),      
     1                DFVB(0:23)                                        
       COMMON /BANDC/ FBANDC(0:14,0:9),DFVC(0:9)                        
C
C      Last modified 5 Oct. 92 (Tel Aviv) 
C      to include ROBERGE formalism for dust attenuation.
C      This version is to be used ONLY for radiation fields
C      of equal intensity on both sides (ie SINTL=SINTR)      
C
       ATAU=MIN(TAUDL,TAUDR)/4.0D0
       GRABS=SINTL*EXPC2(-4.762D0*ATAU+9.426D-02*ATAU**2.D0)
C
C      CALCULATE PUMPING RATES                                          
C      X-B PUMPING RATES
       DO 40, K=0,23                                                 
          PXBL=FXB(K)                                  
          TAUD=COLVOL*TXB(K)                             
          PXBL=PXBL*FGK(TAUD,DXB(K),ABTOT(K+1)) 
          PXBR=FXB(K)                                  
          TAUD=COLVOR*TXB(K)                             
          PXBR=PXBR*FGK(TAUD,DXB(K),ABTOT(K+1))
          PXB(K)=GRABS*(PXBL+PXBR)/2.0D0           
40     CONTINUE                                                      
C                                                                       
C                                                                       
C      X-C PUMPING RATES                           
               
       DO 70, K=0,9
          PXCL=FXC(K)                                  
          TAUD=COLVOL*TXC(K)                             
          PXCL=PXCL*FGK(TAUD,DXC(K),ACTOT(K+1)) 
          PXCR=FXC(K)                                  
          TAUD=COLVOR*TXC(K)                             
          PXCR=PXCR*FGK(TAUD,DXC(K),ACTOT(K+1))
          PXC(K)=GRABS*(PXCL+PXCR)/2.0D0  
70        CONTINUE                                                      
C
          DISRB=0.0d0
          EDISRB=0.0d0
          DO 85, K=0,23                                                 
             SPUMD=PXB(K)*DFVB(K)                        
             DISRB=DISRB+SPUMD                                    
             EDISRB=EDISRB+SPUMD*EBD(K)                           
85        CONTINUE
          DISRC=0.0d0
          EDISRC=0.0d0                                                      
          DO 87, K=0,9                                                  
             SPUMD=PXC(K)*DFVC(K)              
             DISRC=DISRC+SPUMD                                    
             EDISRC=EDISRC+SPUMD*ECD(K)                           
87        CONTINUE                                                      
90     CONTINUE                                                         
C
C
       RETURN                                                           
       END                                                              
C                                                                       
C                                                                       
C                                                                       
       FUNCTION FGK(TAUD,DOPW,ARAD)                                     
C                                                                       
C      THIS ROUTINE CALCULATES THE LINE SELF SHIELDING FUNCTION         
C      DESCRIBED IN FEDERMAN ET AL. AP.J. 227:466.  INPUT PARAMETERS    
C      ARE THE OPTICAL DEPTH AT LINE CENTER TAUD, AND THE DOPPLER       
C      AND RADIAITIVE LINE WIDTHS DOPW AND RADW.                        
C                                                                       
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
C      WRITE(5,11) DOPW,ARAD                                            
11     FORMAT(2(1PE10.3))                                               
       R=ARAD/(22.2721D0*DOPW)                                            
       T=3.02D0*((R*1.0D+03)**(-0.064D0))                                   
       U=((TAUD*R)**0.5D0)/T                                              
       SR=((0.785398D0+U**2.D0)**(-0.5D0))*R/T                                
       IF(TAUD .LT. 2.D0) THEN                                            
          SJ=expc2(-0.6667D0*TAUD)                                         
       ELSE IF (TAUD .LT. 10.D0) THEN                                     
          SJ=0.638D0*TAUD**(-1.25D0)                                        
       ELSE IF (TAUD .LT. 100.D0) THEN                                    
          SJ=0.505D0*TAUD**(-1.15D0)                                        
       ELSE                                                             
          SJ=0.344D0*TAUD**(-1.0667D0)                                      
       END IF                                                           
       FGK=SJ+SR                                                        
       RETURN                                                           
       END                                                              
 
C
      FUNCTION PHI(X)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C      COMPUTES THE PHOTON FLUX (PHOTONS CM-2 S-1 HZ-1| IN THE
C      UNATTENUATED INTERSTELLAR RADIATION FIELD OF VAN DISHOECK
C      AND BLACK (1982,AP.J.,258,533) FOR LAMBDA > 2000 ANGSTROMS,
C      AND OF ROBERGE ET AL. (1981, AP.J., 243, 817) = DRAINE
C      (1978) FOR LAMBDA < 2000.
C      X IS THE WAVELENGTH IN ANGSTROMS.  FORMULA APPLIES IN
C      THE RANGE  911.7 < X < 30000 ANGSTROMS.
C
      COMMON /CDEN2/ THCOL,H2COL2
      IF(X.LT.911.75D0) GO TO 1
      IF(X.LT.2000.D0) GO TO 2
C     RETURN
    2 PHI=      (1.068D-03/X-1.719D0/(X*X)+6.853D+02/(X*X*X))
C   2 PHI=4.5D-08
C   2 PHI=(0.11/(X*X))/(expc2(1.44D+03/X)-1)
      RETURN
    1 PHI=0.0
      RETURN
      END
C
 
  
                                             
 
