 
       Subroutine TCAL(T,CD,CDD,NR,BETA,SINTL,SINTR,TAUDL,
     >                 TAUDR,XNTOT,COLR,HDEN,H2DEN,COSRAY,THRES,ITER)

       Parameter(NLHT=15)
       Parameter(NPAR=416)
       Parameter(NMAX1=800)      
       Parameter(NCO=50)

       IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
       DIMENSION CD(NR),CDD(NR),COLR(NR)                            
          
       COMMON /XNULL/ XCD(NLHT+NPAR),XCDD(NLHT+NPAR),
     >                XCOLR(NLHT+NPAR), 
     >                XBETA,XSINTL,XSINTR,XTAUDL,
     >                XTAUDR,XXNTOT,
     >                XHDEN,XH2DEN,XCOSRAY,XTHRES

  
       EXTERNAL FKT 


     
       
C      UMSPEICHERN FUER COMMON-BLOCK   
       DO 100 i = 1,NR
         XCD(i)   = CD(i)
         XCDD(i)  = CDD(i)
         XCOLR(i) = COLR(i)
c         write(*,*) i, cdd(i)
 100    continue
       XBETA   = BETA
       XSINTL  = SINTL
       XSINTR  = SINTR
       XTAUDL  = TAUDL
       XTAUDR  = TAUDR
       XHDEN   = HDEN
       XH2DEN  = H2DEN
       XXNTOT  = XNTOT
       XCOSRAY = COSRAY
	XTHRES = THRES
 
C      goto 111
       ABSERR = 0.0d0                         
       RELERR = 1.0D-3
       NMAX   = 40                               
       IMETH  = 4                     
       IEXTRA = 0 
       IEINST = 1                                  
       DELX   = 1.0D-6  
C       IF (ITTA.eq.0) then                                                       
C         X1     = 10.0d0                                                          
C         X2     = 1000.0d0
C         ITTA = 1 
C       Else
C
        X1 = T-T*0.1d0
        X2 = T+T*0.1d0
C       ENDIF    

       CALL  NULLST(FKT,ABSERR,RELERR,NMAX,IMETH,IEXTRA,DELX, 
     +              X1,X2,X3,F1,F2,F3,IZAEHL,IHILF1,IHILF2,   
     +              IEINST,IFEHL)
        IF(IZAEHL.eq.nmax) then
          write(*,*) 'WARNING: IZAEHL = nmax !!!'
          write(*,*) 'X1,x2,x3',x1,x2,x3
        endif
        IF(IFEHL.EQ.0) THEN
          Write(*,*) 'WARNING: TEMPERATURE NOT CONVERGED 1'
          write(*,*) 'X1,x2,x3',x1,x2,x3
          If(x1.eq.3.0d0.and.x2.eq.3.0d0) goto 150
          X1 = 3.0d0
          X2 = 5000.0d0
	  write(*,*) 'T= ',T
          CALL  NULLST(FKT,ABSERR,RELERR,NMAX,IMETH,IEXTRA,DELX, 
     +                 X1,X2,X3,F1,F2,F3,IZAEHL,IHILF1,IHILF2,
     +                 IEINST,IFEHL)
CB	write(*,*) '2. izaehl = ',izaehl	
        ENDIF
        IF(IFEHL.EQ.0) THEN
          Write(*,*) 'Error: TEMPERATURE NOT CONVERGED 2'
          write(*,*) 'X1,x2,x3',x1,x2,x3
          stop        
        ENDIF
C      STOP
C111    continue
C       Do 222 i = 1,5
C       CALL HTCL(T,CD,CDD,NR,BETA,SINTL,SINTR,TAUDL,
C     >          TAUDR,XNTOT,ETOT,COLR,HDEN,H2DEN,COSRAY,THRES)
C222    continue 
C       return
150    continue        
       T = MIN(X1,X2)
       DO 200 i = 1,NR
         CD(i)   = XCD(i)
         CDD(i)  = XCDD(i)
200    continue
       HDEN  = XHDEN
       H2DEN = XH2DEN
C      Check Chemical network
        RETURN
        END
       
 
       subroutine   H2LEVS(CD,CDD,NR,T,HDEN,H2DEN,COLR,
     >                   XNTOT,COSRAY,TAUDL,TAUDR,SINTL,
     >                   SINTR,ETRAN,EPHOT)
C
C      Righthand-side of initial value solver for H2-problem
C
       Parameter(NLHT=15)
       Parameter(NPAR=416)
       Parameter(NMAX1=800)      
       PARAMETER(NSP=45)
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
       DIMENSION CD(NR),CDD(NR),COLR(NR)
     
       COMMON /ENERGY/ EX(15),EB(24),EC(10)
       COMMON /MATRIX/ POPA(NLHT,NLHT),POPP(NLHT),POPC(NLHT,NLHT)
       COMMON /EDIS/ EDISRB,EDISRC,EBD(0:23),ECD(0:9)
       Common/Xtest/ TD1,RFORM1,DCOL12CO,DCOL13CO
C        
C
       DIMENSION Z(NLHT+1,NLHT+1),VJFRAC(NLHT+1),INDX(NLHT+1)
       DIMENSION ZCOP(NLHT+1,NLHT+1),BP(NLHT+1) 

C      H2-problem 
       CALL COLVIB(T,HDEN,H2DEN)
       COLH2L = CD(3)
       COLH2R = COLR(3) 
       CALL PCLVIB(COLH2L,COLH2R,TAUDL,TAUDR)
       CALL PMPVIB
C      Matrix zur Loesung der Ratengl. aufbauen
       Do 10 i=1,NLHT+1
         VJFRAC(i) = 0.0d0 
         INDX(i)   = 0
         D         = 0.0d0
         Do 10 j=1,NLHT+1
           Z(i,j) = 0.0d0
10     continue
       Do 20 i=1,NLHT
         Do 30 j=1,NLHT
           Z(i,j) = Popa(i,j)+Popc(i,j)
30       continue
         Z(I,I) = Z(i,i)+Cosray
         Z(i,1) = Z(i,1)+POPP(i)
20     continue
C      Letzte Zeile einbauen
       Do 40 j=1,NLHT
         Z(NLHT+1,j) = 1.0d0
40     continue
C      Letzte Spalte einbauen 
       Qform = 0.0d0
       Do 50 i = 1,NLHT
         Qform = Qform+expc2(-EX(i)/12098.0d0)
50     continue
       CALL SFAC(T,SINTL,SINTR,TAUDL,TAUDR,TD,RFORM)
       TD1    = TD
       Rform1 = Rform
C      RFORM  =  3.0d-17
       Do 60 i=1,NLHT
         Z(i,NLHT+1) = (-Rform*XNTOT*expc2(-ex(i)/12098.0d0))
     >                 /Qform
60     continue
       Z(NLHT+1,NLHT+1) = 0.5d0
       VJFRAC(16)       = 0.5d0 
       DO 185, I=1,NLHT+1
         BP(I)=VJFRAC(I)
         DO 184, J=1,NLHT+1
           ZCOP(I,J)=Z(I,J)
184      CONTINUE
185    CONTINUE

       Call LUDCMP(Z,NLHT+1,NLHT+1,INDX,D)
       Call LUBKSB(Z,NLHT+1,NLHT+1,INDX,VJFRAC)
       H2DEN = 0.0d0
       Do 70 i = 1,NLHT+1
         if(i.lt.NLHT+1) H2DEN = H2DEN+XNTOT*VJFRAC(i)
70     continue
       HDEN  = VJFRAC(16)*XNTOT
       H2DEN = (XNTOT-HDEN)/2.0d0
       CDD(1) = H2den
       CDD(2) = Hden
       Do 90 i = 1,NLHT
          CDD(i+2) = XNTOT*VJFRAC(i)
90     continue

       ETRAN=0.0D0
       DO 100 I=1,NLHT
         DO 110 J=1,NLHT
             ETRAN=ETRAN-POPC(I,J)*
     >             VJFRAC(j)*(xntot/h2den)*(EX(I)-EX(J))
110      CONTINUE
100    CONTINUE
       ETRAN=ETRAN*H2DEN
CB	write(*,*) 'etran = ',etran

       EPHOT=-VJFRAC(1)*xntot*(EDISRB+EDISRC)
       EDIS=0.0D0
       RETURN
       END
 
C  
C  

       Subroutine HTCL(T,CD,CDD,NR,BETA,SINTL,SINTR,TAUDL,
     >            TAUDR,XNTOT,ETOT,COLR,HDEN,H2DEN,COSRAY,THRES) 

   
       Parameter(NLHT=15)
       Parameter(NPAR=416)
       Parameter(NMAX1=800)      
       PARAMETER(NSP=45)
       PARAMETER(nco=50)
       PARAMETER(NTRANS=476) 

       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       
C      Three-level-atom (data see Tielens & Hollenbach) Ap.J. 291
C      ADAT(1..3) A-values
C      ADAT(4..9) coefficients for collisional rates (atomic hydrogen)
C      ADAT(10...12)  nu/c ( und nicht delta nu/c ) 
C      ADAT(13..15) statistical weights      
CB 20.06.1997:
C CIORTHO, CIPARA, OIORTHO, OIPARA: coefficients for collisional
C rates with ortho/para H2, see Spaans et al.,1994,  ApJ 437, 270,
C Schroeder et al. 1991, J. Phys. B, 24, 2487 and Jaquet et al. 1992, J. Phys. B,
C 25, 285
C APARA(1...6): T < 150K
C APARA(7...12): 150K < T < 1000K
C APARA(13...18): T > 1000K
C analog for AORTHO
       COMMON /CI/ CIDAT(16),CIDEN(3),CICOL(3),CITAU(3),CIPARA(18),
     >          CIORTHO(18)
       COMMON /OXY/ OXYDAT(16),OXYDEN(3),OXYCOL(3),OXYTAU(3),
     >          OXYPARA(18),OXYORTHO(18)
       COMMON /FEP/ FEDAT(16),FEDEN(3),FECOL(3),FETAU(3)
       Common/Xfrac/ HEFRAC,OfRAC,CFRAC,SIFRAC,C13FRAC     
       Common/Xprint/ EBALPR 
       Common/Xtest/ TD1,RFORM1,DCOL12CO,DCOL13CO
       INTEGER NR,NF
     
       DIMENSION CD(NR),CDD(NR),COLR(NR),XNSP(NSP) 
       DIMENSION ADAT(16),ADEN(3),ACOL(3),ATAU(3),ACOOL(3)
       DIMENSION ACOLL(3),ACOLR(3),ATAUL(3),ATAUR(3)
       DIMENSION EBAL(18),EBALPR(18),COCOOL(NCO-1) 
       Dimension Cpcol(2),Cpden(2),Cpcoll(2),Cpcolr(2)     
       DIMENSION SIPDEN(2),SIPCOLL(2),SIPCOLR(2)
     

C      New
       T = max(T,3.0d0) 
C      H2-PROBLEM
       CALL H2LEVS(CD,CDD,NR,T,HDEN,H2DEN,COLR,
     >             XNTOT,COSRAY,TAUDL,TAUDR,SINTL,
     >             SINTR,ETRAN,EPHOT)
C      H2-HEATING
C      einbauen ..........................
C       EBAL(1)=5.0d0*ETRAN/XNTOT
         EBAL(1)=ETRAN/XNTOT
CB	 ebal(1) = 0.0d0
       EBAL(2)=EPHOT/XNTOT
CB	 ebal(2) = 0.0d0
C      FORMATION HEATING (1/3 BINDING ENERGY)
C      CALL SFAC(T,SINT,TAUDST,TD,RFORM)
       CALL SFAC(T,SINTL,SINTR,TAUDL,TAUDR,TD,RFORM)
       EBAL(3)=-12098.D0*RFORM*HDEN
CB	ebal(3) = 0.0d0
       EBAL1=ETRAN/XNTOT
       EBAL2=EPHOT/XNTOT 
       EBAL3=-12098.D0*RFORM*HDEN
C      write(*,*) 'EBAL-H2',EBAL1,EBAL2,EBAL3 
       
C      Chemical network      
       Call CHEM3(T,SINTL,SINTR,TAUDL,TAUDR,
     >            HDEN,H2DEN,NF,COSRAY,HEFRAC,
     >            OFRAC,CFRAC,SIFRAC,C13FRAC,XNSP,
     >            CD,COLR,NR,DCOL12CO,DCOL13CO)
C      Changes in numbering of CDD 04.10.92 H.S.
C      Do 100 i = 1,NSP 
C        CDD(NLHT+2+I)   = XNSP(I)
C100    continue
       Do 100 i = 1,51  
         CDD(NLHT+2+I)   = 0.0d0  
100    continue
       CDD(NLHT+2+1) = XNSP(1)
       CDD(NLHT+2+2) = XNSP(6)
       CDD(NLHT+2+3) = XNSP(22)
       CDD(NLHT+2+4) = XNSP(3)
       CDD(NLHT+2+5) = XNSP(4)
       CDD(NLHT+2+6) = XNSP(5)
       CDD(NLHT+2+7) = XNSP(2)
       CDD(NLHT+2+8) = XNSP(7)
       CDD(NLHT+2+12)= XNSP(9)
       CDD(NLHT+2+13)= XNSP(10)
       CDD(NLHT+2+14)= XNSP(11)
       CDD(NLHT+2+18)= XNSP(23)
       CDD(NLHT+2+19)= XNSP(24)
       CDD(NLHT+2+20)= XNSP(26)
       CDD(NLHT+2+21)= XNSP(27)
       CDD(NLHT+2+22)= XNSP(28)
       CDD(NLHT+2+23)= XNSP(29)
       CDD(NLHT+2+24)= XNSP(8)
       CDD(NLHT+2+25)= XNSP(12)
       CDD(NLHT+2+26)= XNSP(13)
       CDD(NLHT+2+27)= XNSP(30) 
       CDD(NLHT+2+28)= XNSP(25)
       CDD(NLHT+2+31)= XNSP(14)
       CDD(NLHT+2+32)= XNSP(15)
       CDD(NLHT+2+36)= XNSP(17)
       CDD(NLHT+2+37)= XNSP(18)
       CDD(NLHT+2+38)= XNSP(19)
       CDD(NLHT+2+42)= XNSP(16)
       CDD(NLHT+2+43)= XNSP(20)
       CDD(NLHT+2+44)= XNSP(21)
c  _________________________________
       CDD(NLHT+2+310)= XNSP(31) 
       CDD(NLHT+2+311)= XNSP(32)
       CDD(NLHT+2+312)= XNSP(33)
       CDD(NLHT+2+313)= XNSP(34)
       CDD(NLHT+2+314)= XNSP(35)
       CDD(NLHT+2+315)= XNSP(36)
       CDD(NLHT+2+316)= XNSP(37)
       CDD(NLHT+2+317)= XNSP(38)
       CDD(NLHT+2+318)= XNSP(39)
       CDD(NLHT+2+319)= XNSP(40)
       CDD(NLHT+2+320)= XNSP(41)
       CDD(NLHT+2+321)= XNSP(42)
       CDD(NLHT+2+322)= XNSP(43)
       CDD(NLHT+2+323)= XNSP(44)
       CDD(NLHT+2+324)= XNSP(45)
       
C      Check Chemical network
C      Call CMSRTB(MSTP,T,SINTL,SINTR,TAUDL,TAUDR,HDEN,H2DEN,
C    >             COSRAY,CD,COLR,NR)

C      HEATING AND COOLING PROCESSES
C      Oxygen-cooling
       Do 10 i = 1,16
         ADAT(i)=OXYDAT(i)
10     continue
       Do 20 i = 1,3
         ATAU(i)  = 0.0d0
         ATAUL(i) = 0.0d0
         ATAUR(i) = 0.0d0
         Acool(i) = 0.0d0
         Aden(i)  = 0.0d0
20     continue
       ACOL(1)  = CD(119)
       ACOL(2)  = CD(120)
       ACOL(3)  = CD(121)
       ACOLL(1) = CD(119)
       ACOLL(2) = CD(120)
       ACOLL(3) = CD(121)
       ACOLR(1) = COLR(119)
       ACOLR(2) = COLR(120)
       ACOLR(3) = COLR(121)
       DTOT = CDD(20)
CB21.06.97       HPCL = CDD(2)
C      old: half-infinite-slab
C      CALL ATMCL3(T,ADAT,ACOL,ATAU,ADEN,ACOOL,DTOT,HPCL,
C     >            BETA)
        CALL ATCL3N(T,ADAT,ACOLL,ACOLR,ATAUL,ATAUR,ADEN,ACOOL,DTOT,
     >              HDEN,H2DEN,BETA,OXYPARA,OXYORTHO)
       CDD(119) = ADEN(1)
       CDD(120) = ADEN(2)
       CDD(121) = ADEN(3)
       EBAL(4)  = ACOOL(1)/XNTOT
       EBAL(5)  = ACOOL(2)/XNTOT
       EBAL(6)  = ACOOL(3)/XNTOT

C      Cosmic-ray heating
       EBAL(7) = -COSRAY*6.161D4


CB05.12.1995.1995 new photoelectric-heating nach Bakes und Tielens, 1994, ApJ 427
        eden = CDD(44) 
CB04.123.1995        radn  = SINTL*expc2(-TAUDL)+SINTR*expc2(-TAUDR)
        RADN  = SINTL*expc2(-TAUDL)+SINTR*expc2(-TAUDR)
	tkin = t
CB 	write(*,*) 'tkin=',tkin 
CB Umrechnung von Draine-Feld auf Habing-Feld nach Draine und Bertoldi,
CB 1996, 468, Tabelle 1
        rad1 = radn*1.71d0
CB11.12.96	rad1 = radn/1.71	
CB	photoelectric heating efficiency (Formel 41 aus Bakes ...)
	effpe = 3.0d-2/(1.0d0+(2.0d-4*rad1*dsqrt(Tkin)/eden))
CB     heating (Formel 42)
        xh1   = 1.0d-24*effpe*Rad1*xntot
CB     recombination cooling (vgl. Formel 44)
       alpha = 0.944d0
       b1  = 0.735d0/(Tkin**0.068d0)
       a1    = (rad1*dsqrt(Tkin)/eden)**b1 
       xc1   = 3.49d-30*Tkin**alpha*a1*eden*xntot
CB       xheat(1) = xh1-xc1
CB04.12.1995 Vorzeichen beachten:
               ebal(8) = -(xh1-xc1)/(1.986484d-16*XNTOT)
CB        write(*,*) xh1,xc1,ebal(8)



CB05.12.1995
C      GRAIN PHOTOELECTRIC HEATING
CB       EDEN  = CDD(44) 
CB        RADN  = SINTL*expc2(-TAUDL)+SINTR*expc2(-TAUDR)
CB        A1    = 1.658D+06
CB        A2    = -2.152D+05
CB        A3    = 6.919D+03
CB        CALL DGRN(T,RADN,EDEN,PEHEAT,RCOOL,U,A1,A2,A3,THRES)
CB        EBAL(8) = -1.342D-17*(PEHEAT-RCOOL)
C      new 1.4.92
CB                Ebal(8) = Ebal(8)*1.0d0

C      old EBAL(8) = EBAL(8)/5.D0


C      CO-Rotational cooling 12CO
C      old
CB       Call COLEVS(CD,CDD,H2DEN,HDEN,T,BETA,NR,COCOOL)
C      new
       Call COLEVSN(CD,CDD,COLR,H2DEN,HDEN,T,BETA,NR,COCOOL)
C       write(*,*) 'COCool-2',COCool(1)
       EBAL(9) = 0.0d0
       Do 300 i = 1,NCO-1
         EBAL(9) = EBAL(9) + COCOOL(i)
300    continue
       EBAL(9) = EBAL(9)/XNTOT
C     
       EBAL(15) = 0.0D0
       Call CO13LEV(CD,CDD,COLR,H2DEN,HDEN,T,BETA,NR,COCOOL)
   
C       CO-Rotational cooling 13CO
    	Do 301 i = 1,NCO-1
          EBAL(15) = EBAL(15) + COCOOL(I)
301     CONTINUE	
        EBAL(15) = EBAL(15)/XNTOT

       Call CO18LEV(CD,CDD,COLR,H2DEN,HDEN,T,BETA,NR,COCOOL)

C     B     SI+-COOLING
	SIPCOLL(1) = CD(177)
	SIPCOLL(2) = CD(178)
	SIPCOLR(1) = COLR(177)
	SIPCOLR(2) = COLR(178)
	SIPDEN(1) = 0.0D0
	SIPDEN(2) = 0.0D0
	SITAU = 0.0D0
	SIPTOT = CDD(63)
CB new version for Si-cooling:
C	CALL SIPCL(T,SIPCOLL,SIPCOLR,SITAU,SIPDEN,SIPTOT,
C     + HDEN,H2DEN,COOL,BETA)
C	EBAL(14) = COOL/XNTOT
        EBAL(14) = 0.0d0
	CDD(177) = SIPDEN(1)
	CDD(178) = SIPDEN(2)

C     12C+-cooling
       CPCOL(1) = CD(122)
       CPCOL(2) = CD(123)
       CPCOLL(1) = CD(122)
       CPCOLL(2) = CD(123)
       CPCOLR(1) = COLR(122)
       CPCOLR(2) = COLR(123)
       CPDEN(1) = 0.0d0
       CPDEN(2) = 0.0d0
       CPTAU    = 0.0d0
       CPTOT    = CDD(29)
C      old half-infinite slab
C       CALL CPCL(T,CPCOL,CPTAU,CPDEN,CPTOT,HDEN,H2DEN,COOL,
C     >           BETA)
C       write(*,*) 'COOL-C+-1',COOL
       CALL CPCLN(T,CPCOLL,CPCOLR,CPTAU,CPDEN,CPTOT,HDEN,
     >            H2DEN,COOL,BETA)
         EBAL(10) = cool/Xntot
       CDD(122) = CPDEN(1)
       CDD(123) = CPDEN(2)
CB	write(*,*) '12C+ cdd(122) =',cdd(122)
CB	write(*,*) '12C+ cdd(123) =',cdd(123)

CB  13C+-level-population

       CPCOLL(1) = CD(179)
       CPCOLL(2) = CD(180)
       CPCOLR(1) = COLR(179)
       CPCOLR(2) = COLR(180)
       CPDEN(1) = 0.0d0
       CPDEN(2) = 0.0d0
       CPTAU    = 0.0d0
CB	CPTOT = CDD(29)
       CPTOT    = CDD(53)
       CALL CPCLN(T,CPCOLL,CPCOLR,CPTAU,CPDEN,CPTOT,HDEN,
     >            H2DEN,COOL,BETA)
       CDD(179) = CPDEN(1)
       CDD(180) = CPDEN(2)
CB	write(*,*) '13C+ cdd(179) =',cdd(179)
CB	write(*,*) '13C+ cdd(180) =',cdd(180)

C      12 CI-cooling
       Do 410 i = 1,16
         ADAT(i)=CIDAT(i)
410     continue
       Do 420 i = 1,3
         ATAU(i)  = 0.0d0
         ATAUL(i) = 0.0d0
         ATAUR(i) = 0.0d0
         Acool(i) = 0.0d0
         Aden(i)  = 0.0d0
420    continue
       ACOL(1)  = CD(124)
       ACOL(2)  = CD(125)
       ACOL(3)  = CD(126)
CB	write(*,*) 'beginn atcl3n:'
CB	write(*,*) 'acoll(1) =',acoll(1)
CB	write(*,*) 'acoll(2) =',acoll(2)
CB	write(*,*) 'acoll(3) =',acoll(3)

       ACOLL(1) = CD(124)
       ACOLL(2) = CD(125)
       ACOLL(3) = CD(126)
       ACOLR(1) = COLR(124)
       ACOLR(2) = COLR(125)
       ACOLR(3) = COLR(126)
       DTOT = CDD(19)
CB        HPCL = CDD(2)
C      old: half-infinite-slab
C       CALL ATMCL3(T,ADAT,ACOL,ATAU,ADEN,ACOOL,DTOT,HPCL,
C     >            BETA)
        CALL ATCL3N(T,ADAT,ACOLL,ACOLR,ATAUL,ATAUR,ADEN,ACOOL,DTOT,
     >              HDEN,H2DEN,BETA,CIPARA,CIORTHO)
       CDD(124) = ADEN(1)
       CDD(125) = ADEN(2)
       CDD(126) = ADEN(3)
CB	write(*,*) '12C cdd(124) = ',cdd(124)
CB	write(*,*) '12C cdd(125) = ',cdd(125)
CB	write(*,*) '12C cdd(126) = ',cdd(126)
C      CDD(124) = Dtot
C      CDD(125) = Dtot
C      CDD(126) = Dtot
C      write(*,*) 'ACOOL', ACOOL
       EBAL(11)  = ACOOL(1)/XNTOT
       EBAL(12)  = ACOOL(2)/XNTOT
       EBAL(13)  = ACOOL(3)/XNTOT
       EBAL11  = ACOOL(1)/XNTOT
       EBAL12  = ACOOL(2)/XNTOT
       EBAL13  = ACOOL(3)/XNTOT

CB 14.01.93 13C-levelpopulation
       Do 411 i = 1,16
         ADAT(i)=CIDAT(i)
411     continue
       Do 421 i = 1,3
         ATAU(i)  = 0.0d0
         ATAUL(i) = 0.0d0
         ATAUR(i) = 0.0d0
         Acool(i) = 0.0d0
         Aden(i)  = 0.0d0
421    continue
       ACOL(1)  = CD(181)
       ACOL(2)  = CD(182)
       ACOL(3)  = CD(183)

       ACOLL(1) = CD(181)
       ACOLL(2) = CD(182)
       ACOLL(3) = CD(183)
       ACOLR(1) = COLR(181)
       ACOLR(2) = COLR(182)
       ACOLR(3) = COLR(183)
       DTOT = CDD(48)
CB       HPCL = CDD(2)
C      old: half-infinite-slab
C       CALL ATMCL3(T,ADAT,ACOL,ATAU,ADEN,ACOOL,DTOT,HPCL,
C     >            BETA)
        CALL ATCL3N(T,ADAT,ACOLL,ACOLR,ATAUL,ATAUR,ADEN,ACOOL,DTOT,
     >              HDEN,H2DEN,BETA,CIPARA,CIORTHO)
       CDD(181) = ADEN(1)
       CDD(182) = ADEN(2)
       CDD(183) = ADEN(3)
CB	write(*,*) '13C cdd(181) = ',cdd(181)
CB	write(*,*) '13C cdd(182) = ',cdd(182)
CB	write(*,*) '13C cdd(183) = ',cdd(183)

C
C      ROTATIONAL COOLING BY  OH  
       SH = 3.0D-16
       SH2 = SH
       OHDEN  = CDD(35) 
       OHCOLL = CD(35)
       OHCOLR = COLR(35)
       ETA = 10.D0
       A0  = 2.3D-02
       E0  = 27.D0
       CALL ROTCL(T,OHDEN,OHCOLL,OHCOLR,A0,E0,ETA,SH,SH2,
     >                  HDEN,H2DEN,BETA,RCOOL)
       EBAL(16) = RCOOL/XNTOT
C
C      ROTATIONAL COOLING BY  H2O 
       H2ODEN  = CDD(36) 
       H2OCOLL = CD(36)
       H2OCOLR = COLR(36) 
       CALL WATER(HDEN,H2DEN,H2ODEN,H2OCOLL,
     >            H2OCOLR,BETA,T,RCOOL) 
       EBAL(17) = RCOOL/XNTOT 
 
C
C      GAS GRAIN COOLING
       IF(T.GT.TD1) THEN
         EBAL(18) = 1.762D-18*XNTOT*(T-TD1)*T**0.5D0
       ELSE
         EBAL(18) = 0.0d0
       ENDIF 

       ETOT = 0.0d0
C      Write(*,*) EBAL
       Do 200 i=1,18
C        EBAL(i)   = 1.986484d-16*XNTOT*EBAL(i)
         EBALPR(i) = 1.986484d-16*XNTOT*EBAL(i)
         EBAL(i)   = 1.0d10*EBAL(i)
         ETOT      = EBAL(i)+ETOT
         EBAL(I)   = 0.0d0
200    continue 
       return
       end 

C
C
CMR... ATMCL3 is never invoked ...may be deleted
CMR...........................................................

       SUBROUTINE ATMCL3(T,ADAT,ACOL,ATAU,ADEN,ACOOL,DTOT,HPCL,
     >                   BETA)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      MODIFIED FEB 87.
C      CALCULATES COOLING RATES FOR THREE LEVEL ATOM WITH ONE SIDED
C      ESCAPE PROBABILITY TREATMENT FOR THE RADIATIVE TRANSFER WITHOUT
C      BACKGROUND RADIATION FIELD.
C      INPUT PARAMETERS;
C            T        GAS TEMPERATURE
C            ADAT     ATOMIC DATA
C            ACOL     FINESTRUCTURE COLUMN DENSITIES
C            DTOT     TOTAL ATOMIC DENSITY
C            HPCL     TOTAL HYDROGEN PARTICLE DENSITY
C      OUTPUT PARAMETERS;
C            ADEN     LOCAL FINE STRUCTURE DENSITIES
C            ACOOL    FINE STRUCTURE COOLING RATES
C
       DIMENSION ADAT(16),ADEN(3),ACOL(3),ATAU(3),ACOOL(3)
       X=-1.43883D0
C
       ATAU(1)=ADAT(1)*(ACOL(1)*ADAT(14)/ADAT(13)-ACOL(2))
     >         /(25.133D0*ADAT(10)**3.D0*BETA)
       ATAU(2)=ADAT(2)*(ACOL(1)*ADAT(15)/ADAT(13)-ACOL(3))
     >         /(25.133D0*ADAT(11)**3.D0*BETA)
       ATAU(3)=ADAT(3)*(ACOL(2)*ADAT(15)/ADAT(14)-ACOL(3))
     >         /(25.133D0*ADAT(12)**3.D0*BETA)
C      POPULATION MATRIX ELEMENTS.
       B21=-(ADAT(14)/ADAT(13)*(ADAT(4)*T**ADAT(7))
     >     *HPCL*expc2(X*ADAT(10)/T))
       B12=-(ADAT(1)*BESC(ATAU(1)) + (ADAT(4)*T**ADAT(7))*HPCL)
       B23=-(ADAT(3)*BESC(ATAU(3)) + (ADAT(6)*T**ADAT(9))*HPCL)
       B13=-(ADAT(2)*BESC(ATAU(2)) + (ADAT(5)*T**ADAT(8))*HPCL)
       IF(ABS(X*ADAT(11)/T) .LT. 50.D0) THEN
         B11=(ADAT(15)/ADAT(13))*(ADAT(5)*T**ADAT(8))
     >     *HPCL*expc2(X*ADAT(11)/T)  - B21
       ELSE
         B11=-B21
       END IF
       IF(ABS(X*ADAT(12)/T) .LT. 50.D0) THEN
         B22=(ADAT(15)/ADAT(14))*(ADAT(6)*T**ADAT(9))
     >     *HPCL*expc2(X*ADAT(12)/T)  - B12
       ELSE
         B22=-B12
       END IF
C
C      POPULATION SOLUTION.
       D=B11*(B23-B22) + B12*(B21-B23) + B13*(B22-B21)
       ADEN(2)=DTOT*(B11*B23-B21*B13)/D
       ADEN(3)=DTOT*(B21*B12-B11*B22)/D
       ADEN(1)=DTOT-ADEN(2)-ADEN(3)
C
C      CALCUALATE COOLING RATES.
       ACOOL(1)=ADEN(2)*ADAT(1)*BESC(ATAU(1))*ADAT(10)
       ACOOL(2)=ADEN(3)*ADAT(2)*BESC(ATAU(2))*ADAT(11)
       ACOOL(3)=ADEN(3)*ADAT(3)*BESC(ATAU(3))*ADAT(12)
C
       RETURN
       END

C
C
CMR... CPCL is never invoked, may be deleted..
CMR...........................................................

       SUBROUTINE CPCL(T,CPCOL,TAU,CPDEN,CPTOT,HDEN,H2DEN,
     >                 COOL,BETA)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      CALCULATE COOLING DUE TO TWO LEVEL INFRARED TRANSITION OF SINGLY
C      IONIZED CARBON.
C

       DIMENSION CPDEN(2),CPCOL(2)
       C21H=5.8D-10*T**0.02D0*HDEN
       C21H2=3.1D-10*T**0.1D0*H2DEN
       A11=2.0d0*(C21H+C21H2)*EXPC2(-91.6453D0/T)
C
       TAU=3.745D-13*(2.D0*CPCOL(1)-CPCOL(2))/BETA
       A12=-(2.4D-06*BESC(TAU)+C21H+C21H2)
       CPDEN(2)=CPTOT*A11/(A11-A12)
       CPDEN(1)=CPTOT-CPDEN(2)
       COOL=CPDEN(2)*BESC(TAU)*1.5287D-04
C
       RETURN
       END
C
C
       Subroutine CPCLN(T,CPCOLL,CPCOLR,CPTAU,CPDEN,CPTOT,HDEN,
     >                  H2DEN,COOL,BETA)
 
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      CALCULATE COOLING DUE TO TWO LEVEL INFRARED TRANSITION OF SINGLY
C      IONIZED CARBON.
C

       DIMENSION CPDEN(2),CPCOLL(2),CPCOLR(2)
       C21H=5.8D-10*T**0.02D0*HDEN
       C21H2=3.1D-10*T**0.1D0*H2DEN
       A11=2.0d0*(C21H+C21H2)*EXPC2(-91.6453D0/T)
C
       TAUL=3.745D-13*(2.D0*CPCOLL(1)-CPCOLL(2))/BETA
       TAUR=3.745D-13*(2.D0*CPCOLR(1)-CPCOLR(2))/BETA
       A12=-(2.4D-06*(BESC(TAUL)+BESC(TAUR))+C21H+C21H2)
       CPDEN(2)=CPTOT*A11/(A11-A12)
       CPDEN(1)=CPTOT-CPDEN(2)
       COOL=CPDEN(2)*(BESC(TAUL)+BESC(TAUR))*1.5287D-04

CB	write(10,*) 'taul= ',taul
CB	write(10,*) 'taur=' ,taur
CB	write(10,*) 'besc(taul)=',besc(taul),'  taul=',taul
CB	write(10,*) 'cpcolr(1)=',cpcolr(1),'  cpcolr(2)=',cpcolr(2)
CB	write(10,*) 'besc(taur)=',besc(taur),'  taur',taur
CB	write(10,*) 'cool= ',cool,'  cpden(2)=',cpden(2)
C
       RETURN
       END

C
C

       SUBROUTINE ROTCL(T,DEN,COLDENL,COLDENR,A0,E0,ETA,
     >                  SH,SH2,HDEN,H2DEN,BETA,RCOOL)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      CALCULATES THE ROTATIONAL COOLING BY A MOLECULE WITH A COLUMN
C      DENSITY COLDEN USING THE ANALYTICAL FORMULA GIVEN BY HOLLENBACH
C      AND MCKEE (AP. J. SUPP. 41:555).
C      INPUT DATA ARE;
C         T        GAS TEMPERATURE            (KELVIN)
C         DEN      MOLECULAR DENSITY          (CM**-2)
C         COLDEN   MOLECULAR COLUMN DENSITY   (CM**-2)
C         A0       TRANSITION PROBABILITY     (SEC**-1)
C         E0       ROTATIONAL ENERGY          (KELVIN)
C         ETA      # OF EFFECTIVE TRANSITIONS
C         SH       H COLLISION CROSS SECTION  (CM**2)
C         SH2      H2 COLLISION CROSS SECTION (CM**2)
C         HDEN     ATOMIC HYDROGEN GAS DENSITY (CM**-3)
C         H2DEN    H2 GAS DENSITY              (CM**-3)
C         BETA     DOPPLER PARAMETER          (CM/SEC)
C      OUTPUT DATA IS
C         RCOOL    ROTATIONAL COOLING               CM**-4/SEC)
C
C
       VH=1.455D+04*T**0.5D0
       VH2=VH/1.4142D0
C      Left side
       TAU=4.D0*COLDENL*A0/(1.18D+02*BETA*ETA*E0**2.D0*T)
       CTAU=TAU*(6.283D0*LOG(2.13D0+(TAU/2.718D0)**2.D0))**0.5D0
       CRRTIO=(4.D0*T*A0/E0)/(HDEN*SH*VH+H2DEN*SH2*VH2)
CCC    CRRTIO=2.3D+10*(T/1000.)**0.5D0/(2.D0*H2DEN)
       YM=LOG(1.D0+CTAU/(1.D0+10.D0*CRRTIO))
       FAC=9.665D-01*T**2.D0*A0*DEN/E0
       RCOOL1=FAC*(2.D0+YM+0.6D0*YM**2.D0)/
     >        (1.D0+CTAU+CRRTIO+1.5D0*CRRTIO**0.5D0)
C      Right side
       TAU=4.D0*COLDENR*A0/(1.18D+02*BETA*ETA*E0**2.D0*T)
       CTAU=TAU*(6.283D0*LOG(2.13D0+(TAU/2.718D0)**2.D0))**0.5D0
       CRRTIO=(4.D0*T*A0/E0)/(HDEN*SH*VH+H2DEN*SH2*VH2)
CCC    CRRTIO=2.3D+10*(T/1000.)**0.5D0/(2.D0*H2DEN)
       YM=LOG(1.D0+CTAU/(1.D0+10.D0*CRRTIO))
       FAC=9.665D-01*T**2.D0*A0*DEN/E0
       RCOOL2=FAC*(2.D0+YM+0.6D0*YM**2.D0)/
     >        (1.D0+CTAU+CRRTIO+1.5D0*CRRTIO**0.5D0)
       RCOOL=RCOOL1+RCOOL2


C      WRITE(5,10) TAU,CTAU,CRRTIO,YM,FAC,RCOOL
10     FORMAT(5(2X,1PE10.3))
C
       RETURN
       END

C
C

        Subroutine  WATER(HDEN,H2DEN,H2ODEN,H2OCOLL,
     >                    H2OCOLR,BETA,T,RCOOL) 
 
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C	Computes water cooling according to Eqn (8)
C       of Neufeld and Melnick Ap.J. 322:266 1987.
C       Collisions with H and H2 are assumed to be
C	equivalent.
C
	T3=T/1.0D3
	FAC=1.309D-07*T3**1.95D0
C  alt  ROOT=((HDEN+H2DEN)*H2OCOL/(7.0D+19*BETA*T3**2.9D0))**5.0D-01
C       ROOT=abs(((HDEN+H2DEN)*H2OCOL/(7.0D+19*BETA*T3**2.9D0)))**5.0D-01
C       Left side       
        ROOT=((HDEN+H2DEN)*H2OCOLL/(7.0D+19*BETA*T3**2.9D0))
        IF(ROOT.LT.1.0d-16) ROOT=0.0d0
        ROOT=ROOT*5.0d-1
	RCOOL1=H2ODEN*(HDEN+H2DEN)*FAC/(1.D0+ROOT)
C       Right side
        ROOT=((HDEN+H2DEN)*H2OCOLR/(7.0D+19*BETA*T3**2.9D0))
        IF(ROOT.LT.1.0d-16) ROOT=0.0d0
        ROOT=ROOT*5.0d-1
	RCOOL2=H2ODEN*(HDEN+H2DEN)*FAC/(1.D0+ROOT)
        RCOOL=RCOOL1+RCOOL2
C
	RETURN
	END

C
C

CB **********************7.5.92 *********************************

CMR... SIPCL is never invokied, may be deleted
CMR..................................................................

       SUBROUTINE SIPCL(T,SIPCOLL,SIPCOLR,SITAU,SIPDEN,SIPTOT,HDEN,
     + H2DEN,COOL,BETA)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      CALCULATES COOLING DUE TO TWO LEVEL INFRARED TRANSITION OF
C      SINGLY IONIZED SILICON.
C
       DIMENSION SIPDEN(2),SIPCOLL(2),SIPCOLR(2)
       HPCL=HDEN+H2DEN
       COOL=0.D0
       IF(414.D0/T .LT. 50.D0) THEN
          C21=6.5D-10*HPCL
          A11=2.0d0*C21*EXPC2(-414.D0/T)
C
          TAUL=3.689D-13*(2.D0*SIPCOLL(1)-SIPCOLL(2))/BETA
          TAUR=3.689D-13*(2.D0*SIPCOLR(1)-SIPCOLR(2))/BETA

          A12=-(2.2D-04*(BESC(TAUL)+BESC(TAUR))+C21)
          SIPDEN(2)=SIPTOT*A11/(A11-A12)
          SIPDEN(1)=SIPTOT-SIPDEN(2)
          COOL=SIPDEN(2)*(BESC(TAUL)+BESC(TAUR))*6.12D-02
       END IF
       RETURN
       END
C
 
       SUBROUTINE ATCL3N(T,ADAT,ACOLL,ACOLR,ATAUL,ATAUR,ADEN,ACOOL,
     >                   DTOT,HDEN,H2DEN,BETA,APARA,AORTHO)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      MODIFIED March 92.
CB 21.06.1997: modified for H2-collision:
C      CALCULATES COOLING RATES FOR THREE LEVEL ATOM WITH TWO SIDED
C      ESCAPE PROBABILITY TREATMENT FOR THE RADIATIVE TRANSFER WITHOUT
C      BACKGROUND RADIATION FIELD.
C      INPUT PARAMETERS;
C            T        GAS TEMPERATURE
C            ADAT     ATOMIC DATA
C            ACOLL    FINESTRUCTURE COLUMN DENSITIES (left-side)
C            ACOLR    FINESTRUCTURE COLUMN DENSITIES (right-side)
C            DTOT     TOTAL ATOMIC DENSITY
CB 21.06.1997: modified for H2-collisions:
CB       HDEN      H PARTICLE DENSITY
CB       H2DEN     H2 PARTICLE DENSITY
       
C      OUTPUT PARAMETERS;
C            ADEN     LOCAL FINE STRUCTURE DENSITIES
C            ACOOL    FINE STRUCTURE COOLING RATES
C
       DIMENSION ADAT(16),ADEN(3),ACOLL(3),ACOLR(3),ATAUL(3),
     >           ATAUR(3),ACOOL(3),APARA(18),AORTHO(18)
       X=-1.43883D0
C
       ATAUL(1)=ADAT(1)*(ACOLL(1)*ADAT(14)/ADAT(13)-ACOLL(2))
     >         /(25.133D0*ADAT(10)**3.D0*BETA)
       ATAUL(2)=ADAT(2)*(ACOLL(1)*ADAT(15)/ADAT(13)-ACOLL(3))
     >         /(25.133D0*ADAT(11)**3.D0*BETA)
       ATAUL(3)=ADAT(3)*(ACOLL(2)*ADAT(15)/ADAT(14)-ACOLL(3))
     >         /(25.133D0*ADAT(12)**3.D0*BETA)
C
       ATAUR(1)=ADAT(1)*(ACOLR(1)*ADAT(14)/ADAT(13)-ACOLR(2))
     >         /(25.133D0*ADAT(10)**3.D0*BETA)
       ATAUR(2)=ADAT(2)*(ACOLR(1)*ADAT(15)/ADAT(13)-ACOLR(3))
     >         /(25.133D0*ADAT(11)**3.D0*BETA)
       ATAUR(3)=ADAT(3)*(ACOLR(2)*ADAT(15)/ADAT(14)-ACOLR(3))
     >         /(25.133D0*ADAT(12)**3.D0*BETA)

       xtest1 = besc(ATAUL(1))
       xtest2 = besc(ATAUR(1))
C      stop
C      POPULATION MATRIX ELEMENTS.
C 1. B21/B12
C FOR H
      qh = ADAT(4)*(T**ADAT(7))*HDEN
C FOR H2
      IF (T.LT.150) THEN
         qh2 = 1.0d0/4.0d0*APARA(1)*(T**APARA(4))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(1)*(T**AORTHO(4))*H2DEN
      ELSEIF(T.LT.1000) THEN
         qh2 = 1.0d0/4.0d0*APARA(7)*(T**APARA(10))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(7)*(T**AORTHO(10))*H2DEN
      ELSE
         qh2 = 1.0d0/4.0d0*APARA(13)*(T**APARA(16))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(13)*(T**AORTHO(16))*H2DEN
      ENDIF

       B21=-(ADAT(14)/ADAT(13)*(qh + qh2)*expc2(X*ADAT(10)/T))
       B12=-(ADAT(1)*(BESC(ATAUL(1))+BESC(ATAUR(1))) 
     >     + (qh + qh2))

C 2. B23/B22
C FOR H
      qh = ADAT(6)*(T**ADAT(9))*HDEN
C FOR H2
      IF (T.LT.150) THEN
         qh2 = 1.0d0/4.0d0*APARA(3)*(T**APARA(6))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(3)*(T**AORTHO(6))*H2DEN
      ELSEIF(T.LT.1000) THEN
         qh2 = 1.0d0/4.0d0*APARA(9)*(T**APARA(12))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(9)*(T**AORTHO(12))*H2DEN
      ELSE
         qh2 = 1.0d0/4.0d0*APARA(15)*(T**APARA(18))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(15)*(T**AORTHO(18))*H2DEN
      ENDIF
       B23=-(ADAT(3)*(BESC(ATAUL(3))+BESC(ATAUR(3)))
     >     + (qh + qh2))

       IF(ABS(X*ADAT(12)/T) .LT. 50.D0) THEN
         B22=(ADAT(15)/ADAT(14))*(qh + qh2)
     >     *expc2(X*ADAT(12)/T)  - B12
       ELSE
         B22=-B12
       END IF


C 3. B13/B11
C FOR H
      qh = ADAT(5)*(T**ADAT(8))*HDEN
C FOR H2
      IF (T.LT.150) THEN
         qh2 = 1.0d0/4.0d0*APARA(2)*(T**APARA(5))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(2)*(T**AORTHO(5))*H2DEN
      ELSEIF(T.LT.1000) THEN
         qh2 = 1.0d0/4.0d0*APARA(8)*(T**APARA(11))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(8)*(T**AORTHO(11))*H2DEN
      ELSE
         qh2 = 1.0d0/4.0d0*APARA(14)*(T**APARA(17))*H2DEN +
     >         3.0d0/4.0d0*AORTHO(14)*(T**AORTHO(17))*H2DEN
      ENDIF
      
       B13=-(ADAT(2)*(BESC(ATAUL(2))+BESC(ATAUR(2))) 
     >     + (qh + qh2))
       
       IF(ABS(X*ADAT(11)/T) .LT. 50.D0) THEN
         B11=(ADAT(15)/ADAT(13))*(qh + qh2)
     >     *expc2(X*ADAT(11)/T)  - B21
       ELSE
         B11=-B21
       END IF
C
C      POPULATION SOLUTION.
       D=B11*(B23-B22) + B12*(B21-B23) + B13*(B22-B21)
       ADEN(2)=DTOT*(B11*B23-B21*B13)/D
       ADEN(3)=DTOT*(B21*B12-B11*B22)/D
       ADEN(1)=DTOT-ADEN(2)-ADEN(3)
C
C      CALCULATE COOLING RATES.
       ACOOL(1)=ADEN(2)*ADAT(1)*
     >          (BESC(ATAUL(1))+BESC(ATAUR(1)))*ADAT(10)
       ACOOL(2)=ADEN(3)*ADAT(2)*
     >          (BESC(ATAUL(2))+BESC(ATAUR(2)))*ADAT(11)
       ACOOL(3)=ADEN(3)*ADAT(3)*
     >          (BESC(ATAUL(3))+BESC(ATAUR(3)))*ADAT(12)
C
       RETURN
       END

C
C  
CMR... DGRN is never invoked, may be deleted....
CMR...............................................................
 
       SUBROUTINE DGRN(T,SINT,EDEN,PEHEAT,RCOOL,U,A1,A2,A3,THRES)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      CALCULATES THE GRAIN-PHOTOELECTRIC HEATING USING DRAINE'S
C      FORMALISM.
C      INPUT PARAMETERS ARE:
C         GAS TEMPERATURE T  (K)
C         RADIATION FIELD SCALING PARAMETER SINT
C         ELECTRON DENSITY EDEN  (CM**-3)
C         RADIATION FIELD COEFFICIENTS A1,A2, AND A3.
C      THIS CODE ASSUMES A RADIATION FIELD OF THE FORM
C      F(E)=A1*D+A2*E**2.+A3*E**3.  IN UNITS OF
C      PHOTONS CM**-2. SEC**-1. SR**-1 EV**-1   WHERE E IS IN EV.
C	work-function = thres

       PARAMETER (MAXIT=2000)
	U1=-4.0D0
       U2=6.0D0
       XACC=1.0D-04
       RTNEWT=0.5D0*(U1+U2)
       DO 10, I=1,50
          CALL GCUR(T,RTNEWT,EDEN,SINT,CT,CPOS,CNEG,DCT,A1,A2,A3,THRES)
          DX=CT/DCT
          RTNEWT=RTNEWT-DX
          IF((U1-RTNEWT)*(RTNEWT-U2) .LT. 0.D0) THEN
           PRINT*,'EDEN=',EDEN,' i = ',i
           PAUSE 'JUMPED OUT'
          END IF
          IF(ABS(DX) .LT. XACC) GO TO 100
10     CONTINUE
       WRITE(5,*) 'NO CONVERGENCE'
100    U=RTNEWT
C      WRITE(5,*) 'U',U
       F1=4.189D0*(A1+13.59D0*A2+184.7D0*A3)
       F2=-1.047D0*(A2+27.18D0*A3)
       F3=0.2618D0*A3
       C1=6.284D0*(A1+13.59D0*A2+184.7D0*A3)
       C2=-2.094D0*(A2+27.18D0*A3)
       C3=1.047D0*A3
       DEL=13.59D0-thres-U
       IF(U .LT. 0.D0) DEL=13.59D0 - thres
       PEHEAT= 0.5D0*DEL*DEL*DEL*(F1+DEL*(F2+DEL*F3))
       IF(U .LT. 0.D0) PEHEAT=PEHEAT-
     1     U*(DEL*DEL*(C1+DEL*(C2+DEL*C3)))
       PEHEAT=0.5D0*0.75D0*PEHEAT*SINT
C      PEHEAT=SINT*2.69D+07*0.5D0*0.75D0*(1-U/5.6D0)**4.D0
       TEV=8.6171D-05*T
       PHI=U/TEV
       IF(PHI .GE. 0.D0) THEN
          BRAK=0.5D0*(2.D0+PHI)
        IF(PHI .LT. 100.D0) BRAK=BRAK+2.334D-02*expc2(-PHI)*(0.28D0+PHI)
       ELSE
          BRAK=2.334D-02*0.14D0*(2.D0-PHI)
          IF(ABS(PHI) .LT. 100.D0) BRAK=BRAK+0.5D0*(2.D0-PHI)*expc2(PHI)
       END IF
       RCOOL=5.3531D+01*EDEN*T**1.5D0*BRAK
       RETURN
       END


CMR... GCUR  is never invoked, may be deleted....
CMR...............................................................

       SUBROUTINE GCUR(T,U,EDEN,SINT,CT,CPOS,CNEG,DCT,A1,A2,A3,THRES)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C      THIS FUNCTION CALCULATES THE GRAIN CURRENT GCUR.
C      INPUT PARAMETERS ARE:
C         GAS TEMPERATURE T  (KELVIN)
C         GRAIN POTENTIAL U  (EV)
C         ELECTRON DENSITY EDEN   (CM**-3)
C         RADIATION FIELD SCALING PARAMETER SINT
C      IT IS ASSUMED THAT THE POSITIVE ION DENSITY (CII) EQUALS EDEN.
C      NOTE THAT THE STEADY-STATE POTENTIAL IS DETERMINED BY GCUR=0.
C      THE WORK FUNCTION IS 'thres', AND YINFINITY=0.5 AND Q=1.
C      FOR MORE DETAILS SEE DRAINE, AP. J. SUPP. 36:595, 1978.
C
C
       TEV=8.6171D-05*T
        FE=(2.79923D+14*TEV)**0.5D0
       FP=(1.27852D+10*TEV)**0.5D0
       C1=1.571D0*(A1+13.59D0*A2+184.688D0*A3)
       C2=-0.5236D0*(A2+27.18D0*A3)
       C3=0.2618D0*A3
       IF (U .GE. 0.D0) THEN
          CE=-0.5D0*EDEN*FE*(1.D0+U/TEV)
          DCE=-0.5D0*EDEN*FE/TEV
          CP=0.D0
          DCP=0.D0
          ARG=-U/TEV
          IF(ARG .GE. -100.D0) THEN
          CP=EDEN*FP*expc2(ARG)
          DCP=-EDEN*FP*expc2(ARG)/TEV
          END IF
          ETHRSH=thres+U
          DEL=13.59D0-ETHRSH
          CPHOT=DEL*DEL*(C1+DEL*(C2+DEL*C3))
          DCPHOT=-DEL*(2.D0*C1+DEL*(3.D0*C2+4.D0*C3*DEL))
C         CPHOT=4.80D+06*0.5D0*0.75D0*(1.-U/5.6D0)**3.D0
C         DCPHOT=-2.5714D+06*0.5D0*0.75D0*(1.-U/5.6D0)**2.D0
          CPHOT=SINT*CPHOT*0.5D0*0.75D0
          DCPHOT=SINT*DCPHOT*0.5D0*0.75D0
       ELSE
          CE=-0.5D0*EDEN*FE*expc2(U/TEV)
          DCE=-0.5D0*EDEN*FE*expc2(U/TEV)/TEV
          CP=EDEN*FP*(1.D0-U/TEV)
          DCP=-EDEN*FP/TEV
          ETHRSH=thres
          DEL=13.59D0-ETHRSH
          CPHOT=DEL*DEL*(C1+DEL*(C2+DEL*C3))
C         CPHOT=4.80D+06*0.75D0*0.5D0
          DCPHOT=0.D0
          CPHOT=SINT*CPHOT*0.5D0*0.75D0
       END IF
45     FORMAT(5(1X,1PE14.7))
       CPOS=CPHOT+CP
       CNEG=CE
       CT=CPOS+CNEG
       DCT=DCPHOT+DCE+DCP
       RETURN
       END
 
                                                                
C                                                                               
C --------------------------------------------------------------------          
C                                                                               
                                                                 
            SUBROUTINE NULLST(FKT,ABSERR,RELERR,NMAX,IMETH,IEXTRA,DELX,
     +                  X1,X2,X3,F1,F2,F3,IZAEHL,IHILF1,IHILF2, 
     +                  IEINST,IFEHL)            
C                                                                               
C*****************************************************************              
C                                                                *              
C  DIE SUBROUTINE NULLST BILDET DAS RAHMENPROGRAMM FUER MEHRERE  *              
C  UNTERPROGRAMME ZUR BESTIMMUNG VON NULLSTELLEN REELLWERTIGER   *              
C  STETIGER FUNKTIONEN. DAS VERFAHREN IST IN ERSTER LINIE FUER   *              
C  EINFACHE NULLSTELLEN BZW. NULLSTELLEN UNGERADER ORDNUNG       *              
C  GEDACHT. DAS UNTERPROGRAMM UNTERSCHEIDET SICH IN DER VORGE-   *              
C  HENSWEISE IN ABHAENGIGKEIT DAVON, OB DIE STARTWERTE NULL-     *              
C  -STELLEN EINSCHLIESSEN ODER NICHT.                            *              
C  FALLS EINSCHLUSS VORHANDEN IST, WIRD EINE ITERATIONSFOLGE     *              
C  MIT HILFE VERSCHIEDENER ITERATIONSVERFAHREN (PEGASUS,         *              
C  ANDERSON/BJOERCK, KING) KONSTRUIERT. DABEI IST GESICHERT,     *              
C  DASS DER EINSCHLUSS ERHALTEN BLEIBT. ALLE VERWENDETEN VER-    *              
C  FAHREN ARBEITEN ABLEITUNGSFREI UND BESITZEN EINE KONVERGENZ-  *              
C  ORDNUNG P > 1.6. SIND STARTWERTE MIT EINSCHLUSS NICHT BEKANNT,*              
C  SO KOENNEN ZWEI GLEICHE STARTWERTE GEWAEHLT WERDEN. DIE SUB-  *              
C  ROUTINE NULLST KONSTRUIERT DANN EINEN DAVON VERSCHIEDENEN     *              
C  STARTWERT DURCH ADDITION DES WERTES DELX AUF DEN STARTWERT X1;*              
C  DELX MUSS VOM BENUTZER GEWAEHLT WERDEN.                       *              
C  FALLS KEIN EINSCHLUSS VORHANDEN IST, WIRD ENTWEDER NUR        *              
C  LINEARE EXTRAPOLATION AUSGEFUEHRT ODER NACH DEM ERSTEN        *              
C  SEKANTENSCHRITT AUCH QUADRATISCHE EXTRAPOLATION (TANGENTE AN  *              
C  DIE INTERPOLIERENDE PARABEL DURCH DREI VERSCHIEDENE INTERPO-  *              
C  LATIONSPUNKTE). SOFERN AUF DIESEM WEGE EINSCHLUSS ERREICHT    *              
C  WIRD, GEHT ES MIT EINEM DER SPEZIELLEN ITERATIONSVERFAHREN    *              
C  WEITER, JE NACH WAHL DURCH DEN BENUTZER.                      *              
C  BEMERKUNG : UMFANGREICHE TESTS HABEN ERGEBEN, DASS DIE ANZAHL *              
C              DER BENOETIGTEN ITERATIONSSCHRITTE PRO NULLSTELLE *              
C              BEI GLEICHER GENAUIGKEITSFORDERUNG BEIM PEGASUS-  *              
C              VERFAHREN (SUBROUTINE PEG) AM GROESSTEN UND BEI   *              
C              DER KOMBINATION DER VERFAHREN VON ANDERSON/       *              
C              BJOERCK UND KING (SUBROUTINE ANDBJK) MIT ABSTAND  *              
C              AM KLEINSTEN IST.                                 *              
C                                                                *              
C                                                                *              
C  EINGABEPARAMETER :                                            *              
C  ==================                                            *              
C  FKT      : FUNKTION, VON DER EINE NULLSTELLE BESTIMMT WERDEN  *              
C             SOLL. SIE HAT DIE FORM                             *              
C                 REAL FUNCTION FKT(X)                           *              
C             UND MUSS IM RUFENDEN PROGRAMM ALS EXTERNAL VEREIN- *              
C             BART WERDEN ( BZW. ALS INTRINSIC, FALLS EINE FOR-  *              
C             TRAN 77-STANDARDFUNKTION VERWENDET WIRD ).         *              
C  ABSERR   : ) FEHLERSCHRANKEN, DIE BEIDE >= 0. GEWAEHLT WERDEN *              
C  RELERR   : ) MUESSEN, IHRE SUMME MUSS > 0. SEIN. ES WIRD DER  *              
C               FOLGENDE GEMISCHTE TEST DURCHGEFUEHRT :          *              
C               ABS(X1-X2) <= ABS(X2)*RELERR+ABSERR.             *              
C               WIRD ALSO RELERR=0. GEWAEHLT, SO HANDELT ES SICH *              
C               UM EINEN TEST AUF DEN ABSOLUTEN FEHLER, WAEHLT   *              
C               MAN ABSERR=0., IST ES EIN TEST AUF DEN RELATIVEN *              
C               FEHLER.                                          *              
C               DIE EINGEGEBENEN WERTE FUER ABSERR UND RELERR    *              
C               WERDEN VOM PROGRAMM NUR DANN UNGEAENDERT UEBER-  *              
C               NOMMEN, WENN SIE BEIDE GROESSER ALS DAS VIER-    *              
C               FACHE DES MASCHINENRUNDUNGSFEHLERS SIND ODER     *              
C               EINER NULL UND DER ANDERE GROESSER ALS DAS VIER- *              
C               FACHE DES MASCHINENRUNDUNGSFEHLERS IST. IST DIES *              
C               NICHT DER FALL, SO WERDEN BEIDE BZW. EINER AUF   *              
C               DIESEN WERT GESETZT.                             *              
C  NMAX     : MAXIMALE ANZAHL DER FUNKTIONSAUSWERTUNGEN.         *              
C             (GLEICH ANZAHL DER ITERATIONSSCHRITTE)             *              
C  IMETH    : = 1, PEGASUS-VERFAHREN.                            *              
C             = 2, VERFAHREN VON KING.                           *              
C             = 3, VERFAHREN VON ANDERSON/BJOERCK.               *              
C             = 4, VERFAHREN VON ANDERSON/BJOERCK UND KING.      *              
C  IEXTRA   : = 0, QUADRATISCHE EXTRAPOLATION ZUGELASSEN.        *              
C             = 1, NUR LINEARE EXTRAPOLATION ZUGELASSEN ( FALLS  *              
C                  EINE DOPPELTE NULLSTELLE VERMUTET WIRD ODER   *              
C                  SICH MIT IEXTRA=0 ERGEBEN HAT IFEHL=0).       *              
C             FALLS KEIN EINSCHLUSS VORHANDEN IST ( F1*F2 > 0. ),*              
C             KANN DURCH DIE WAHL VON IEXTRA ENTSCHIEDEN WERDEN, *              
C             OB NUR LINEAR EXTRAPOLIERT WERDEN SOLL ODER AUCH   *              
C             QUADRATISCHE EXTRAPOLATION ZUGELASSEN WIRD. FALLS  *              
C             KEINE DOPPELTE NULLSTELLE VERMUTET WIRD, SOLLTE    *              
C             MIT IEXTRA=0 BEGONNEN WERDEN.                      *              
C  DELX     : DIENT ZUR ABAENDERUNG EINES STARTWERTES BEI EIN-   *              
C             GABE VON ZWEI GLEICHEN STARTWERTEN. SINNVOLLE      *              
C             WAHL IST ETWA : DELX=1E-6 ODER DELX=1E-8.          *              
C  X1,X2    : STARTWERTE FUER DIE ITERATION; FALLS NUR EIN START-*              
C             WERT BEKANNT IST, MUSS X2=X1 GESETZT WERDEN.       *              
C             DURCH ADDITION VON DELX AUF EINEN DER BEIDEN       *              
C             GLEICHEN STARTWERTE WERDEN VOM PROGRAMM ZWEI       *              
C             VERSCHIEDENE STARTWERTE ERZEUGT.                   *              
C                                                                *              
C                                                                *              
C  AUSGABEPARAMETER :                                            *              
C  ==================                                            *              
C  ABSERR   : ) TATSAECHLICH VERWENDETE FEHLERGROESSEN.          *              
C  RELERR   : )                                                  *              
C  X1,X2,X3 : NAEHERUNGSWERTE FUER DIE GESUCHTE NULLSTELLE       *              
C             ( SIEHE IFEHL ).                                   *              
C  F1,F2,F3 : FUNKTIONSWERTE FKT(X1), FKT(X2), FKT(X3).          *              
C  IZAEHL   : ANZAHL DER DURCHGEFUEHRTEN FUNKTIONSAUSWERTUNGEN.  *              
C  IEINST   : = 0, STARTWERTE OHNE EINSCHLUSS.                   *              
C             = 1, STARTWERTE MIT EINSCHLUSS.                    *              
C  IFEHL    : = 0, NULLSTELLE NICHT GEFUNDEN.                    *              
C             = 1, NULLSTELLE LIEGT ZWISCHEN X1 UND X2  (MAN     *              
C                  NEHME DENJENIGEN DER BEIDEN WERTE, DESSEN     *              
C                  FUNKTIONSWERT DEN KLEINEREN BETRAG HAT).      *              
C                  DER ABSOLUTE FEHLER FUER DIE NULLSTELLE IST   *              
C                  KLEINER ODER GLEICH ABS(X1-X2).               *              
C             = 2, X2 IST NULLSTELLE MIT F2=0.0 ( MASCHINENNULL )*              
C             = 3, X3 IST NULLSTELLE MIT ABS(F3) < 4*MASCHINEN-  *              
C                  RUNDUNGSFEHLER.                               *              
C             = 4, NULLSTELLE LIEGT BEI X2 ( EINSCHLUSSINTERVALL *              
C                  NICHT  ANGEBBAR ).                            *              
C             = 5, ZULAESSIGE ANZAHL DER FUNKTIONSAUSWERTUNGEN   *              
C                  ( NMAX ) UEBERSCHRITTEN.                      *              
C             = 6, ABSERR ODER RELERR IST NEGATIV ODER BEIDE     *              
C                  SIND GLEICH NULL, NMAX < 1.                   *              
C                                                                *              
C                                                                *              
C  HILFSPARAMETER :                                              *              
C  ================                                              *              
C  IHILF1,IHILF2 : HILFSVARIABLEN.                               *              
C                                                                *              
C----------------------------------------------------------------*              
C                                                                *              
C  BENOETIGTE UNTERPROGRAMME: TAUSCH, PEG, PEGK, ANDBJ, ANDBJK,  *              
C                             UP1, UP2, MASCH                    *              
C                                                                *              
C                                                                *              
C  QUELLEN : 1. ANDERSON/BJOERCK, SIEHE [ANDE73].                *              
C            2. DOWELL/JARRAT, SIEHE [DOWE71], [DOWE72].         *              
C            3. KING, SIEHE [KING73].                            *              
C            4. UNVEROEFFENTLICHTE MITTEILUNG VON R. WODICKA,    *              
C               RWTH AACHEN.                                     *              
C                                                                *              
C*****************************************************************              
C                                                                *              
C  AUTOR     : GISELA ENGELN-MUELLGES                            *              
C  DATUM     : 26.08.1985                                        *              
C  QUELLCODE : FORTRAN 77                                        *              
C                                                                *              
C*****************************************************************              
C                                                                               
C  FALLS ZWEI GLEICHE STARTWERTE VORGEGEBEN SIND (X1=X2), WIRD                  
C  EIN ZWEITER STARTWERT KUENSTLICH KONSTRUIERT.                                
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                    
                                                       
      IF(X1.EQ.X2)THEN         
         X1=X1+DELX                                  
      END IF                         
C                                                                               
C  VORBESETZEN DER PARAMETER IFEHL UND IZAEHL .                                 
C                                                                               
      IFEHL=1                                        
      IZAEHL=2                                           
C                                                                               
C  BERECHNUNG DES MASCHINENRUNDUNGSFEHLERS FMACHN.                              
C                                                                               
      FMACHN=1.0D0                                     
   10 FMACHN=0.5D0*FMACHN                                    
      IF(MASCH(1.0D0+FMACHN).EQ.1) GOTO 10               
      FMACHN=2.0D0*FMACHN                                  
C                                                                               
C  PRUEFUNG DER VORAUSSETZUNGEN BEZUEGLICH DER FEHLERGROESSEN.                  
C                                                                               
      IF(ABSERR.GE.0..AND.RELERR.GE.0..AND.ABSERR+RELERR         
     +   .GT.0..AND.NMAX.GE.1) GOTO 20                         
      IFEHL=6                                                  
      RETURN                                                       
   20 HILF=4.0D0*FMACHN                                        
      IF(RELERR.EQ.0.)THEN                                     
         IF(ABSERR.LT.HILF) ABSERR=HILF                      
      ELSE IF(ABSERR.EQ.0.)THEN                            
         IF(RELERR.LT.HILF) RELERR=HILF                    
      ELSE                                                   
         IF(ABSERR.LT.HILF) ABSERR=HILF                          
         IF(RELERR.LT.HILF) RELERR=HILF                      
      END IF                                   
C                                                                               
C  BERECHNUNG DER FUNKTIONSWERTE AN DEN STARTSTELLEN.                           
C                                                                               
      F1=FKT(X1)
      F2=FKT(X2)                                           
C                                                                               
C  NUMERIERUNG DER NULLSTELLEN SO, DASS ABS(F2) <= ABS(F1) GILT.                
C                                                                               
      IF(ABS(F2).GT.ABS(F1))THEN                             
         CALL TAUSCH(X1,X2,F1,F2)                              
      END IF                                             
C                                                                               
C  PRUEFEN, OB X2 BEREITS NULLSTELLE IST MIT F2=0.0 (MASCHINEN-                 
C  NULL) UND DAMIT IFEHL=2.                                                     
C                                                                               
      IF(F2.EQ.0.0D0)THEN                                            
         IFEHL=2                                                 
         RETURN                                                  
      END IF                                             
C                                                                               
C  PRUEFEN, OB DIE STARTWERTE X1,X2 DIE NULLSTELLE EINSCHLIESSEN.               
C  FALLS EINSCHLUSS VORHANDEN, WERDEN DIE INTERNEN VARIABLEN                    
C  IEIN=1, IHILF2=1 GESETZT, ANDERNFALLS IEIN=0.                                
C  IHILF2=1 BEDEUTET, DASS DER NAECHSTE ITERATIONSSCHRITT                       
C  EIN SEKANTENSCHRITT IST.                                                     
C                                                                               
      IF(F1*F2.GT.0.0D0)THEN                                   
         IEIN=0                                                
         F3=F2                                                 
      ELSE                                                       
         IEIN=1                                              
         IHILF2=1                                            
      END IF                                               
      IEINST=IEIN                                      
C                                                                               
C  ITERATIONSSCHLEIFE FUER DIE ERZEUGUNG EINES NEUEN NAEHERUNGS-                
C  WERTES X3. DABEI WIRD UNTERSCHIEDEN, OB EINSCHLUSS VORHANDEN                 
C  IST ODER NICHT. DER NEUE NAEHERUNGSWERT X3 IST DIE NULLSTELLE                
C  DER VERBINDUNGSGERADEN VON (X2,F2) UND (X1,F1). FALLS KEIN                   
C  SEKANTENSCHRITT ERFOLGT, WIRD F1 ABGEAENDERT UND ZWAR IM                     
C  FALLE VON EINSCHLUSS MIT HILFE EINES DER SPEZIELLEN VERFAHREN;               
C  ANDERNFALLS MIT HILFE QUADRATISCHER EXTRAPOLATION (SIEHE OBEN).              
C                                                                               
   30 IF(IEIN.EQ.0)THEN                                      
         F1DF2=F1/F2                                 
         IF(F1DF2.GT.1.0D0)THEN                      
C                                                                               
C     ABFRAGE, OB NUR LINEARE EXTRAPOLATION ZUGELASSEN IST                      
C     ODER AUCH QUADRATISCHE.                                                   
C                                                                               
            IF(IEXTRA.EQ.0)THEN                            
               IF((F1DF2-F1/F3).GT.1.0D0)THEN          
                  G=1.0D0-F2/F3                        
                  F1=G*F1                                
               END IF                                
            END IF                             
         ELSE                                  
C                                                                               
C     JETZT IST F1/F2 <= 1. . WENN SOGAR F1/F2 < 0. IST, DANN IST               
C     EINSCHLUSS VORHANDEN.                                                     
C                                                                               
            IF(F1DF2.LT.0.)THEN                        
               IEIN=1                                      
               IF(ABS(X1-X2).LE.ABS(X2)*RELERR+ABSERR)THEN 
                  IFEHL=1                        
                  RETURN                                   
               ELSE                                    
                  IHILF2=1                                 
               END IF                                      
            ELSE                                     
C                                                                               
C     IST KEIN EINSCHLUSS VORHANDEN,SO KANN WEGEN ABS(F1)<=ABS(F2)              
C     EINE NULLSTELLE NICHT GEFUNDEN WERDEN.                                    
C                                                                               
               IFEHL=0                                     
               RETURN                                        
            END IF                                         
         END IF                                                
      END IF                                           
C                                                                               
C  BERECHNUNG DES SKALIERUNGSFAKTORS Q FUER X3=X2+Q(X1-X2).                     
C                                                                               
      Q=F2/(F2-F1)                                           
C                                                                               
C  BERECHNUNG DES NEUEN NAEHERUNGSWERTES.                                       
C                                                                               
      X3=X2+Q*(X1-X2)                                        
C                                                                               
C  NUN WIRD GEPRUEFT, OB DER NEUE NAEHERUNGSWERT X3 VON X1 UND X2               
C  VERSCHIEDEN IST. IST ER DAS NICHT, SO WIRD FUER X3 EIN ERSATZ-               
C  WERT X3NEU BERECHNET. FALLS KEIN EINSCHLUSS VORHANDEN IST UND                
C  UND MAN X2=X3=X3NEU ERHAELT, WIRD DAS VERFAHREN MIT IFEHL=4                  
C  (NULLSTELLE LIEGT BEI X2)  BEENDET.                                          
C                                                                               
      IF(IEIN.EQ.0)THEN                                          
         IF(X2.EQ.X3)THEN                                        
            X3NEU=X2+(X2-X1)/9.0D0                               
            IF(X2.EQ.X3NEU)THEN                                  
               IFEHL=4                                         
               RETURN                                          
            ELSE                                           
               X3=X3NEU                                          
            END IF                                               
         ELSE                                                  
            IF(X2.EQ.X3)THEN                                   
               X3NEU=X2+(X1-X2)/3.0D0                            
               IF(X2.EQ.X3NEU)THEN                               
                  IFEHL=1                                      
                  RETURN                                         
               ELSE                                            
   40             Q=2.*Q                                         
                  X3NEU=X2+Q*(X1-X2)                           
                  IF(X3NEU.EQ.X2) GOTO 40                      
                  IF(X3NEU.EQ.X1)THEN                            
                     IFEHL=1                                   
                     RETURN                                  
                  ELSE                                         
                     X3=X3NEU                                  
                  END IF                                         
               END IF                                            
            ELSE                                               
               IF(X1.EQ.X3)THEN                                
                  X3NEU=X1+(X2-X1)/3.                            
                  IF(X3NEU.EQ.X1)THEN                                
                     IFEHL=1                             
                     RETURN                                      
                  ELSE                                           
                     Q=F1/(F1-F2)                                
   50                Q=2.0D0*Q                                 
                     X3NEU=X1+Q*(X2-X1)                              
                     IF(X3NEU.EQ.X1) GOTO 50                   
                     IF(X3NEU.EQ.X2)THEN                           
                        IFEHL=1                                    
                        RETURN                                     
                     ELSE                                        
                        X3=X3NEU                                     
                     END IF                                        
                  END IF                                           
               END IF                                              
            END IF                                               
         END IF                                                
      END IF                                                 
C                                                                               
C  JETZT IST X3 VON X1 UND X2 VERSCHIEDEN, UND ES WIRD F3 BERECHNET.            
C                                                                               
      F3=FKT(X3)                                                 
C                                                                               
C  ERHOEHUNG DES ZAEHLERS DER FUNKTIONSAUSWERTUNGEN.                            
C                                                                               
      IZAEHL=IZAEHL+1                                                
C                                                                               
C  PRUEFUNG, OB DER BETRAG VON F3 DAS VIERFACHE DES MASCHINEN-                  
C  RUNDUNGSFEHLERS UNTERSCHREITET. DANN IST X3 NULLSTELLE MIT                   
C  IFEHL=3.                                                                     
C                                                                               
      IF(ABS(F3).LT.4.0D0*FMACHN)THEN                                
         IFEHL=3                                                 
         RETURN                                                      
      END IF                                                         
C                                                                               
C  PRUEFUNG, OB DIE MAXIMALE ANZAHL DER FUNKTIONSAUSWERTUNGEN                   
C  UEBERSCHRITTEN IST.                                                          
C                                                                               
      IF(IZAEHL.GE.NMAX)THEN                                     
         IFEHL=5                                                 
         RETURN                                                    
      END IF                                                     
C                                                                               
C  IM FOLGENDEN WERDEN DIE NAEHERUNGSWERTE UND DIE ZUGEHOERIGEN                 
C  FUNKTIONSWERTE MIT HILFE DES UNTERPROGRAMMS TAUSCH UMGESPEI-                 
C  CHERT. FALLS F2*F3 > 0., WIRD DIE HILFSVARIABLE IHILF1=0                     
C  GESETZT, IM FALLE F2*F3 < 0. WIRD IHILF1=1 GESETZT.                          
C                                                                               
      IF(IEIN.EQ.0)THEN                                            
         CALL TAUSCH(X1,X2,F1,F2)                                  
      ELSE                                                         
         IF(F2*F3.LT.0.0D0)THEN                                  
            CALL TAUSCH(X1,X2,F1,F2)                               
            IHILF1=1                                             
         ELSE                                                      
            IHILF1=0                                               
         END IF                                                      
      END IF                                                     
      CALL TAUSCH(X2,X3,F2,F3)                                       
C                                                                               
C  IST EINSCHLUSS VORHANDEN, SO WIRD GEPRUEFT, OB DIE ABBRUCH-                  
C  BEDINGUNG FUER DAS NEUE EINSCHLUSSINTERVALL ERFUELLT IST.                    
C  IST DIE ABBRUCHBEDINGUNG NICHT ERFUELLT, SO WIRD MIT HILFE                   
C  EINES DER SPEZIELLEN VERFAHREN F1 ERMITTELT.                                 
C  IST DIE ABBRUCHBEDINGUNG ERFUELLT, SO WIRD DIE ITERATION                     
C  MIT IFEHL=1 BEENDET.                                                         
C                                                                               
      IF(IEIN.EQ.1)THEN                                              
         IF(ABS(X1-X2).GT.ABS(X2)*RELERR+ABSERR)THEN               
            IF(IMETH.EQ.1)THEN                                 
               CALL PEG(IHILF1,F1,F2,F3)                           
            ELSE IF(IMETH.EQ.2)THEN                                  
               CALL PEGK(IHILF1,IHILF2,F1,F2,F3)                     
            ELSE IF(IMETH.EQ.3)THEN                              
               CALL ANDBJ(IHILF1,F1,F2,F3)                         
            ELSE                                                   
               CALL ANDBJK(IHILF1,IHILF2,F1,F2,F3)                 
            END IF                                               
         ELSE                                                        
            IFEHL=1                                              
            RETURN                                                 
         END IF                                                    
      END IF                                                     
      GOTO 30                                                      
      END                                                        
C                                                                               
C                                                                               
      SUBROUTINE PEG(IHILF1,F1,F2,F3)                  
C                                                                               
C*****************************************************************              
C                                                                *              
C  DIESES UNTERPROGRAMM VERWENDET DAS PEGASUS-VERFAHREN ZUR      *              
C  BERECHNUNG EINES NEUEN FUNKTIONSWERTES F1 FUER DAS RAHMEN-    *              
C  NULLSTELLENPROGRAMM NULLST.                                   *              
C                                                                *              
C                                                                *              
C  EINGABEPARAMETER :                                            *              
C  ==================                                            *              
C  IHILF1   : HILFSVARIABLE, DIE VOM RAHMEN-NULLSTELLENPRO-      *              
C              GRAMM UEBERGEBEN WIRD.                            *              
C  F1,F2,F3 : FUNKTIONSWERTE FKT(X1), FKT(X2), FKT(X3).          *              
C                                                                *              
C                                                                *              
C  AUSGABEPARAMETER :                                            *              
C  ==================                                            *              
C  F1       : NEUER FUNKTIONSWERT AN DER STELLE X1.              *              
C                                                                *              
C----------------------------------------------------------------*              
C                                                                *              
C  BENOETIGTE UNTERPROGRAMME: UP1                                *              
C                                                                *              
C                                                                *              
C  QUELLEN : DOWELL/JARRAT, SIEHE [DOWE71], [DOWE72].            *              
C                                                                *              
C*****************************************************************              
C                                                                *              
C  AUTOR     : GISELA ENGELN-MUELLGES                            *              
C  DATUM     : 26.08.1985                                        *              
C  QUELLCODE : FORTRAN 77                                        *              
C                                                                *              
C*****************************************************************              
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                                    
                                                                                
                                                                                
      IF(IHILF1.EQ.0)THEN                                      
         CALL UP1(F1,F2,F3)                              
      END IF                                                     
      RETURN                                                   
      END                                                  
C                                                                               
C                                                                               
C                                                                               
      SUBROUTINE PEGK(IHILF1,IHILF2,F1,F2,F3)                    
C                                                                               
C*****************************************************************              
C                                                                *              
C  DIESES UNTERPROGRAMM VERWENDET EINE VON KING VERBESSERTE      *              
C  VERSION DES PEGASUS-VERFAHRENS ZUR BERECHNUNG EINES NEUEN     *              
C  FUNKTIONSWERTES F1 FUER DAS RAHMEN-NULLSTELLENPROGRAMM        *              
C  NULLST.                                                       *              
C                                                                *              
C                                                                *              
C  EINGABEPARAMETER :                                            *              
C  ==================                                            *              
C  IHILF1   : )  HILFSVARIABLEN, DIE VOM RAHMEN-NULLSTELLEN-     *              
C  IHILF2   : )  PROGRAMM UEBERGEBEN WERDEN.                     *              
C  F1,F2,F3 : FUNKTIONSWERTE FKT(X1),FKT(X2), FKT(X3).           *              
C                                                                *              
C                                                                *              
C  AUSGABEPARAMETER :                                            *              
C  ==================                                            *              
C  F1       : NEUER FUNKTIONSWERT AN DER STELLE X1.              *              
C                                                                *              
C----------------------------------------------------------------*              
C                                                                *              
C  BENOETIGTE UNTERPROGRAMME: UP1                                *              
C                                                                *              
C                                                                *              
C  QUELLEN : VERFAHREN VON KING, SIEHE [KING73].                 *              
C                                                                *              
C*****************************************************************              
C                                                                *              
C  AUTOR     : GISELA ENGELN-MUELLGES                            *              
C  DATUM     : 26.08.1985                                        *              
C  QUELLCODE : FORTRAN 77                                        *              
C                                                                *              
C*****************************************************************              
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                                    
                                                               
      IF(IHILF2.EQ.1)THEN                                        
         IHILF2=0                                                
         CALL UP1(F1,F2,F3)                              
      ELSE IF(IHILF1.EQ.0)THEN                                   
         CALL UP1(F1,F2,F3)                                      
      ELSE                                                       
         IHILF2=1                                                
      END IF                                                       
      RETURN                                                   
      END                                                      
C                                                                               
C                                                                               
C                                                                               
      SUBROUTINE ANDBJ(IHILF1,F1,F2,F3)                       
C                                                                               
C*****************************************************************              
C                                                                *              
C  DIESES UNTERPROGRAMM VERWENDET DAS VERFAHREN VON              *              
C  ANDERSON / BJOERCK ZUR BERECHNUNG EINES NEUEN FUNKTIONS-      *              
C  WERTES F1 FUER DAS RAHMEN-NULLSTELLENPROGRAMM NULLST.         *              
C                                                                *              
C                                                                *              
C  EINGABEPARAMETER :                                            *              
C  ==================                                            *              
C  IHILF1   : HILFSVARIABLE, DIE VOM RAHMEN-NULLSTELLENPRO-      *              
C             GRAMM UEBERGEBEN WIRD.                             *              
C  F1,F2,F3 : FUNKTIONSWERTE FKT(X1), FKT(X2), FKT(X3).          *              
C                                                                *              
C                                                                *              
C  AUSGABEPARAMETER :                                            *              
C  ==================                                            *              
C  F1       : NEUER FUNKTIONSWERT AN DER STELLE X1.              *              
C                                                                *              
C----------------------------------------------------------------*              
C                                                                *              
C  BENOETIGTE UNTERPROGRAMME: UP2                                *              
C                                                                *              
C                                                                *              
C  QUELLEN : VERFAHREN VON ANDERSON/BJOERCK, SIEHE [ANDE73].     *              
C                                                                *              
C*****************************************************************              
C                                                                *              
C  AUTOR     : GISELA ENGELN-MUELLGES                            *              
C  DATUM     : 26.08.1985                                        *              
C  QUELLCODE : FORTRAN 77                                        *              
C                                                                *              
C*****************************************************************              
C                                                                *              
      IMPLICIT REAL*8 (A-H,O-Z)                           
                                                                 
      IF(IHILF1.EQ.0)THEN                                      
           CALL UP2(F1,F2,F3)                                  
      END IF                                                   
      RETURN                                             
      END                                                      
C                                                                               
C                                                                               
      SUBROUTINE ANDBJK(IHILF1,IHILF2,F1,F2,F3)              
C                                                                               
C*****************************************************************              
C                                                                *              
C  DIESES UNTERPROGRAMM VERWENDET EINE VON KING VORGESCHLAGENE   *              
C  KOMBINATION DER VERFAHREN VON ANDERSON/BJOERCK UND KING ZUR   *              
C  BERECHNUNG EINES NEUEN FUNKTIONSWERTES F1 FUER DAS RAHMEN-    *              
C  NULLSTELLENPROGRAMM NULLST.                                   *              
C                                                                *              
C                                                                *              
C  EINGABEPARAMETER :                                            *              
C  ==================                                            *              
C  IHILF1   : )  HILFSVARIABLEN, DIE VOM RAHMEN-NULLSTELLEN-     *              
C  IHILF2   : )  PROGRAMM UEBERGEBEN WERDEN.                     *              
C  F1,F2,F3 : FUNKTIONSWERTE FKT(X1), FKT(X2), FKT(X3).          *              
C                                                                *              
C                                                                *              
C  AUSGABEPARAMETER :                                            *              
C  ==================                                            *              
C  F1       : NEUER FUNKTIONSWERT AN DER STELLE X1.              *              
C                                                                *              
C----------------------------------------------------------------*              
C                                                                *              
C  BENOETIGTE UNTERPROGRAMME: UP2                                *              
C                                                                *              
C                                                                *              
C  QUELLEN : 1. VERFAHREN VON ANDERSON/BJOERCK, SIEHE [ANDE73].  *              
C            2. VERFAHREN VON KING, SIEHE [KING73].              *              
C                                                                *              
C*****************************************************************              
C                                                                *              
C  AUTOR     : GISELA ENGELN-MUELLGES                            *              
C  DATUM     : 26.08.1985                                        *              
C  QUELLCODE : FORTRAN 77                                        *              
C                                                                *              
C*****************************************************************              
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                                
                                                                 
      IF(IHILF2.EQ.1)THEN                                      
         IHILF2=0                                            
         CALL UP2(F1,F2,F3)                                    
      ELSE IF(IHILF1.EQ.0)THEN                               
         CALL UP2(F1,F2,F3)                                      
      ELSE                                                      
         IHILF2=1                                          
      END IF                                                   
      RETURN                                                   
      END                                                      
C                                                                               
C                                                                               
      SUBROUTINE TAUSCH(X,Y,FX,FY)                       
C                                                                               
C*****************************************************************              
C                                                                *              
C  DIESES UNTERPROGRAMM VERTAUSCHT X MIT Y UND FX MIT FY.        *              
C                                                                *              
C*****************************************************************              
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                              
                                                                 
      HILF=X                                                       
      X=Y                                                            
      Y=HILF                                                   
      HILF=FX                                                    
      FX=FY                                                      
      FY=HILF                                                  
      RETURN                                                   
      END                                                     
C                                                                               
C                                                                               
      SUBROUTINE UP1(F1,F2,F3)                           
C                                                                               
C*****************************************************************              
C                                                                *              
C  HILFSROUTINE FUER DIE UNTERPROGRAMME PEG UND PEGK.            *              
C                                                                *              
C*****************************************************************              
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                                      
                                                                   
      G=F3/(F2+F3)                                                


      F1=G*F1                                                    
      RETURN                                                     
      END                                                    
C                                                                               
C                                                                               
      SUBROUTINE UP2(F1,F2,F3)                               
C                                                                               
C*****************************************************************              
C                                                                *              
C  HILFSROUTINE FUER DIE UNTERPROGRAMME ANDBJ UND ANDBJK.        *              
C                                                                *              
C*****************************************************************              
C                                                                               
      IMPLICIT REAL*8 (A-H,O-Z)                                
                                                             
      G=1.0D0-F2/F3                                              
      IF(G.LE.0.)THEN                                            
         G=0.5D0                                                 
      END IF                                                       
      F1=G*F1                                                   
      RETURN                                                 
      END                                                      
                                                               
      INTEGER FUNCTION MASCH(X)                                  
                                                                 
      IMPLICIT REAL*8 (A-H,O-Z)                                
                                                               
      MASCH = 0                                                
      IF (1.0.LT.X) MASCH = 1                                    
      RETURN                                                   
      END                                                  
                                                                                
C                                                                               
C --------------------------------------------------------------------          
C                                                                               
                                                                 
       DOUBLE PRECISION FUNCTION FKT(TT)  

       Parameter(NLHT=15)
       Parameter(NPAR=416)
       Parameter(NMAX1=800)      
       Parameter(nco=50)

       IMPLICIT DOUBLE PRECISION (A-H,O-Z)   

       COMMON /XNULL/ XCD(NLHT+NPAR),XCDD(NLHT+NPAR),
     >                XCOLR(NLHT+NPAR), 
     >                XBETA,XSINTL,XSINTR,XTAUDL,
     >                XTAUDR,XXNTOT,
     >                XHDEN,XH2DEN,XCOSRAY,XTHRES 
 
       NR = NLHT+NPAR                         
       CALL HTCL(TT,XCD,XCDD,NR,XBETA,XSINTL,XSINTR,XTAUDL,
     >         XTAUDR,XXNTOT,ETOT,XCOLR,XHDEN,XH2DEN,XCOSRAY,XTHRES)
       FKT = ETOT 
       Return                                            
       END                                                      
                                                         
 




