       
       Subroutine COLDR(ZG,COLR,ZTOT,XNTOT) 
                         
       Parameter(NMAX1=800)
       Parameter(NLHT=15)
       Parameter(NPAR=416)

       Implicit Double Precision (A-H,O-Z)

       COMMON /Xint/  XHelp,ZG1,NARZ,Iter
     
       Dimension XHELP(NMAX1,NLHT+NPAR),ZG1(NMAX1),
     >           XHELP1(NMAX1),COLR(NLHT+NPAR)
     
       Integer ITER

       If(iter.eq.1) then
         Do 10 i=1,NLHT+NPAR
         COLR(i) = 0.0d0
10       continue

       Else
         Do 20 i=1,NLHT+NPAR
           Do 30 j = 1,NARZ 
             XHELP1(J) = XHELP(J,I)
30         continue           
           CAll Inter(ZG,XNH2,XHELP1,ZG1,NARZ,ITER)
           COLR(i) = Xhelp(NARZ,I)-XNH2
           ZGA     = ZTOT-ZG
           If(ZGA.lt.1.0d12) COLR(i) = 0.0d0

321 	format(4(3pe10.3))
20       continue 
C       stop
C      write(*,*) 'jetzt',colr
       Endif
       Return
       End
             
       Subroutine Inter(Z,XNH2,XHELP1,ZG1,NARZ,ITER)

C      Input geometrical location z, Output XNH2 column-density
C      XNH2 at that place

       Implicit Double Precision (A-H,O-Z)	

       Parameter(NMAX1=800)

       REAL*8  XHelp1(NMAX1),ZG1(NMAX1)
       Integer NARZ

       Ztot = ZG1(NARZ)
C      Search neighboured points of Z
       IF(Z.le.1.0d-6) then
         XNH2 = 0.0d0
C        Write(*,*) 'XNH2 =',XNH2,'Z = ',z
       Elseif(abs(Z-Ztot)/Ztot.lt.1.0d-7) then
         XNH2 = XHELP1(NARZ)
       Else
C        Write(*,*) 'Z =',Z
         Call Locate(ZG1,NARZ,Z,J)
C        Write(*,*) 'J=',j,'ZG1(JJ+1) =',ZG1(J+1),'ZG1(J) =',ZG1(J)
C        Linear interpolation in ln
         IF(XHELP1(j).eq.0.0d0.or.XHELP1(J+1).eq.0.0d0) then
           a1   = (XHELP1(J)-XHELP1(J+1))/(ZG1(J+1)-ZG1(J))
           XNH2 = XHELP1(J) - a1*(Z-ZG1(j))
         Else
           a1   = (log(XHELP1(J))-log(XHELP1(J+1)))/(ZG1(J+1)-ZG1(J))
           XNH2 = log(XHELP1(J)) - a1*(Z-ZG1(j))
           XNH2 = dexp(XNH2)
         Endif
C        Write(*,*) 'XHELP1(J) =',XHELP1(j)
C        Write(*,*) 'XHELP1(J+1) =',XHELP1(j+1)
C        Write(*,*) 'XNH2 =',XNH2
       ENDif
C      Iter = Iter + 1
C      If(Iter.gt.100) stop
       RETURN                                                           
       END                                                              
	


       Subroutine Locate(XX,N,X,J)

C      See Numerical-Recipes page 90

       Implicit Double Precision (A-H,O-Z)	

       Real*8 XX(N)

       JL = 0
       JU = N+1
10     IF(JU-JL.GT.1) then
         JM=(JU+JL)/2
         IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM))) Then
           JL=JM
         Else
           JU=JM
         ENDIF
         GOTO 10
       ENDIF
       J=JL
       RETURN
       END
