       SUBROUTINE MMID(Y,DYDX,NVAR,XS,HBIG,NSTEP,YOUT,DERIVS,           
     >                 T,HDEN,H2DEN,KK)                                 
C                                                                       
C      MODIFIED MIDPOINT STEP.                                          
C                                                                       
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
       PARAMETER (NMAX=900)                                             
       DIMENSION Y(NVAR),DYDX(NVAR),YOUT(NVAR),YM(NMAX),YN(Nmax)    
 
       External Derivs       
       
       H=HBIG/NSTEP                                                     
       DO 11, I=1,NVAR                                                  
          YM(I)=Y(I)                                                    
          YN(I)=Y(I)+H*DYDX(I)                                          
11     CONTINUE                                                         
       X=XS+H                                                           
       CALL DERIVS(X,YN,YOUT,NVAR,T,HDEN,H2DEN)                         
       KK=KK+1                                                          
       H2=2.D0*H 
       DO 13, N=2,NSTEP                                                 
          DO 12, I=1,NVAR                                               
C            WRITE(5,98) I,YOUT(I)                                      
98           FORMAT(2X,I4,2X,1PE10.3)                                   
             SWAP=YM(I)+H2*YOUT(I)                                      
             YM(I)=YN(I)                                                
             YN(I)=SWAP                                                 
12        CONTINUE                                                      
          X=X+H                                                         
          CALL DERIVS(X,YN,YOUT,NVAR,T,HDEN,H2DEN)                      
          KK=KK+1                                                       
13     CONTINUE                                                         
       DO 14, I=1,NVAR                                                  
          YOUT(I)=0.5D0*(YM(I)+YN(I)+H*YOUT(I))
14     CONTINUE                                                         
       RETURN                                                           
       END                                                              
C                                                                       
C                                                                       
C                                                                       
       SUBROUTINE BSSTEP(Y,DYDX,NV,NY,X,HTRY,EPS,YSCAL,HDID,HNEXT,  
     >            DERIVS,T,HDEN,H2DEN,KK)                               
C                                                                       
C      BULIRSCH-STOER STEP WITH MONITORING OF LOCAL TRUNCATION ERROR.   
C                                                                       
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
       PARAMETER(NMAX=900,LMAX=242,                                     
     >       IMAX=11,NUSE=7,ONE=1.0D0,SHRINK=0.95D0,GROW=1.2D0) 
       DIMENSION Y(NV),DYDX(NV),YSCAL(NY),EPS(NY),YERR(Nmax),           
     >           YSAV(Nmax),DYSAV(Nmax),YSEQ(Nmax),NSEQ(IMAX)           
       DATA NSEQ /2,4,6,8,12,16,24,32,48,64,96/                         

       EXTERNAL DERIVS

       H=HTRY                                                           
       XSAV=X                                                           
	if (T.eq.150) write(*,*) T 
       DO 11, I=1,NV                                                    
          YSAV(I)=Y(I)                                                  
          DYSAV(I)=DYDX(I)                                              
11     CONTINUE                                                         
       TP=T                                                             
       HDENP=HDEN                                                       
       H2DENP=H2DEN                                                     
1      DO 10, I=1,IMAX                                                  
          T=TP                                                          
          HDEN=HDENP                                                    
          H2DEN=H2DENP                                                  
          CALL MMID(YSAV,DYSAV,NV,XSAV,H,NSEQ(I),YSEQ,DERIVS,           
     >              T,HDEN,H2DEN,KK)                                    
          XEST=(H/NSEQ(I))**2.D0 
C         PRINT*,'y(3)=',Y(3)                                          
          CALL PZEXTR(I,XEST,YSEQ,Y,YERR,NV,NUSE)  
C         PRINT*,'y(3)=',Y(3)                     
          ERRMAX=0.D0        
CB	  write(*,*) 'eps(15),H2 Level =',eps(15)
CB	  write(*,*) 'eps(25),data SS =',eps(25)
CB	  write(*,*) 'eps(75),12CO-Level =',eps(75)
CB	  write(*,*) 'eps(120),3Level O-Atom =',eps(120)
CB	  write(*,*) 'eps(170),13CO-Level =',eps(170)
CB	  write(*,*) 'eps(178),Si+-Level =',eps(178)
          DO 12, J=1,NY                                                 
            ERRMAX=MAX(ERRMAX,ABS(YERR(J)/(EPS(J)*YSCAL(J)))) 
12        CONTINUE                                                      
CC        ERRMAX=ERRMAX/EPS                                             
          IF(ERRMAX .LT. ONE) THEN                                      
             X=X+H                                                      
             HDID=H                                                     
             IF (I .EQ. NUSE) THEN                                      
                HNEXT=H*SHRINK                                          
             ELSE IF (I .EQ. NUSE-1) THEN                               
                HNEXT=H*GROW                                            
             ELSE                                                       
                HNEXT=(H*NSEQ(NUSE-1))/NSEQ(I)                          
             END IF
CB **************************************************************
	     hnext = hnext/2	
CB            write(*,*) 'am Ende von bsstep'
            RETURN                                                     
          END IF                                                        
10     CONTINUE                                                         
       H=0.25D0*H/2.0d0**((IMAX-NUSE)/2) 
       IF(X+H .EQ. X) PAUSE 'STEP SIZE UNDERFLOW'                       
       GO TO 1                                                          
C      X=X+H                                                            
C      HNEXT=(H*NSEQ(NUSE-1))/NSEQ(3)                                   
C      RETURN                                                           
       END                                                              
C                                                                       
C                                                                       
C                                                                       
       SUBROUTINE RZEXTR(IEST,XEST,YEST,YZ,DY,NV,NUSE) 

       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
       PARAMETER (IMAX=11,NMAX=900,NCOL=7)                              
       DIMENSION X(IMAX),YEST(NV),YZ(NV),DY(NV),D(NMAX,NCOL),
     >           FX(NCOL)  
      
       X(IEST)=XEST         

C      write(*,*) iest
C       write(*,*) xest
C       write(*,*) yest
C       write(*,*) yz
C       write(*,*) dy
C       write(*,*) nv
C       write(*,*) nuse

C      write(*,*) 'in YZ(3) =',YZ(3)                                            
       IF(IEST .EQ. 1) THEN                                             
          DO 11, J=1,NV                                                 
             YZ(J)=YEST(J)                                              
             D(J,1)=YEST(J)                                             
             DY(J)=YEST(J)   
C            write(*,*) 'D(J,1) =', D(j,1)                                           
11        CONTINUE                                                      
       ELSE                                                             
          M1=MIN(IEST,NUSE) 
C         write(*,*) 'M1 =',M1                                            
          DO 12, K=1,M1-1     
C            write(*,*) iest,k
C            write(*,*) 'Xest =',Xest,'X(IEST-K) =',X(iest-k)                                          
             FX(K+1)=X(IEST-K)/XEST                                     
12        CONTINUE       
                                            
          DO 14, J=1,NV                                                 
             YY=YEST(J)                                                 
             V=D(J,1)                                                   
             C=YY                                                       
             D(J,1)=YY                                                  
             DO 13, K=2,M1  
                                             
                B1=FX(K)*V 
                                             
                B=B1-C          
 
C               IF(ABS(B).gt.1.0d-12) then                       
                IF(B .NE. 0.D0) THEN  
                   B=(C-V)/B 
                                          
                   DDY=C*B                                              
                   C=B1*B                                               
                ELSE                                                    
                   DDY=V                                                
                END IF                                                  
                V=D(J,K)                                                
                D(J,K)=DDY                                              
                YY=YY+DDY                                               
13           CONTINUE 
                                                  
             DY(J)=DDY                                                  
             YZ(J)=YY 
14        CONTINUE   
C      write(*,*) 'out YZ(3) =',YZ(3)                                                     
       END IF 
C      write(*,*) 'out YZ(3) =',YZ(3)                                                            
       RETURN                                                           
       END                                                              

       SUBROUTINE PZEXTR(IEST,XEST,YEST,YZ,DY,NV,NUSE)                  
C                                                                       
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
       PARAMETER (IMAX=11,NMAX=900,NCOL=7)                              
       DIMENSION X(IMAX),YEST(NV),YZ(NV),DY(NV),QCOL(NMAX,NCOL),
     >   D(NMAX)
       X(IEST)=XEST                
       DO 11, J=1,NV                                                 
         YZ(J)=YEST(J)                                              
         DY(J)=YEST(J)                                              
11     CONTINUE                                                      
       If(IEST.EQ.1) THEN
         Do 12 J=1,NV
           QCOL(J,1) = YEST(J)
12       continue
       else
         M1 = MIN(IEST,NUSE)
         Do 13 J=1,NV
           D(J) = YEST(J)
13       continue
         Do 15 K1 = 1,M1-1

           DELTA = 1.0d0/(X(IEST-K1)-XEST)  
           F1 = XEST*DELTA
           F2 = X(IEST-K1)*DELTA
           Do 14 J = 1,NV
             Q=QCOL(J,K1)
             QCOL(J,K1) = DY(j)
             DELTA = D(j)-Q
             DY(J)=F1*DELTA
             D(J)= F2*DELTA
             YZ(J)=YZ(J)+DY(J)
14           continue
15         continue
         Do 16 J=1,NV
           QCOL(J,M1) = DY(J)
16       continue
       endif
       return
       end
        
