      SUBROUTINE LUDCMP(A,N,NP,INDX,D)                                  
C                                                                       
C     LU DECOMPOSITION ALA BILL PRESS.                                  
C                                                                       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
      PARAMETER (NMAX=302,TINY=1.0D-20)                                 
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)                               
C                                                                       
      D=1.D0 
      DO 12, I=1,N                                                      
         AAMAX=0.D0 
         DO 11, J=1,N                                                   
            AAMAX=MAX(AAMAX,A(I,J))
CZ            IF(ABS(A(I,J)) .GT. AAMAX) AAMAX=ABS(A(I,J)
11       CONTINUE                                                       
       IF (AAMAX .EQ. 0.D0) then
 	write(*,*) 'N = ',n
	PAUSE 'SINGULAR MATRIX'                     
       endif
         VV(I)=1.D0/AAMAX 
12    CONTINUE                                                          
C                 
      DO 19, J=1,N                                                      
         IF(J .GT. 1) THEN                                              
            DO 14, I=1,J-1                                              
               SUM=A(I,J)                                               
               IF (I .GT. 1) THEN                                       
                  DO 13, K=1,I-1                                        
                     SUM=SUM-A(I,K)*A(K,J)                              
13                CONTINUE                                              
                  A(I,J)=SUM                                            
               END IF                                                   
14          CONTINUE                                                    
         END IF                                                         
         AAMAX=0.D0
         DO 16, I=J,N                                                   
            SUM=A(I,J)                                                  
            IF(J .GT. 1) THEN                                           
               DO 15, K=1,J-1                                           
                  SUM=SUM-A(I,K)*A(K,J)                                 
15             CONTINUE                                                 
               A(I,J)=SUM                                               
            END IF                                                      
            DUM=VV(I)*ABS(SUM)                                          
            IF(DUM .GE. AAMAX) THEN                                     
               IMAX=I                                                   
               AAMAX=DUM                                                
            END IF                                                      
16       CONTINUE                                                       
         IF(J .NE. IMAX) THEN                                           
            DO 17, K=1,N                                                
               DUM=A(IMAX,K)                                            
               A(IMAX,K)=A(J,K)                                         
               A(J,K)=DUM                                               
17          CONTINUE                                                    
            D=-D                                                        
            VV(IMAX)=VV(J)                                              
         END IF                                                         
         INDX(J)=IMAX                                                   
         IF(J .NE. N) THEN                                              
            IF(A(J,J) .EQ. 0.D0)  A(J,J)=TINY
            DUM=1.D0/A(J,J) 
            DO 18, I=J+1,N                                              
               A(I,J)=A(I,J)*DUM                                        
18          CONTINUE                                                    
         END IF                                                         
19    CONTINUE                                                          
      IF(A(N,N) .EQ. 0.D0) A(N,N)=TINY
      RETURN                                                            
      END                                                               
C                                                                       
C                                                                       
C                                                                       
C                                                                       
      SUBROUTINE LUBKSB(A,N,NP,INDX,B)                                  
C                                                                       
C     SOLVES N LINEAR EQUATIONS GIVEN LU DECOMPOSITION OF MATRIX.       
C                                                                       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
      DIMENSION A(NP,NP),INDX(N),B(N)                                   
      II=0                                                              
      DO 12, I=1,N                                                      
         LL=INDX(I)                                                     
         SUM=B(LL)                                                      
         B(LL)=B(I)                                                     
         IF(II .NE. 0) THEN                                             
            DO 11, J=II,I-1                                             
               SUM=SUM-A(I,J)*B(J)                                      
11          CONTINUE                                                    
         ELSE IF (SUM .NE. 0.D0) THEN
            II=I                                                        
         END IF                                                         
         B(I)=SUM                                                       
12       CONTINUE                                                       
         DO 14, I=N,1,-1                                                
            SUM=B(I)                                                    
            IF(I .LT. N) THEN                                           
               DO 13, J=I+1,N                                           
                  SUM=SUM-A(I,J)*B(J)                                   
13             CONTINUE                                                 
            END IF                                                      
            B(I)=SUM/A(I,I)                                             
14       CONTINUE                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C                                                                       
       SUBROUTINE MPROVE(A,ALUD,N,NP,INDX,B,X)                          
C                                                                       
C      ITERATIVE IMPROVEMENT OF SOLUTION TO LINEAR EQUATIONS.           
C                                                                       
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)                              
       PARAMETER (NMAX=100)                                             
       DIMENSION A(NP,NP),ALUD(NP,NP),INDX(N),B(N),X(N),R(NMAX)         
       DO 12, I=1,N                                                     
          SDP=-B(I)                                                     
          DO 11, J=1,N                                                  
             SDP=SDP+A(I,J)*X(J)                                        
11        CONTINUE                                                      
          R(I)=SDP                                                      
12     CONTINUE                                                         
       CALL LUBKSB(ALUD,N,NP,INDX,R)                                    
       DO 13, I=1,N                                                     
          X(I)=X(I)-R(I)                                                
13     CONTINUE                                                         
       RETURN                                                           
       END                                                              
