c.... 30.01.2003 M.Roellig
c....   Changes due to compilation on Linux/g77 rather than alpha
c....   standard g77 allows for 100 files to be opened
c....   -> unit numbers greater 100 are changed 
c....   Changes: write/open(653   --> write/open(83
c....   Changes: write/open(654   --> write/open(84
c....   Changes: write/open(651   --> write/open(81
c....   Changes: write/open(652   --> write/open(82
c....   Changes: write/open(102   --> write/open(22
c....   Changes: write/open(661   --> write/open(71
c....   Changes: write/open(662   --> write/open(72
c....   Changes: write/open(751   --> write/open(61
c....   Changes: write/open(752   --> write/open(62
c....   Changes: write/open(753   --> write/open(63
c....   Changes: write/open(754   --> write/open(64
c....   Changes: write/open(755   --> write/open(65
c....   Changes: write/open(756   --> write/open(66
c....   Changes: write/open(757   --> write/open(67
c....   Changes: write/open(758   --> write/open(68
c....   Changes: write/open(759   --> write/open(69
c....   Changes: write/open(760   --> write/open(70
c....   Changes: write/open(104   --> write/open(24
c....   Changes: write/open(105   --> write/open(25
c....   Changes: write/open(106   --> write/open(26

        Subroutine Xline(CDDST,ZGST,NAKT,Beta,
     >                   AV,XNTOT,SINT,zg2) 

C       Calculates line intensities on surface of 
C       finite slab.
C
C       Input: CDDST,ZGST,NAKT
C       ZGST  = Grid-points
C       CDDST = Densities at grid-points
C       NAKT  = Number of gridpoints
C       Beta  = line width
C       AV    = visual extinction
C       XNTOT = density
C       SINT  = strength of radiation field

	Parameter(NLHT=15)
        Parameter(NMAX1=800)
        Parameter(NPAR=416)
	Parameter (nco=50)      
        Parameter (NGRI=500)
	parameter (nlevel = 50)

	IMPLICIT DOUBLE PRECISION (A-H,O-Z)

 	COMMON /COMAT/ COA(NCO-1),COC(NCO,NCO),COE(NCO) 
	COMMON /CI/ CIDAT(16),CIDEN(3),CICOL(3),CITAU(3)
	COMMON /OXY/ OXYDAT(16),OXYDEN(3),OXYCOL(3),OXYTAU(3)
 
        DIMENSION CDDST(NMAX1,NLHT+NPAR),ZGST(NMAX1),
     >            CD12CO(NGRI,NCO),CD13CO(NGRI,NCO),CD18CO(NGRI,NCO),
     >            ZPGR(NMAX1),
     >            CO12A(NCO),CO12E(NCO),CO13A(NCO),CO13E(NCO),
     >            CO18A(NCO),CO18E(NCO),
     >            XIL12a(NGRI),XIL12b(NGRI),XIL12c(NGRI),
     >            XIL12d(NGRI),XIL12E(NGRI),XIL12F(NGRI),
     >            XIL13a(NGRI),XIL13b(NGRI),XIL13c(NGRI),
     >            XIL13d(NGRI),XIL13E(NGRI),XIL13F(NGRI),
     >            XIL18a(NGRI),XIL18b(NGRI),XIL18c(NGRI),
     >            XIL18d(NGRI),XIL18E(NGRI),XIL18F(NGRI),
     >            XTAU12(NGRI),XTAU13(NGRI),XTAU18(NGRI),XTAU(NGRI),
     >            ZG2(NMAX1),
     >            XIL12G(ngri,nlevel-1),XIL13G(ngri,nlevel-1),	 
     >            XIL12h(ngri,nlevel-1),XIL13h(ngri,nlevel-1),
     >            XIL18h(ngri,nlevel-1),XIL18G(ngri,nlevel-1),   
     >            sou12co(ngri,nlevel),sou13co(ngri,nlevel),
     >            cap12co(ngri,nlevel),cap13co(ngri,nlevel),
     >            sou18co(ngri,nlevel),cap18co(ngri,nlevel)

        
        Character*19 FNAME(5)       
        Integer NAKT

        
        Do 10 i = 69,69+NLEVEL-2
          CO12A(i-68) = COA(i-68)
10      continue

        
        CO12A(NLEVEL) = 0.0d0
        
        Do 20 i = 69,69+NLEVEL-1
          CO12E(i-68) = COE(i-68)
          Do 20 j = 1,NAKT
            CD12CO(j,i-68) = CDDST(j,i)
c            write(*,*) "CD12CO",j,i,CDDST(j,i)
20       continue

         
        Do 30 i = 127,127+NLEVEL-2
          CO13A(i-126) = COA(i-126)
30      continue

        
        CO13A(NLEVEL) = 0.0d0
        
        Do 40 i = 127,127+NLEVEL-1
          CO13E(i-126) = COE(i-126)
          Do 40 j = 1,Nakt
            CD13CO(j,i-126) = CDDST(j,i)
c             write(*,*) "CD13CO",j,i,CDDST(j,i)           
40      continue

        Do 42 i = 367,367+NLEVEL-2
          CO18A(i-126) = COA(i-126)
c...          CO18A(i-366) = COA(i-366)
42      continue

        CO18A(NLEVEL) = 0.0d0
        
        Do 45 i = 367,367+NLEVEL-1
          CO18E(i-366) = COE(i-366)
          Do 45 j = 1,Nakt
            CD18CO(j,i-366) = CDDST(j,i)
c             write(*,*) "CD18CO",j,i,CDDST(j,i)           
45       continue



        
        
        Do 50 i = 1,NAKT
          ZPGR(i) = ZGST(i)
50      continue
        Call XINTLC(NAKT,CD12CO,
     >           CO12E,Beta,CO12A,ZPGR,XIL12G,XIL12H,
     >           XIL12a,XIL12b,XIL12C,XIL12d,XIL12E,XIL12F,XTAU12,
     >           sou12co,cap12co)


        write(*,*) "12co line intensities"
        
        OPEN(84,file='sou12co.dat', STATUS='UNKNOWN')
        OPEN(83,file='cap12co.dat', STATUS='UNKNOWN')
        
        write(83,*) nakt  
        write(84,*) nakt

       do j = 1,nakt
         WRITE(84,3210) zg2(j),(SOU12CO(J,I),I=1,10) 
         WRITE(83,3210) zg2(j),(CAP12CO(J,I),I=1,10) 
       ENDDO
 3210  FORMAT(11(2X,1PE9.3))

	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME(1)(1:7)='12cothk'
        FNAME(1)(14:17)='.dat' 
C       FNAME(1)(12:13)='av' 
        write(FNAME(1)(8:9),110)   MS
        write(FNAME(1)(10:11),110) MD  
        write(FNAME(1)(12:13),110) MR
        write(FNAME(1)(18:19),110) MT
        FNAME(2)(1:7)='12cothn'
        FNAME(2)(14:17)='.dat' 
C       FNAME(2)(12:13)='av' 
        write(FNAME(2)(8:9),110)   MS
        write(FNAME(2)(10:11),110) MD  
        write(FNAME(2)(12:13),110) MR
        write(FNAME(2)(18:19),110) MT
110     FORMAT(I2)
        OPEN(91,file=FNAME(1), STATUS='UNKNOWN')
        OPEN(92,file=FNAME(2), STATUS='UNKNOWN') 
 
C
C      Line intensities for 12-CO
       Do 60 i = 1,Nlevel-1
         a1 = dlog10(xil12a(i)+1.0d-30)
         a2 = dlog10(xil12b(i)+1.0d-30)
         a3 = xil12c(i)
         a4 = xil12d(i)
	 a5 = dlog10(xil12e(i)+1.0d-30)
	 a6 = xil12f(i)
         IF(xtau12(i).gt.1.0d0) then 
           write(*,120)  i,a1,a2,a3,a4,a5,a6,xtau12(i)
           write(91,120) i,a1,a2,a3,a4,a5,a6,xtau12(i)
         else 
	n = i
 	goto 62
         endif          
60     continue
62	continue
       Do 61 i = n-1,Nlevel-1
         a1 = dlog10(xil12a(i)+1.0d-30)
         a2 = dlog10(xil12b(i)+1.0d-30)
         a3 = xil12c(i)
         a4 = xil12d(i)
	 a5 = dlog10(xil12e(i)+1.0d-30)
	 a6 = xil12f(i)
           write(*,120)  i,a1,a2,a3,a4,a5,a6,xtau12(i)
           write(92,120) i,a1,a2,a3,a4,a5,a6,xtau12(i)
61	continue

120    format(i4,7(1x,e12.5)) 


C
CB ------------------------ 13CO --------------------------------
C
 
         Call  XINTLC(NAKT,CD13CO,
     >           CO12E,Beta,CO12A,ZPGR,XIL13G,xil13H,
     >           XIL13a,XIL13b,XIL13C,XIL13d,XIL13e,XIL13f,XTAU13,
     >           sou13co,cap13co)

         write(*,*) "13co line intensities"

        OPEN(82,file='sou13co.dat', STATUS='UNKNOWN')
        OPEN(81,file='cap13co.dat', STATUS='UNKNOWN')

        write(81,*) nakt  
        write(82,*) nakt



       do j = 1,nakt
         WRITE(82,3210) zg2(j),(SOU13CO(J,I),I=1,10) 
         WRITE(81,3210) zg2(j),(CAP13CO(J,I),I=1,10) 
       ENDDO


 	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME(3)(1:7)='13cothk'
        FNAME(3)(14:17)='.dat' 
C       FNAME(3)(12:13)='av' 
        write(FNAME(3)(8:9),110)   MS
        write(FNAME(3)(10:11),110) MD  
        write(FNAME(3)(12:13),110) MR
        write(FNAME(3)(18:19),110) MT
        FNAME(4)(1:7)='13cothn'
        FNAME(4)(14:17)='.dat' 
C       FNAME(4)(12:13)='av' 
        write(FNAME(4)(8:9),110)   MS
        write(FNAME(4)(10:11),110) MD  
        write(FNAME(4)(12:13),110) MR
        write(FNAME(4)(18:19),110) MT
        OPEN(93,file=FNAME(3), STATUS='UNKNOWN')
        OPEN(94,file=FNAME(4), STATUS='UNKNOWN') 
C      Line intensities for 13-CO
       Do 70 i = 1,Nlevel-1
         a1 = dlog10(xil13a(i)+1.0d-30)
         a2 = dlog10(xil13b(i)+1.0d-30)
         a3 = xil13c(i)
         a4 = xil13d(i)
 	 a5 = dlog10(xil13e(i)+1.0d-30)
	 a6 = xil13f(i)	 
         IF(xtau13(i).gt.1.0d0) then 
          write(*,120)  i,a1,a2,a3,a4,a5,a6,xtau13(i)
          write(93,120) i,a1,a2,a3,a4,a5,a6,xtau13(i)
	else 
	n = i
	goto 72
         endif   
70     continue 
72	continue

       Do 71 i = n-1,Nlevel-1
         a1 = dlog10(xil13a(i)+1.0d-30)
         a2 = dlog10(xil13b(i)+1.0d-30)
         a3 = xil13c(i)
         a4 = xil13d(i)
 	 a5 = dlog10(xil13e(i)+1.0d-30)
	 a6 = xil13f(i)	 
         write(*,120)  i,a1,a2,a3,a4,a5,a6,xtau13(i)
           write(94,120) i,a1,a2,a3,a4,a5,a6,xtau13(i)
71	continue 
CB output der Intensitaeten an Gitterpunkten xil7(*,*)
	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME(5)(1:7)='cogridl'
        FNAME(5)(14:17)='.dat' 
C       FNAME(5)(12:13)='av' 
        write(FNAME(5)(8:9),110)   MS
        write(FNAME(5)(10:11),110) MD  
        write(FNAME(5)(12:13),110) MR
        write(FNAME(5)(18:19),110) MT	 
        OPEN(22,file=FNAME(5), STATUS='UNKNOWN') 

	do 78 j = 1,ngri
	  avgrid = zpgr(j)*xntot*1.9d-21/4.0d0
	if (avgrid.gt.0.0d0) then
	  a1 = xil12g(j,1)+1.0d-30
	  a2 = xil12g(j,2)+1.0d-30
	  a3 = xil12g(j,3)+1.0d-30
	  a4 = xil12g(j,6)+1.0d-30
	  a5 = xil12g(j,13)+1.0d-30
	  a6 = 66.6d0*xil13g(j,1)+1.0d-30
	  a7 = 66.6d0*xil13g(j,2)+1.0d-30
	  a8 = 66.6d0*xil13g(j,3)+1.0d-30
	  a9 = 66.6d0*xil13g(j,6)+1.0d-30
	  a10 = 66.6d0*xil13g(j,13)+1.0d-30
	write(22,119) avgrid,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10
	endif
78	continue




C    -------------   c18o   --------------------

 
         Call  XINTLC(NAKT,CD18CO,
     >           CO12E,Beta,CO12A,ZPGR,XIL18G,xil18H,
     >           XIL18a,XIL18b,XIL18C,XIL18d,XIL18e,XIL18f,XTAU18,
     >           sou18co,cap18co)
c
         write(*,*) "c18o line intensities"
c
        OPEN(72,file='sou18co.dat', STATUS='UNKNOWN')
        OPEN(71,file='cap18co.dat', STATUS='UNKNOWN')

        write(72,*) nakt  
        write(71,*) nakt


       do j = 1,nakt
         WRITE(72,3210) zg2(j),(SOU18CO(J,I),I=1,10) 
         WRITE(71,3210) zg2(j),(CAP18CO(J,I),I=1,10) 
       ENDDO


 	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME(3)(1:7)='18cothk'
        FNAME(3)(14:17)='.dat' 
       FNAME(3)(12:13)='av' 
        write(FNAME(3)(8:9),110)   MS
        write(FNAME(3)(10:11),110) MD  
        write(FNAME(3)(12:13),110) MR
        write(FNAME(3)(18:19),110) MT
        FNAME(4)(1:7)='18cothn'
        FNAME(4)(14:17)='.dat' 
       FNAME(4)(12:13)='av' 
        write(FNAME(4)(8:9),110)   MS
        write(FNAME(4)(10:11),110) MD  
        write(FNAME(4)(12:13),110) MR
        write(FNAME(4)(18:19),110) MT
        OPEN(95,file=FNAME(3), STATUS='UNKNOWN')
        OPEN(96,file=FNAME(4), STATUS='UNKNOWN') 
c      Line intensities for 18-CO
       Do 80 i = 1,Nlevel-1
         a1 = dlog10(xil18a(i)+1.0d-30)
         a2 = dlog10(xil18b(i)+1.0d-30)
         a3 = xil18c(i)
         a4 = xil18d(i)
 	 a5 = dlog10(xil18e(i)+1.0d-30)
	 a6 = xil18f(i)	 
         IF(xtau13(i).gt.1.0d0) then 
          write(*,120)  i,a1,a2,a3,a4,a5,a6,xtau18(i)
          write(95,120) i,a1,a2,a3,a4,a5,a6,xtau18(i)
	else 
	n = i
	goto 82
         endif   
80     continue 
82	continue

       Do 81 i = n-1,Nlevel-1
         a1 = dlog10(xil18a(i)+1.0d-30)
         a2 = dlog10(xil18b(i)+1.0d-30)
         a3 = xil18c(i)
         a4 = xil18d(i)
 	 a5 = dlog10(xil18e(i)+1.0d-30)
	 a6 = xil18f(i)	 
         write(*,120)  i,a1,a2,a3,a4,a5,a6,xtau18(i)
           write(96,120) i,a1,a2,a3,a4,a5,a6,xtau18(i)
81	continue 
CB output der Intensitaeten an Gitterpunkten xil7(*,*)
	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME(5)(1:7)='cogridl'
        FNAME(5)(14:17)='.dat' 
       FNAME(5)(12:13)='av'
        write(FNAME(5)(8:9),110)   MS
        write(FNAME(5)(10:11),110) MD  
        write(FNAME(5)(12:13),110) MR
        write(FNAME(5)(18:19),110) MT	 
        OPEN(22,file=FNAME(5), STATUS='UNKNOWN') 
c
c	do 88 j = 1,ngri
c	  avgrid = zpgr(j)*xntot*1.9d-21/4.0d0
c	if (avgrid.gt.0.0d0) then
c	  a1 = xil12g(j,1)+1.0d-30
c	  a2 = xil12g(j,2)+1.0d-30
c	  a3 = xil12g(j,3)+1.0d-30
c	  a4 = xil12g(j,6)+1.0d-30
c	  a5 = xil12g(j,13)+1.0d-30
c	  a6 = 66.6*xil13g(j,1)+1.0d-30
c	  a7 = 66.6*xil13g(j,2)+1.0d-30
c	  a8 = 66.6*xil13g(j,3)+1.0d-30
c	  a9 = 66.6*xil13g(j,6)+1.0d-30
c	  a10 = 66.6*xil13g(j,13)+1.0d-30
c	write(102,119) avgrid,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10
c	endif
c88	continue














        
119	format(11(e12.5,1x))
        Return
        END

C
C

        Subroutine XINTLC(NAKT,CDSP,
     >                    Dengy,Beta,AVAL,Z,XIL7,XIL8,XIL1,
     >                    XIL2,XIL3,XIL4,XIL5,XIL6,XTAU,souco,capco)


C-------------------------------------------------------------
C
C	parameter: nlevel,ngri,trapez
C       Input:  NAKT,CDSP,Dengy,BETA,AVAL,Z
C       Output: XINTL,XINTR
C       NLEVEL = number of levels
C       NAKT   = number of grid points
C       AVAL   = A-values(CO12A)
C       Dengy  = excitation energy(CO12E) in v/c
C       Beta   = line width
CB       Betanew = Beta*sqrt(pi), aequivalente Linienbreite
C       CDSP   = Density (CD12CO bzw. CD13CO)
C       XIL1   = Line integrated intensities
C                using escape probability formalism
C       XIL3   = Brightness temperature for line 
C                integrated intensities
C       XIL2   = Intensity in Line center (left side,
C                source side)
C       XIL4   = Brightness temperature for line center
CB      XIL5   = INTENSITY IN LINE CENTER 
CB	XIL6   = BRIGHNTESS TEMPERATURE FOR XIL5 
CB      XIL7   = intensity in line-center at grid-points 
CB      XIL8   = Brightness temperature for line center at each grid-point 
C       Z      = Grid points(ZPGR)
CB      freq   = frequenz - freqnull in (v/c), d.h. delta(frequenz)
CB      freqnull = Uebergangsfrequenz des jeweiligen Uebergangs
CB      deltafreq = Aequivalentbreite in v/c  
CB      help1   = Profilfunktion(freq) (line shape function)
CB      help2,3 =  freqnull +/- freq, d.h. tatsaechliche Frequenz
CB	help4 = intensity at level i and frequenz help2(i,n)
CB
CB
CB
C 
C-------------------------------------------------------------




 	IMPLICIT DOUBLE PRECISION (A-H,O-Z)

        integer  trapez
	Parameter(NLHT=15)
        Parameter(NMAX1=800)
        Parameter(NPAR=416)
	Parameter (nco=50)      
        Parameter (NGRI=500)
	parameter (nlevel = 50)
        parameter (trapez =300) 

         Dimension Dengy(NLEVEL),AVAL(NLEVEL), XIL3(NGRI),
     >       CDSP(NGRI,NCO),Z(NAKT),xtau1(nlevel,trapez),
     >       XKAP(NGRI,NGRI),SOU1(NGRI,NGRI),XTAU(NGRI),
     >       help4(nlevel-1,trapez),XIL1(NGRI),XIL2(NGRI),
     >       XIL4(NGRI),XKAP2(NGRI,NGRI),
     >       SOU2(NGRI,NGRI),SOU3(NGRI,NGRI),help2(nlevel-1,trapez),
     >       help3(nlevel-1,trapez),xil6(nlevel-1),XIL5(nlevel-1),
     >       xil7(ngri,nlevel-1), xil8(ngri,nlevel-1),
     >       souco(ngri,nlevel),capco(ngri,nlevel)
         
        clight = 2.997929d10
        xh     = 6.6252d-27   
        xk     = 1.380622d-16 
	pi = 3.141592654d0
	betanew = beta*sqrt(pi)
CB	beta = betanew
CB	betanew = beta

	hell2 = 0.0d0

        Do 10 i = 1 , ngri 
	  XTAU(I)  = 0.0d0
          XIL1(i)  = 0.0d0
          XIL2(i)  = 0.0d0
          XIL3(i)  = 0.0d0
          XIL4(i)  = 0.0d0 
c...	  XIL5(I)  = 0.0D0
c...	  XIL6(I)  = 0.0D0
10      continue 

c...
c... XIL(5) und XIL(6) entsprechend ihrer Dimension
c... nullgesetzt
        do i=1,nlevel-1
           XIL5(I)  = 0.0D0
           XIL6(I)  = 0.0D0
        end do
 
        Do 19 j = 1 , ngri
	  do 19 i = 1 , nlevel-1
          XIL7(j,i)  = 0.0d0 
	  XIL8(j,i)  = 0.0D0
19	continue	 
	do 6 i = 1,nlevel-1
		do 5 j = 1,trapez
		 xtau1(i,j) = 0.0d0
	         help4(i,j) = 0.0d0
		 help2(i,j) = 0.0d0
5		continue
6	continue

        Do 11 j = 1 , NAKT
C         Compute transition opacities.

          DO 12 i = 1 , (NLEVEL-1)
	    FAC = 25.1327D0*BETA*(Dengy(I+1)-Dengy(I))**3.D0
	    WR  = FLOAT(2*I+1)/FLOAT(2*(I-1)+1)
	    XKAP(j,i) = (WR*CDSP(j,i)-CDSP(j,i+1))*AVAL(i)/FAC
            IF(XKAP(j,i).lt.0.0d0) XKAP(j,i)=0.0d0
12        continue
11        continue
        Do 13 j = 1 , NAKT
C         Compute transition opacities.
          DO 14 i = 1 , (NLEVEL-1)
	   deltafreq = (betanew/1.0d0)*(dengy(i+1)-dengy(i))
	    FAC2 = 25.1327D0*deltafreq*(Dengy(I+1)-Dengy(I))**2.D0
	    WR2  = FLOAT(2*I+1)/FLOAT(2*(I-1)+1)
	    XKAP2(j,i) = (WR2*CDSP(j,i)-CDSP(j,i+1))*AVAL(i)/FAC2
            IF(XKAP2(j,i).lt.0.0d0) XKAP2(j,i)=0.0d0
14        continue
13        continue


	write (*,*) 'nakt = ',nakt
           Do 20 j = 1 , NAKT
CB	write (*,*) 'j = ',j
            DO 30 i = 1 , (NLEVEL-1)

CB 14.10.1992    Compute line integrated intensity:


CB 12.10.1992       Compute profilfunction:

	    freqnull = dengy(i+1)-dengy(i)
	        do 34 n = 1,trapez
		   deltafreq = (betanew/clight)*freqnull
c		   write(*,*) 'deltafreq = ',deltafreq
c	           write(*,*) 'n =',n
                   freq = deltafreq/(n/10.0d0)
	        if (n.eq.trapez) then
	           freq = 0.0d0
	        endif
	              help1 = profil(freq,deltafreq)
                      help2(i,n) = (freqnull - freq) 
                      help3(i,n) = (freqnull + freq)
c                      write(*,*) "help1= ",help1
CB       Compute source functions:
            xpu = CDSP(j,i+1)/DBLE(2*i+1)
            xpl = CDSP(j,i)/DBLE(2*(i-1)+1)
            x1  = 2.0d0*clight*XH*(help2(i,n))**3.0d0
            x2  = XPL-XPU
            IF(X2.gt.1.0d-12) then 
              Sou3(j,i) = x1*XPU/(XPL-XPU)
	      if (i.eq.2) then
CB              write(*,*) '1 sourcefunction =',sou3(j,i)
	      endif	
            Else
              Sou3(j,i) = 0.0d0
	    Endif  
CB       Compute optical depths and line (integrated) intensity:
          IF(J.gt.1) then
              dz      = z(j)-z(j-1)
CB	     write(*,*) 'profilf(',n,') =',help1
              dtau1    = dz*help1*(XKAP2(J-1,I)+XKAP2(J,I))/2.0d0
              XTAUOLD = XTAU1(i,n)

              XTAU1(i,n) = XTAU1(i,n)+dtau1
	     help4(i,n)  = ((Sou3(j,i)*expc2(-Xtau1(i,n))+
     >                         Sou3(j-1,i)*expc2(-Xtauold))*
     >                         dtau1/2.0d0)*(help2(i,n)
     >                         -help2(i,n-1))*clight 
	
	endif

34	        continue


CB Aufsummieren fuer die Helligkeitstemp. in der Linienmitte:	
CB	hell2 = hell2  + hell1 

CB   Aufsummieren der linienintegrierten Intensitaet :  
	do 35 n = 1,trapez
	  xil5(i) = xil5(i) + 2*help4(i,n)
35	continue
C           Compute source functions
            xpu = CDSP(j,i+1)/DBLE(2*i+1)
            xpl = CDSP(j,i)/DBLE(2*(i-1)+1)
            x1  = 2.0d0*clight*XH*(Dengy(i+1)-Dengy(i))**3.0d0
            x2  = XPL-XPU
c            write(*,*) 'CDSP(',j,',',i,') = ',CDSP(j,i)	
c            write(*,*) 'CDSP(j,i+1) = ',CDSP(j,i+1)
c	    write(*,*) 'xpu = ',xpu
c	    write(*,*) 'xpl = ',xpl
c	    write(*,*) 'x1 = ',x1
C           Compute 'source function' for line integrated
C           Intensities (using escape probabilities) 
            Sou2(j,i) = CDSP(j,i+1)*Aval(i)*
     >                  xh*clight*(Dengy(i+1)-Dengy(i))/6.282d0 
C           Calculate source function in line center            
            IF(X2.gt.1.0d-12) then 
              Sou1(j,i) = x1*XPU/(XPL-XPU)
	     if (i.eq.2) then
	     end if
            Else
              Sou1(j,i) = 0.0d0
            Endif  
30        CONTINUE
41         continue	

           IF(J.gt.1) then
            DO 40 i=1,NLEVEL-1
C             Compute optical depths
              dz      = z(j)-z(j-1)
              dtau    = dz*(XKAP(J-1,I)+XKAP(J,I))/2.0d0
              XTAUOLD = XTAU(i)
              XTAU(i) = XTAU(i)+dtau

CB new output: 25.10.1996 => sou*.dat, cap*.dat
              souco(j,i) = sou1(j,i)
              capco(j,i) = xkap(j,i)

C             Compute line intensities on surface (Trapez-rule)
	      xilhelp = xil2(i) 
              Xil2(i) = Xil2(i)+(Sou1(j,i)*expc2(-Xtau(i))+
     >                         Sou1(j-1,i)*expc2(-Xtauold))*
     >                         dtau/2.0d0
	      xil7(j,i) = (xil2(i)-xilhelp)/dz	 
CB	      if (i.eq.2) write(*,*) 'xil7(',j,',2) =',xil7(j,2)
              Xil1(i) = Xil1(i)+(Sou2(j,i)*besc(Xtau(i))+
     >                           Sou2(j-1,i)*besc(XTAUOLD))*
     >                           dz/2.0d0 
40          continue
         Endif
20      continue

CB Linienintegrierten Intensitaeten auf line_int.dat:
	do 21 i = 1,nlevel-1
	write(10,*) i,xil5(i),xil1(i)
21	continue

         Do 50 i = 1,NLEVEL-1
C         Calculate Brightness temperature for line integrated
C         Intensities
          xfac1   = 1.0d0/(2.0d0*xk*beta*(dengy(i+1)-
     >              dengy(i))**3)  
          XIL3(i) = XIL1(i)*xfac1 
C         Calculate Brightness temperatures for line center 
          xfac2   = 1.0d0/(2.0d0*xk*(dengy(i+1)-
     >              dengy(i))**2) 
          XIL4(i) = XIL2(I)*xfac2 
50      continue
CB	do 51 j = 1,ngri
CB	  do 53 i = 1,nlevel-1
CB          xfac2   = 1.0d0/(2.0d0*xk*(dengy(i+1)-
CB     >              dengy(i))**2) 
CB          XIL8(j,i) = XIL7(j,i)*xfac2 
CB53	continue
CB51	continue
	 
CB Berechnung der Helligkeitstemperatur fuer linienintegrierte Intensitaet
	  do 52 j = 1,nlevel-1
     	Xfac3 = 1.0d0/(2.0d0*xk*betanew*(dengy(j+1)-
     >              dengy(j))**3)  
	 XIL6(j) = XIL5(j)*xfac3
52	continue

       return
        end

      
CB **********************************************************************
        Subroutine Xline1(CDDST,ZGST,NAKT,Beta,
     >                   AV,XNTOT,SINT,zg2) 

CB       Calculates line intensities on surface of 
CB       finite slab for 12C,12C+,13C,13C+ and O.

CB 29.11.1992     B.Koester

C
C       Input: CDDST,ZGST,NAKT
C       ZGST  = Grid-points
C       CDDST = Densities at grid-points
C       NAKT  = Number of gridpoints
C       Beta  = line width
C       AV    = visual extinction
C       XNTOT = density
C       SINT  = strength of radiation field

	Parameter(NLHT=15)
        Parameter(NMAX1=800)
        Parameter(NPAR=416)
        Parameter (NGRI=500)

	IMPLICIT DOUBLE PRECISION (A-H,O-Z)

       COMMON /CI/ CIDAT(16),CIDEN(3),CICOL(3),CITAU(3)
       COMMON /OXY/ OXYDAT(16),OXYDEN(3),OXYCOL(3),OXYTAU(3)
 
       DIMENSION CDDST(NMAX1,NLHT+NPAR),ZGST(NMAX1),ZPGR(NMAX1),
     >            ZG2(NMAX1), 
CB      12C
     >         CDCI(NGRI,3),CIE(3),CIA(3),CIS(3),
     >         XILCIa(NGRI),XILCIb(NGRI),XILCIc(NGRI),
     >         XILCId(NGRI),XTAUCI(NGRI),XILCIe(ngri,3),	
     >	       XILCIf(ngri,3),
CB      12C+
     >         CDCII(NGRI,2),XILCIIa(NGRI),XILCIIb(NGRI),
     >         XILCIIc(NGRI),XILCIId(NGRI),XTAUCII(NGRI),
     >         XILCIIe(ngri),XILCIIf(ngri),
CB      16O
     >         CDOI(NGRI,3),OIE(3),OIA(3),OIS(3),XILOIa(NGRI),
     >         XILOIb(NGRI),XILOIc(NGRI),XILOId(NGRI),XTAUOI(NGRI), 
     >         XILOIe(ngri,3),XILOIf(ngri,3),
CB      13C
     >         CDC13I(NGRI,3),XTAUC13I(NGRI),
     >         XILC13Ia(NGRI),XILC13Ib(NGRI),XILC13Ic(NGRI),
     >         XILC13Id(NGRI),XILC13Ie(ngri,3), XILC13If(ngri,3),	
CB      13C+
     >         CDC13II(NGRI,2),XTAUC13II(NGRI),XILC13IIa(NGRI),
     >         XILC13IIb(NGRI),XILC13IIc(NGRI),XILC13IId(NGRI),
     >         XILC13IIe(ngri),
CB new: 25.10.1996:
     >            sou12cp(ngri), cap12cp(ngri),
     >            sou13cp(ngri), cap13cp(ngri),
     >            sou12ci(ngri,3), cap12ci(ngri,3),
     >            sou13ci(ngri,3), cap13ci(ngri,3),
     >            sou16oi(ngri,3), cap16oi(ngri,3)
	 
 
CB XIL*a: Line-Integrated-Intensity
CB XIL*b: Intensity in Line Center
CB XIL*c: Brightness Temperature Line-Integrated
CB XIL*d: Brightness Temperature Line-Center
CB XIL*e: Intensity in Line Center at each grid-point
CB XIL*f: Brightness Temeperature in line center at each grid-point
        Character*19 FNAME1(4)       
        Integer NAKT

	do 33 i = 1,3
		cia(i) = cidat(i) 
		oia(i) = oxydat(i)
		cis(i) = cidat(i+12)
                ois(i) = oxydat(i+12)
		cie(i) = cidat(i+9)
		oie(i) = oxydat(i+9)
33 	continue
 
CB  CII 2P1/2 -> 2P3/2,    cdd(122),cdd(123)

	CIIE = 63.7d0
	CIIA = 2.40d-06

CB ******* DICHTEN IM LEVEL UND SCHALE, BEACHTE REIHENFOLGE:*********
CB Belegung fuer  12CI:
          Do 20 j = 1,NAKT
            CDCI(j,1) = CDDST(j,124)       
            CDCI(j,2) = CDDST(j,125)   
            CDCI(j,3) = CDDST(j,126)   
20	continue
CB Belegung fuer 13C:
	  do 21 j = 1,nakt
            cdc13I(j,1) = cddst(j,181)
            cdc13I(j,2) = cddst(j,182)
            cdc13I(j,3) = cddst(j,183)
21	continue

CB Belegung fuer 12CII:  
	Do  25 j = 1,NAKT
	  CDCII(J,1) = CDDST(J,122)
	  CDCII(J,2) = CDDST(J,123)
25	CONTINUE
CB Belegung fuer 13CII:
	 do 26 j = 1,nakt
	  CDC13II(J,1) = CDDST(J,179)
	  CDC13II(J,2) = CDDST(J,180)
26	CONTINUE

CB Belegung fuer OI:
          Do 40 j = 1,Nakt
            CDOI(j,1) = CDDST(j,119)
            CDOI(j,2) = CDDST(j,120)
            CDOI(j,3) = CDDST(j,121)
40      continue

        Do 50 i = 1,NAKT
          ZPGR(i) = ZGST(i)
50      continue
****************Aufruf fuer 12CI: *********************************

        Call XINTLC1(NAKT,CDCI,
     >           CIE,Beta,CIA,ZPGR,CIS,XILCIe,XILCIf,
     >           XILCIa,XILCIb,XILCIc,XILCId,XTAUCI,sou12ci,cap12ci)
       OPEN(62,file='sou12ci.dat', STATUS='UNKNOWN')
       OPEN(61,file='cap12ci.dat', STATUS='UNKNOWN')

       do j = 1,nakt
         WRITE(62,3211) zg2(j),(SOU12ci(J,I),I=1,3) 
         WRITE(61,3211) zg2(j),(CAP12ci(J,I),I=1,3) 
       ENDDO
 3211  format(4(2x,1pe9.3))
       

	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME1(1)(1:7)='c_o_thk'
        FNAME1(1)(14:17)='.dat' 
C       FNAME1(1)(12:13)='av' 
        write(FNAME1(1)(8:9),111)   MS
        write(FNAME1(1)(10:12),111) MD  
        write(FNAME1(1)(12:13),111) MR
        write(FNAME1(1)(18:19),111) MT
110     FORMAT(I2)
          OPEN(95,file=FNAME1(1), STATUS='UNKNOWN')
 
C
C      Line intensities for 12CI:
	   write(*,*) '12CI :'
	   write(95,*) '     12CI:      '
       Do 60 i = 1,3
         a1 = dlog10(XILCIa(i)+1.0d-30)
         a2 = dlog10(XILCIb(i)+1.0d-30)
         a3 = XILCIc(i)
         a4 = XILCId(i)
           write(*,122)  i,a1,a2,a3,a4,xtauCI(i),ciE(i)
           write(95,121) i,a1,a2,a3,a4,xtauCI(i)
60	continue
121    format(i4,5(1x,e12.5)) 
122    format(i4,6(1x,e12.5)) 

****************Aufruf fuer 13CI: *********************************

        Call XINTLC1(NAKT,CDC13I,
     >       CIE,Beta,CIA,ZPGR,CIS,XILC13Ie,XILC13If,
     >       XILC13Ia,XILC13Ib,XILC13Ic,XILC13Id,XTAUC13I,sou13ci,
     >       cap13ci)
       OPEN(64,file='sou13ci.dat', STATUS='UNKNOWN')
       OPEN(63,file='cap13ci.dat', STATUS='UNKNOWN')

       do j = 1,nakt
         WRITE(64,3211) zg2(j),(SOU13ci(J,I),I=1,3) 
         WRITE(63,3211) zg2(j),(CAP13ci(J,I),I=1,3) 
       ENDDO

113     FORMAT(I2)

C      Line intensities for 13CI:
	   write(*,*) '13CI :'
	   write(95,*) '      13CI:      '
       Do 61 i = 1,3
         a1 = dlog10(XILC13Ia(i)+1.0d-30)
         a2 = dlog10(XILC13Ib(i)+1.0d-30)
         a3 = XILC13Ic(i)
         a4 = XILC13Id(i)
           write(*,122)  i,a1,a2,a3,a4,xtauC13I(i),ciE(i)
           write(95,121) i,a1,a2,a3,a4,xtauC13I(i)
61	continue
CB*************** CB Aufruf fuer OI: **************************************
 
       Call XINTLC1(NAKT,CDOI,
     >           OIE,Beta,OIA,ZPGR,OIS,XILOIe,XILOIf,
     >           XILOIa,XILOIb,XILOIc,XILOId,XTAUOI,sou16oi,cap16oi)

       OPEN(66,file='sou16oi.dat', STATUS='UNKNOWN')
       OPEN(65,file='cap16oi.dat', STATUS='UNKNOWN')

       do j = 1,nakt
         WRITE(66,3211) zg2(j),(SOU16oi(J,I),I=1,3) 
         WRITE(65,3211) zg2(j),(CAP16oi(J,I),I=1,3) 
       ENDDO

C      Line intensities for OI:
	  write(*,*) 'OI :'
	   write(95,*) '        OI:       '
       Do 70 i = 1,3
         a1 = dlog10(XILOIa(i)+1.0d-30)
         a2 = dlog10(XILOIb(i)+1.0d-30)
         a3 = XILOIc(i)
         a4 = XILOId(i)

          write(*,122)  i,a1,a2,a3,a4,xtauOI(i),oie(i)
          write(95,121) i,a1,a2,a3,a4,xtauOI(i)
70     continue 

CB ************  Aufruf fuer 12CII:  ************************************

        Call XINTLC2(NAKT,CDCII,
     >     CIIE,Beta,CIIA,ZPGR,XILCIIe,XILCIIf,
     >     XILCIIa,XILCIIb,XILCIIc,XILCIId,XTAUCII,sou12cp,cap12cp)

111     FORMAT(I2)
       OPEN(68,file='sou12cp.dat', STATUS='UNKNOWN')
       OPEN(67,file='cap12cp.dat', STATUS='UNKNOWN')

       do j = 1,nakt
         WRITE(68,3212) zg2(j),SOU12cp(J) 
         WRITE(67,3212) zg2(j),CAP12cp(J) 
       ENDDO

 3212  format(2(2X,1pe9.3))

C      Line intensities for 12CII:

         a1 = dlog10(XILCIIa(1)+1.0d-30)
         a2 = dlog10(XILCIIb(1)+1.0d-30)
         a3 = XILCIIc(1)
         a4 = XILCIId(1)
	   write(*,*) '12CII :'
	   write(95,*) '       12CII:     '
	   i = 1
           write(*,121)  i,a1,a2,a3,a4,xtauCII(i)
           write(95,121) i,a1,a2,a3,a4,xtauCII(i)

CB ************  Aufruf fuer 13CII:  ************************************

        Call XINTLC2(NAKT,CDC13II,
     >           CIIE,Beta,CIIA,ZPGR,XILC13IIe,XILCII13f,
     >           XILC13IIa,XILC13IIb,XILC13IIc,XILC13IId,XTAUC13II,
     >    sou13cp,cap13cp)

       OPEN(70,file='sou13cp.dat', STATUS='UNKNOWN')
       OPEN(69,file='cap13cp.dat', STATUS='UNKNOWN')

       do j = 1,nakt
         WRITE(70,3212) zg2(j),SOU13cp(J) 
         WRITE(69,3212) zg2(j),CAP13cp(J) 
       ENDDO


C      Line intensities for 13CII:

         a1 = dlog10(XILC13IIa(1)+1.0d-30)
         a2 = dlog10(XILC13IIb(1)+1.0d-30)
         a3 = XILC13IIc(1)
         a4 = XILC13IId(1)
	   write(*,*) '13CII :'
	   i = 1
           write(*,121)  i,a1,a2,a3,a4,xtauC13II(i)
             write(95,*) '        13CII:     '
             write(95,121)  i,a1,a2,a3,a4,xtauC13II(i)

CB *****************************************************************
CB output intensity at line-center at each grid-point file = c_ogril*
CB d.h.:  dI/dz

	MS=10.*LOG10(SINT)
	MD=10.*LOG10(XNTOT)
        MR=AV
	MT = beta/10000.0
        FNAME1(2)(1:7)='ciigril'
        FNAME1(3)(1:7)='ci_gril'
        FNAME1(4)(1:7)='c_ogril'

	do 333 i=2,4
        FNAME1(i)(14:17)='.dat' 
C       FNAME1(i)(12:13)='av' 
        write(FNAME1(i)(8:9),111)   MS
        write(FNAME1(i)(10:12),111) MD  
        write(FNAME1(i)(12:13),111) MR
        write(FNAME1(i)(18:19),111) MT
333	continue
CB      CII-Plot:  104
         OPEN(24,file=FNAME1(2), STATUS='UNKNOWN') 
	do 176 j = 1,ngri
	avgrid = zpgr(j)*xntot*1.9d-21/4.0d0 
	if (avgrid.gt.0.0d0) then
        a3 = XILCIIe(j)+1.0d-30
	a8 = 66.6d0*XILC13IIe(j) + 1.0d-30
	write(24,177) avgrid,a3,a8
	endif
176	continue

CB      CI-Plot:   105
         OPEN(25, file=FNAME1(3), STATUS='UNKNOWN') 
	do 167 j = 1,ngri
	avgrid = zpgr(j)*xntot*1.9d-21/4.0d0 
	if (avgrid.gt.0.0d0) then
        a1 = XILCIe(j,1)+1.0d-30
        a2 = XILCIe(j,3)+1.0d-30
	a6 = 66.6d0*XILC13Ie(j,1) +1.0d-30
	a7 = 66.6d0*XILC13Ie(j,3) + 1.0d-30
	write(25,177) avgrid,a1,a2,a6,a7
	endif
167	continue

CB      12CI,12CII,O-plot: 106 (alte Version)
         OPEN(26,file=FNAME1(4), STATUS='UNKNOWN') 
	
	do 175 j = 1,ngri
	avgrid = zpgr(j)*xntot*1.9d-21/4.0d0 
	if (avgrid.gt.0.0d0) then
        a1 = XILCIe(j,1)+1.0d-30
        a2 = XILCIe(j,3)+1.0d-30
        a3 = XILCIIe(j)+1.0d-30
        a4 = XILOIe(j,1)+1.0d-30
        a5 = XILOIe(j,3)+1.0d-30
	write(26,177) avgrid,a1,a2,a3,a4,a5
	endif
175	continue
177     format(6(e12.5,1x))

        Return
        END

C
C

        Subroutine XINTLC1(NAKT,CDSP,
     >                    Dengy,Beta,AVAL,Z,STAT,XIL5,XIL6,
     >                    XIL1,XIL2,XIL3,XIL4,XTAU,souhelp,caphelp)

CB Berechnung fuer CI,OI:
C-------------------------------------------------------------
C
C	parameter: nlevel,ngri,trapez
C       Input:  NAKT,CDSP,Dengy,BETA,AVAL,Z
C       Output: XINTL,XINTR
C       NAKT   = number of grid points
C       AVAL   = A-values(CIA ...)
C       Dengy  = excitation energy(CIE ...) in v/c
C       Beta   = line width
CB       Betanew = Beta*sqrt(pi), aequivalente Linienbreite
C       CDSP   = Density (CD12CO bzw. CD13CO)
C       XIL1   = Line integrated intensities
C       XIL3   = Brightness temperature for line 
C                integrated intensities
C       XIL2   = Intensity in Line center (left side,
C                source side)
C       XIL4   = Brightness temperature for line center
C       XIL5   = Line Intensity for line center at each grid-point,dI/dz
C       XIL6   = Brightness temperature for line center at each grid-point
C       Z      = Grid points(ZPGR)
CB      freq   = frequenz - freqnull in (v/c), d.h. delta(frequenz)
CB      freqnull = Uebergangsfrequenz des jeweiligen Uebergangs
CB      deltafreq = Aequivalentbreite in v/c  
CB      help1   = Profilfunktion(freq) (line shape function)
CB      help2,3 =  freqnull +/- freq, d.h. tatsaechliche Frequenz
CB	help4 = intensity at level i and frequenz help2(i,n)
CB	STAT = statistisches Gewicht des levels
CB
CB
C 
C-------------------------------------------------------------




 	IMPLICIT DOUBLE PRECISION (A-H,O-Z)

        integer  trapez
	Parameter(NLHT=15)
        Parameter(NMAX1=800)
        Parameter(NPAR=416)
        Parameter (NGRI=500)
        parameter (trapez = 300) 

         Dimension Dengy(3),AVAL(3),STAT(3),
     >       CDSP(NGRI,3),Z(NAKT),xtau1(3,trapez),
     >       XKAP(NGRI,NGRI),SOU1(NGRI,NGRI),XTAU(NGRI),
     >       HELP4(3,trapez),XIL1(NGRI),XIL2(NGRI),	
     >       XIL3(NGRI),XIL4(NGRI),XKAP2(NGRI,NGRI),
     >       SOU2(NGRI,NGRI),SOU3(NGRI,NGRI),help2(3,trapez),
     >       help3(3,trapez),xil6(NGRI,3),xil5(NGRI,3),
     >        souhelp(ngri,3),caphelp(ngri,3)
         
        clight = 2.997929d10
        xh     = 6.6252d-27   
        xk     = 1.380622d-16 
	pi = 3.141592654d0
	betanew = beta*sqrt(pi)
CB	beta = betanew
CB	betanew = beta

	hell2 = 0.0d0

        Do 10 i = 1 , ngri 
	  XTAU(I)  = 0.0d0
          XIL1(i)  = 0.0d0
          XIL2(i)  = 0.0d0
          XIL3(i)  = 0.0d0
          XIL4(i)  = 0.0d0 
10      continue  
	DO 29 J = 1,NGRI
	  DO 29 I = 1,3
	  XIL5(J,I)  = 0.0D0
	  XIL6(J,I)  = 0.0D0
29 	CONTINUE
	do 6 i = 1,3
		do 5 j = 1,trapez
		 xtau1(i,j) = 0.0d0
	         help4(i,j) = 0.0d0
		 help2(i,j) = 0.0d0
5		continue
6	continue
         Do 11 j = 1 , NAKT
C         Compute transition opacities.
            
            DO 12 i = 1 , 3
	if (i.eq.1) then
	    FAC = 25.1327D0*BETA*Dengy(1)**3.D0
	    WR  = stat(2)/stat(1)
	    XKAP(j,1) = (WR*CDSP(j,1)-CDSP(j,2))*AVAL(1)/FAC
	else if (i.eq.2) then
	    FAC = 25.1327D0*BETA*Dengy(2)**3.D0
	    WR  = stat(3)/stat(1)
	    XKAP(j,2) = (WR*CDSP(j,1)-CDSP(j,3))*AVAL(2)/FAC
	else if (i.eq.3) then
	    FAC = 25.1327D0*BETA*Dengy(3)**3.D0
	    WR  = stat(3)/stat(2)
	    XKAP(j,3) = (WR*CDSP(j,2)-CDSP(j,3))*AVAL(3)/FAC
	endif

            IF(XKAP(j,i).lt.0.0d0) XKAP(j,i)=0.0d0
12        continue
11        continue
        Do 13 j = 1 , NAKT
C         Compute transition opacities.
          DO 14 i = 1 , 3
	if (i.eq.1) then
	   deltafreq = (betanew/1.0d0)*dengy(1)
	    FAC2 = 25.1327D0*deltafreq*dengy(1)**2.D0
	    WR2  = stat(2)/stat(1)
            
	    XKAP2(j,1) = (WR2*CDSP(j,1)-CDSP(j,2))*AVAL(1)/FAC2

	else if (i.eq.2) then
	   deltafreq = (betanew/1.0d0)*dengy(2)
	    FAC2 = 25.1327D0*deltafreq*dengy(2)**2.D0
	    WR2  = stat(3)/stat(1)
	    XKAP2(j,2) = (WR2*CDSP(j,1)-CDSP(j,3))*AVAL(2)/FAC2

	else if (i.eq.3) then
	   deltafreq = (betanew/1.0d0)*dengy(3)
	    FAC2 = 25.1327D0*deltafreq*Dengy(3)**2.D0
	    WR2  = stat(3)/stat(2)
	    XKAP2(j,3) = (WR2*CDSP(j,2)-CDSP(j,3))*AVAL(3)/FAC2

	endif
            IF(XKAP2(j,i).lt.0.0d0) XKAP2(j,i)=0.0d0
14        continue
13        continue

           Do 20 j = 1 , NAKT
            DO 30 i = 1 , 3

CB 14.10.1992    Compute line integrated intensity:


CB 12.10.1992       Compute profilfunction:

	    freqnull = dengy(i)
	        do 34 n = 1,trapez
		   deltafreq = (betanew/clight)*freqnull
CB		   write(*,*) 'deltafreq = ',deltafreq
CB	           write(*,*) 'n =',n
                   freq = deltafreq/(n/10.0d0)
	        if (n.eq.trapez) then
	           freq = 0.0d0
	        endif
	              help1 = profil(freq,deltafreq)
                      help2(i,n) = (freqnull - freq) 
                      help3(i,n) = (freqnull + freq)
CB       Compute source functions:
	if (i.eq.1) then
            xpl = CDSP(j,1)/stat(1)
            xpu = CDSP(j,2)/stat(2)
            x1  = 2.0d0*clight*XH*(help2(1,n))**3.0d0
	else if (i.eq.2) then
            xpl = CDSP(j,1)/stat(1)
            xpu = CDSP(j,3)/stat(3)
            x1  = 2.0d0*clight*XH*(help2(2,n))**3.0d0
	else if (i.eq.3) then 
            xpl = CDSP(j,2)/stat(2)
            xpu = CDSP(j,3)/stat(3)
            x1  = 2.0d0*clight*XH*(help2(3,n))**3.0d0
	endif
            x2  = XPL-XPU
            IF(X2.gt.1.0d-12) then 
              Sou3(j,i) = x1*XPU/(XPL-XPU)
            Else
              Sou3(j,i) = 0.0d0
	    Endif  
CB       Compute optical depths and line (integrated) intensity:
          IF(J.gt.1) then
              dz      = z(j)-z(j-1)
CB	     write(*,*) 'profilf(',n,') =',help1

              dtau1    = dz*help1*(XKAP2(J-1,I)+XKAP2(J,I))/2.0d0
              XTAUOLD = XTAU1(i,n)
              XTAU1(i,n) = XTAU1(i,n)+dtau1
	     help4(i,n)  = ((Sou3(j,i)*expc2(-Xtau1(i,n))+
     >                         Sou3(j-1,i)*expc2(-Xtauold))*
     >                         dtau1/2.0d0)*(help2(i,n)
     >                         -help2(i,n-1))*clight 
	
	endif

34	        continue

CB   Aufsummieren der linienintegrierten Intensitaet :  
	do 35 n = 1,trapez
	  xil1(i) = xil1(i) + 2*help4(i,n)
35	continue
CB	write(*,*) 'xil1(1) =',xil1(1),'i=',i,'j=',j
CB	write(*,*) 'help4(1,10) =',help4(1,10)
C           Compute source functions
	if (i.eq.1) then
            xpl = CDSP(j,1)/stat(1)
            xpu = CDSP(j,2)/stat(2)
            x1  = 2.0d0*clight*XH*dengy(1)**3.0d0
	else if (i.eq.2) then
            xpl = CDSP(j,1)/stat(1)
            xpu = CDSP(j,3)/stat(3)
            x1  = 2.0d0*clight*XH*dengy(2)**3.0d0
	else if (i.eq.3) then 
            xpl = CDSP(j,2)/stat(2)
            xpu = CDSP(j,3)/stat(3)
            x1  = 2.0d0*clight*XH*Dengy(3)**3.0d0
	endif
CB            xpu = CDSP(j,i+1)/Float(2*i+1)
CB            xpl = CDSP(j,i)/Float(2*(i-1)+1)
CB            x1  = 2.0d0*clight*XH*(Dengy(i))**3.0d0
            x2  = XPL-XPU

CB           Compute 'source function' for line integrated
CB           Intensities (using escape probabilities) 
CB            Sou2(j,i) = CDSP(j,i+1)*Aval(i)*
CB     >                  xh*clight*(Dengy(i))/6.282d0 

C           Calculate source function in line center            
            IF(X2.gt.1.0d-12) then 
              Sou1(j,i) = x1*XPU/(XPL-XPU)
	     if (i.eq.2) then
	     end if
            Else
              Sou1(j,i) = 0.0d0
            Endif  
30        CONTINUE
41         continue	
          IF(J.gt.1) then
            DO 40 i=1,3
C             Compute optical depths
              dz      = z(j)-z(j-1)
              dtau    = dz*(XKAP(J-1,I)+XKAP(J,I))/2.0d0
              XTAUOLD = XTAU(i)
              XTAU(i) = XTAU(i)+dtau
              
CB new output, 25.10.1996: sou*.dat, cap*.dat              
             souhelp(j,i) = sou1(j,i)
             caphelp(j,i) = XKAP(J,I) 

C             Compute line intensities on surface (Trapez-rule)
	      xilhelp = xil2(i)
              Xil2(i) = Xil2(i)+(Sou1(j,i)*expc2(-Xtau(i))+
     >                         Sou1(j-1,i)*expc2(-Xtauold))*
     >                         dtau/2.0d0
	      XIL5(J,I) = (XIL2(I)-xilhelp)/dz
CB              Xil1(i) = Xil1(i)+(Sou2(j,i)*besc(Xtau(i))+
CB     >                           Sou2(j-1,i)*besc(XTAUOLD))*
CB     >                           dz/2.0d0 
40          continue
         Endif
20      continue

         Do 50 i = 1,3

CB         Calculate Brightness temperature for line integrated
CB         Intensities
CB          xfac1   = 1.0d0/(2.0d0*xk*beta*(
CB     >              dengy(i))**3)  
CB          XIL3(i) = XIL1(i)*xfac1 

C         Calculate Brightness temperatures for line center 
	if (i.eq.1) then
          xfac2   = 1.0d0/(2.0d0*xk*dengy(1)**2) 
          XIL4(i) = XIL2(i)*xfac2 
	else if (i.eq.2) then
          xfac2   = 1.0d0/(2.0d0*xk*dengy(2)**2) 
          XIL4(i) = XIL2(i)*xfac2 
	else if (i.eq.3) then
          xfac2   = 1.0d0/(2.0d0*xk*dengy(3)**2) 
          XIL4(i) = XIL2(i)*xfac2 
	endif

50      continue

CB	DO  56 J = 1,NGRI
CB	  DO 57 I = 1,3
CB	if (i.eq.1) then
CB          xfac2   = 1.0d0/(2.0d0*xk*(dengy(1))**2) 
CB          XIL6(j,i) = XIL5(j,i)*xfac2 
CB	else if (i.eq.2) then
Cb          xfac2   = 1.0d0/(2.0d0*xk*(dengy(2))**2) 
CB          XIL6(j,i) = XIL5(j,i)*xfac2 
CB	else if (i.eq.3) then
CB          xfac2   = 1.0d0/(2.0d0*xk*(dengy(3))**2) 
CB          XIL6(j,i) = XIL5(j,i)*xfac2 
CB	endif	 
CB57	continue
CBG56	continue
CB Berechnung der Helligkeitstemperatur fuer linienintegrierte Intensitaet
	  do 52 j = 1,3
	if (j.eq.1) then
     	Xfac3 = 1.0d0/(2.0d0*xk*betanew*dengy(1)**3)  
	 XIL3(j) = XIL1(j)*xfac3
	else if (j.eq.2) then
     	Xfac3 = 1.0d0/(2.0d0*xk*betanew*dengy(2)**3)  
	 XIL3(j) = XIL1(j)*xfac3
	else if (j.eq.3) then
     	Xfac3 = 1.0d0/(2.0d0*xk*betanew*dengy(3)**3)  
	 XIL3(j) = XIL1(j)*xfac3
	endif
52	continue

       return
        end 

        Subroutine XINTLC2(NAKT,CDSP,
     >                    Dengy,Beta,AVAL,Z,XIL5,XIL6,
     >                    XIL1,XIL2,XIL3,XIL4,XTAU,soucp,capcp)

CB Berechnung fuer CII:
C-------------------------------------------------------------
C
C	parameter: nlevel,ngri,trapez
C       Input:  NAKT,CDSP,Dengy,BETA,AVAL,Z
C       Output: XINTL,XINTR
C       NAKT   = number of grid points
C       AVAL   = A-values(CIA ...)
C       Dengy  = excitation energy(CIE ...) in v/c
C       Beta   = line width
CB       Betanew = Beta*sqrt(pi), aequivalente Linienbreite
C       CDSP   = Density (CD12CO bzw. CD13CO)
C       XIL1   = Line integrated intensities
C       XIL3   = Brightness temperature for line 
C                integrated intensities
C       XIL2   = Intensity in Line center (left side,
C                source side)
C       XIL4   = Brightness temperature for line center
C       XIL5   = Line Intensity for line center at each grid-point
C       XIL6   = Brightness temperature for line center at each grid-poin
C       Z      = Grid points(ZPGR)
CB      freq   = frequenz - freqnull in (v/c), d.h. delta(frequenz)
CB      freqnull = Uebergangsfrequenz des jeweiligen Uebergangs
CB      deltafreq = Aequivalentbreite in v/c  
CB      help1   = Profilfunktion(freq) (line shape function)
CB      help2,3 =  freqnull +/- freq, d.h. tatsaechliche Frequenz
CB	help4 = intensity at level i and frequenz help2(i,n)
CB	STAT = statistisches Gewicht des levels
CB
CB
C 
C-------------------------------------------------------------




 	IMPLICIT DOUBLE PRECISION (A-H,O-Z)

        integer  trapez
	Parameter(NLHT=15)
        Parameter(NMAX1=800)
        Parameter(NPAR=416)
        Parameter (NGRI=500)
        parameter (trapez = 300)
         Dimension 
     >       CDSP(NGRI,2),Z(NAKT),xtau1(1,trapez),
     >       XKAP(NGRI,NGRI),SOU1(NGRI,NGRI),XTAU(NGRI),
     >       HELP4(1,trapez),XIL1(NGRI),XIL2(NGRI),	
     >       XIL3(NGRI),XIL4(NGRI),XKAP2(NGRI,NGRI),
     >       SOU2(NGRI,NGRI),SOU3(NGRI,NGRI),help2(1,trapez),
     >       help3(1,trapez),XIL5(NGRI),XIL6(NGRI),
     >       soucp(ngri), capcp(ngri)


        clight = 2.997929d10
        xh     = 6.6252d-27   
        xk     = 1.380622d-16 
	pi = 3.141592654d0
	betanew = beta*sqrt(pi)
CB	beta = betanew
CB	betanew = beta

	hell2 = 0.0d0

        Do 10 i = 1 , ngri 
	  XTAU(I)  = 0.0d0
          XIL1(i)  = 0.0d0
          XIL2(i)  = 0.0d0
          XIL3(i)  = 0.0d0
          XIL4(i)  = 0.0d0 
          XIL5(i)  = 0.0d0
          XIL6(i)  = 0.0d0 
10      continue  

		do 5 j = 1,trapez
		 xtau1(1,j) = 0.0d0
	         help4(1,j) = 0.0d0
		 help2(1,j) = 0.0d0
5		continue

         Do 11 j = 1 , NAKT
C         Compute transition opacities.
 	    FAC = 25.1327D0*BETA*Dengy**3.D0
	    WR  = 2.0d0
	    XKAP(j,1) = (WR*CDSP(j,1)-CDSP(j,2))*AVAL/FAC

            IF(XKAP(j,1).lt.0.0d0) XKAP(j,1)=0.0d0
CB	    write(*,*) 'xkap(',j,'1) =',xkap(j,1)
CB	    write(*,*) 'fac =',fac
11        continue
        Do 13 j = 1 , NAKT
C         Compute transition opacities.
	   deltafreq = (betanew/1.0d0)*dengy
	    FAC2 = 25.1327D0*deltafreq*dengy**2.D0
	    WR2  = 2.0d0
	    XKAP2(j,1) = (WR2*CDSP(j,1)-CDSP(j,2))*AVAL/FAC2

            IF(XKAP2(j,1).lt.0.0d0) XKAP2(j,1)=0.0d0
13        continue

           Do 20 j = 1 , NAKT

CB 14.10.1992    Compute line integrated intensity:

CB 12.10.1992       Compute profilfunction:

	    freqnull = dengy
	        do 34 n = 1,trapez
		   deltafreq = (betanew/clight)*freqnull
CB		   write(*,*) 'deltafreq = ',deltafreq
CB	           write(*,*) 'n =',n
                   freq = deltafreq/(n/10.0d0)
	        if (n.eq.trapez) then
	           freq = 0.0d0
	        endif
	              help1 = profil(freq,deltafreq)
                      help2(1,n) = (freqnull - freq) 
                      help3(1,n) = (freqnull + freq)
CB       Compute source functions:
            xpl = CDSP(j,1)/0.5d0
            xpu = CDSP(j,2)/1.0d0
            x1  = 2.0d0*clight*XH*(help2(1,n))**3.0d0
            x2  = XPL-XPU
            IF(X2.gt.1.0d-12) then 
              Sou3(j,1) = x1*XPU/(XPL-XPU)
            Else
              Sou3(j,1) = 0.0d0
	    Endif  
CB       Compute optical depths and line (integrated) intensity:
          IF(J.gt.1) then
              dz      = z(j)-z(j-1)
CB	     write(*,*) 'profilf(',n,') =',help1

              dtau1    = dz*help1*(XKAP2(J-1,1)+XKAP2(J,1))/2.0d0
              XTAUOLD = XTAU1(1,n)
              XTAU1(1,n) = XTAU1(1,n)+dtau1
CB       	write (14,*) 'sou3(j,1)=',sou3(j,1) 
CB       	write (14,*) 'xtau1(1,n)=',xtau1(1,n) 
CB       	write (14,*) 'dtau1=',dtau 
CB       	write (14,*) 'help2(1,n-1)=',help2(1,n-1) 	
CB hier geht,s los:
	     help4(1,n)  = ((Sou3(j,1)*expc2(-Xtau1(1,n))+
     >                         Sou3(j-1,1)*expc2(-Xtauold))*
     >                         dtau1/2.0d0)*(help2(1,n)
     >                         -help2(1,n-1))*clight 
	
	endif

34	        continue
	
CB   Aufsummieren der linienintegrierten Intensitaet :  
	do 35 n = 1,trapez
	  xil1(1) = xil1(1) + 2*help4(1,n)
35	continue
cm	write(14,*) 'xil1(1)=',xil1(1)
C           Compute source functions
            xpl = CDSP(j,1)/0.5d0
            xpu = CDSP(j,2)/1.0d0
            x1  = 2.0d0*clight*XH*dengy**3.0d0
            x2  = XPL-XPU

CB           Compute 'source function' for line integrated
CB           Intensities (using escape probabilities) 
CB            Sou2(j,1) = CDSP(j,i+1)*Aval*
CB     >                  xh*clight*Dengy/6.282d0 

C           Calculate source function in line center            
            IF(X2.gt.1.0d-12) then 
              Sou1(j,1) = x1*XPU/(XPL-XPU)
            Else
              Sou1(j,1) = 0.0d0
	endif
CB	  write(*,*) 'sou1(',j,'1) =',sou1(j,1)  
30        CONTINUE
41         continue	
          IF(J.gt.1) then
C             Compute optical depths
              dz      = z(j)-z(j-1)
              dtau    = dz*(XKAP(J-1,1)+XKAP(J,1))/2.0d0
              XTAUOLD = XTAU(1)
              XTAU(1) = XTAU(1)+dtau
              
CB new output, 25.10.1996, sou*.dat, cap*.dat
             soucp(j) = sou1(j,1)
             capcp(j) = xkap(j,1)

C             Compute line intensities on surface (Trapez-rule)
	      xilhelp = xil2(1)	
              Xil2(1) = Xil2(1)+(Sou1(j,1)*expc2(-Xtau(1))+
     >                         Sou1(j-1,1)*expc2(-Xtauold))*
     >                         dtau/2.0d0
             XIL5(J) = (XIL2(1)-xilhelp)/dz

CB              Xil1(i) = Xil1(i)+(Sou2(j,i)*besc(Xtau(i))+
CB     >                           Sou2(j-1,i)*besc(XTAUOLD))*
CB     >                           dz/2.0d0 

         Endif
20      continue

CB         Calculate Brightness temperature for line integrated
CB         Intensities
CB          xfac1   = 1.0d0/(2.0d0*xk*beta*(
CB     >              dengy)**3)  
CB          XIL3(i) = XIL1(i)*xfac1 

C         Calculate Brightness temperatures for line center 
          xfac2   = 1.0d0/(2.0d0*xk*dengy**2) 
          XIL4(1) = XIL2(1)*xfac2 
CB	write(*,*) 'xil4(1) =',xil4(1)
50	continue
CB	do 56 j = 1,ngri
CB          xfac2   = 1.0d0/(2.0d0*xk*(dengy)**2) 
CB          xil6(j) = xil5(j)*xfac2
CB56	continue
CB Berechnung der Helligkeitstemperatur fuer linienintegrierte Intensitaet
     	Xfac3 = 1.0d0/(2.0d0*xk*betanew*dengy**3)  
	 XIL3(1) = XIL1(1)*xfac3
       return
        end 



















CB 13.10.1992

	FUNCTION profil(freq,deltafreq) 

CB  freq = Frequenzstelle
CB  freqnull = Uebergangsfrequenz
CB  deltafreq = Aequivalentbreite ( = sqrt(pi)*beta





        IMPLICIT DOUBLE PRECISION (A-H,O-Z)

	pi = 3.141592654d0
        clight = 2.997929d10

	if (deltafreq.gt.0.0d0) then	
	profil = dexp(-pi*(freq /deltafreq)**2)
	else
	write(*,*) 'deltafreq nicht groesser als Null!! siehe profil !'
	endif

	return
	end


