
C         Program controls Output of PDR program
C
C         H. Stoerzer 23.6.94
C
 
          IMPLICIT DOUBLE PRECISION (A-H,O-Z)

          Double Precision cdd(381),cd(381),av,xhcrat(20) 
          Integer Indx(10),Indxcool(10),Indxheat(10)

C         Density In/Out 
          OPEN(101,file='pdrdensav.out',STATUS='OLD')
          OPEN(102,file='pdrdenszg.out',STATUS='OLD')
          OPEN(21,file='densityav.dat',STATUS='new')
          OPEN(22,file='densityzg.dat',STATUS='new')

C         ColumnDensity In/Out
          OPEN(103,file='pdrcoldensav.out',STATUS='OLD')  
          OPEN(104,file='pdrcoldenszg.out',STATUS='OLD')  
          OPEN(23,file='coldensav.dat',STATUS='new')
          OPEN(24,file='coldenszg.dat',STATUS='new')

C         Heating/Cooling In/Out
          OPEN(105,file='heatcoolav.out',STATUS='OLD')
          OPEN(106,file='heatcoolzg.out',STATUS='OLD')
          OPEN(25,file='heatav.dat',STATUS='new')
          OPEN(26,file='heatzg.dat',STATUS='new')
          OPEN(27,file='coolav.dat',STATUS='new')
          OPEN(28,file='coolzg.dat',STATUS='new')

C         Temperature In/Out
          OPEN(107,file='tgastdustav.out',STATUS='OLD')
          OPEN(108,file='tgastdustzg.out',STATUS='OLD')
          OPEN(29,file='tav.dat',STATUS='new')
          OPEN(30,file='tzg.dat',STATUS='new')

          open(99,file='coldens.ratio')
 
C         Pointer for Density and Column Density 
C         Output Control (max 10) (see PDR Manual
C         for relation between index and species)
         
          Indx(1) = 19
          Indx(2) = 29
          indx(3) = 41
          indx(4) = 20                   
          Nindx   = 4


C         Density

C         Density (as function of av)
          NR=0
          Do i=1,1000
            NR = NR+1
            Read(101,4001,END=150) av,(cdd(k),k=1,381)
c            Write(21,110) av,
c     >                   (dlog10(cdd(indx(k))+1.0D-50),k=1,Nindx)


c   hier hab ich mit den haeufigkeiten multipliziert
c            write(21,110) av,dlog10(cdd(41)),dlog10(cdd(59)*66),
c     >                   dlog10(cdd(327)*500),dlog10(cdd(339)*500*66)


          Enddo
          Write(*,*) 'Error: Number of grid points larger than 1000'
          stop 
150       continue

C         Density (as function of zg)
          NR=0
          Do i=1,1000
            NR = NR+1
            Read(102,4001,END=250) zg,(cdd(k),k=1,381)
           Write(22,110) zg,
     >                   (dlog10(cdd(indx(k))+1.0D-50),k=1,Nindx)

c            write(22,110) zg,dlog10(cdd(41)),dlog10(cdd(59)*66.0d0),
c     >                   dlog10(cdd(327)*500),dlog10(cdd(339)*500.0d0
c     >                                                *66.0d0)

c       test - ratio
c            write(22,110) zg,(cdd(41))/(cdd(59))




          Enddo
          Write(*,*) 'Error: Number of grid points larger than 1000'
          stop 
250       continue


C         Column Density

C         Column density (as function of av)
          NR=0
          Do i=1,1000
            NR = NR+1
            Read(103,4001,END=350) av,(cd(k),k=1,381)
            Write(23,110) av,
     >                   (dlog10(cd(indx(k))+1.0D-50),k=1,Nindx)


c       test - coldensratio
            write(99,110) av,(cd(41))/(cd(59))

          Enddo
350       continue

C         Column density (as function of zg)
          NR=0
          Do i=1,1000
            NR = NR+1
            Read(104,4001,END=450) zg,(cd(k),k=1,381)
            Write(24,110) zg,
     >                   (dlog10(cd(indx(k))+1.0D-50),k=1,Nindx)
          Enddo
450       continue


C         Gas- and Dust-Temperature 
          NR=0
          Do i=1,1000
            NR = NR+1
            Read(107,4003,END=550) av,Tgas,Tdust 
            Read(108,4003,END=550) zg,Tgas1,Tdust1 
            Write(29,120) av,Tgas,Tdust  
            Write(30,120) zg,Tgas,Tdust   
            Write(*,120)  av,Tgas,Tdust  
            Write(*,120)  zg,Tgas,Tdust   
          Enddo
550       continue





C         Pointer for Cooling rates 
C         Output Control (max 10) (see PDR Manual
C         for relation between index and coolant)
          Indxcool(1) = 19 
          Indxcool(2) = 4
          Nindx = 2

          Do i=1,1000
            NR = NR+1
            Read(105,4002,END=650) av,(xhcrat(k),k=1,20)
            Write(27,120) av,
     >      (dlog10(abs(xhcrat(indxcool(k))+1.0D-50)),k=1,Nindx)
          Enddo
650       Continue

          Do i=1,1000
            NR = NR+1
            Read(106,4002,END=750) zg,(xhcrat(k),k=1,20)
            Write(28,120) zg,
     >      (dlog10(abs(xhcrat(indxcool(k))+1.0D-50)),k=1,Nindx)
          Enddo
750       Continue

          Rewind 105
          Rewind 106
 
C         Pointer for Heating rates 
C         Output Control (max 10) (see PDR Manual
C         for relation between index and heating process)
          Indxheat(1) = 1 
          Indxheat(2) = 2 
          Indxheat(3) = 3 
          Indxheat(4) = 7 
          Indxheat(5) = 8
          Nindx = 5

          Do i=1,1000
            NR = NR+1
            Read(105,4002,END=850) av,(xhcrat(k),k=1,20)
            Write(25,120) av,
     >      (dlog10(abs(xhcrat(indxheat(k))+1.0D-50)),k=1,Nindx)
          Enddo
850       Continue

          Do i=1,1000
            NR = NR+1
            Read(106,4002,END=950) zg,(xhcrat(k),k=1,20)
            Write(26,120) zg,
     >      (dlog10(abs(xhcrat(indxheat(k))+1.0D-50)),k=1,Nindx)
          Enddo
950       Continue
 
 
110       Format(11(E12.5))
120       Format(11(E12.5))
4001      Format(311(E12.5))
4002      Format(21(E12.5))
4003      Format(3(E12.5))
4004      Format(20(E12.5))
          END 
  
 
